#include <iostream>
#include <vector>
#include <queue>
#include <map>
#include <cstring>
using namespace std;
int n, q;
int a[100005], maxc;
map <int, int> m;
struct edge
{
    int ver, w;
};
vector <edge> v[100005];
void read()
{
    cin >> n >> q;
    int ui, vi, wi;
    for(int i = 1; i < n; i++)
    {
        cin >> ui >> vi >> wi;
        v[ui].push_back({vi, wi});
        v[vi].push_back({ui, wi});
        if(wi > maxc)maxc = wi;
    }
}
int used[100005];
long long sum;
void BFS(int beg)
{
    queue <int> q;
    q.push(beg);
    used[beg] = 1;
    while(!q.empty())
    {
        int ver = q.front();
        q.pop();
        for(int i = 0; i < v[ver].size(); i++)
        {
            if(!used[v[ver][i].ver])
            {
                a[v[ver][i].ver] = max(a[ver], v[ver][i].w);
                if(v[ver][i].ver > beg)
                    m[v[ver][i].ver] ++;
                    ///cout << beg << " " << v[ver][i].ver << " " << a[v[ver][i].ver] << " " << sum << endl;}
                    ///cout << beg << " " << ver << " " << v[ver][i].ver << " " << a[beg][ver] << " " << v[ver][i].w << endl;
                    q.push(v[ver][i].ver);
                    used[v[ver][i].ver] = 1;
            }
        }
    }
}
void fill_a()
{
    for(int i = 1; i <= n; i++)
    {
        memset(used, 0, sizeof(used));
        memset(a, 0, sizeof(a));
        BFS(i);
    }
}

/*void fill_m()
{
    for(int i = 1; i < n; i++)
    {
        for(int j = i+1; j <= n; j++)
        {
            ///cout << i << " " << j << " " << a[i][j] << endl;
            m[a[i][j]]++;
        }
    }
}*/
map <int, int> m1;
void fill_m1()
{
    for(int i = 1; i <= maxc; i++)
        m1[i] = m1[i-1] + m[i]*i;
}
void query(int l, int r)
{
    cout << m1[r] << endl;
}
void solve()
{
    int l, r;
    if(q == 1)
    {
        cin >> l >> r;
        cout << sum << endl;
        return;
    }
    for(int i = 1; i <= q; i++)
    {
        cin >> l >> r;
        query(l, r);
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    fill_a();
    ///fill_m();
    solve();
    return 0;
}
