#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
using ll = long long;

const int Q_max = 1e5 + 1;

int Q;
int X[Q_max], Y[Q_max];

void solve23()
{
    for (int i = 1; i <= Q; i++)
    {
        cout << max(X[i], Y[i]) - 1 << " ";
    }

    cout << endl;

    if (X[1] < Y[1])
    {
        for (int i = 1; i < max(X[1], Y[1]); i++)
        {
            cout << 1 << " ";
        }
    }
    else
    {
        for (int i = 1; i < max(X[1], Y[1]); i++)
        {
            cout << -1 << " ";
        }
    }

    cout << endl;
}

void solve6()
{
    for (int i = 1; i <= Q; i++)
    {
        cout << max(X[i], Y[i]) << " ";
    }

    cout << endl;

    if (X[1] < Y[1])
    {
        for (int i = 1; i < X[1]; i++)
        {
            cout << -2 << " ";
        }

        cout << 2 * X[1] - 2 + 1 << " ";
        cout << -2 << endl;
    }
    else
    {
        for (int i = 1; i < Y[1]; i++)
        {
            cout << 2 << " ";
        }

        cout << -(2 * Y[1] - 2 + 1) << " ";
        cout << 2 << endl;
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> Q;

    bool isSubtask23 = 1;
    bool isSubtask6 = 1;

    for (int i = 1; i <= Q; i++)
    {
        cin >> X[i] >> Y[i];

        if (!(X[i] % Y[i] == 0 || Y[i] % X[i] == 0))
        {
            isSubtask23 = 0;
        }

        if (abs(X[i] - Y[i]) != 1)
        {
            isSubtask6 = 0;
        }
    }

    if (isSubtask23)
    {
        solve23();

        return 0;
    }

    if (isSubtask6)
    {
        solve6();

        return 0;
    }

    return 0;
}
