#include <bits/stdc++.h>
#define DEFAULT 1e9
using namespace std;

int s[400001];
int segment[1600001];

int build(int idx, int l, int r) {
    if (l == r) return segment[idx] = s[l];
    int m = (l + r) / 2;

    return segment[idx] = min(build(2 * idx, l, m), build(2 * idx + 1, m + 1, r));
}

int get(int idx, int l, int r, int ql, int qr) {
    if (qr < l || r < ql) return DEFAULT;
    if (ql <= l && r <= qr) return segment[idx];
    int m = (l + r) / 2;

    return min(get(2 * idx, l, m, ql, qr), get(2 * idx + 1, m + 1, r, ql, qr));
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, q, g;
    cin >> n >> q >> g;

    string str;
    cin >> str;

    for (int i = 0; i < str.size(); i++) {
        s[i + 1] = s[i] + (str[i] == '(' ? 1 : -1);
    }

    build(1, 1, 2 * n);

    for (int i = 0; i < q; i++) {
        int l, r;
        cin >> l >> r;

        int val = get(1, 1, 2 * n, l, r) - s[l - 1];
        cout << (int) ceil(-(val / 2.0)) << '\n';
    }

    return 0;

}
