#include <bits/stdc++.h>
using namespace std;

int N, Q, G;
string S;

void FastEJOI()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> Q >> G;
    cin >> S;
}

int Query(int left, int right)
{
    stack<char> St;

    for(int i = left; i <= right; i++)
    {
        if(S[i] =='(')
        {
            St.push('(');
        }
        else
        {
            if(!St.empty() && St.top() == '(')
            {
                St.pop();
            }
            else
            {
                St.push(')');
            }
        }
    }

    int Size = (int)St.size();
    int Ans = Size / 4;

    if(Size % 4 != 0)
    {
        Ans++;
    }

    return Ans;
}

void Solve()
{
     while(Q--)
     {
         int left, right; cin >> left >> right;
         left--;
         right--;
         cout << Query(left, right) << '\n';
     }
}

int main()
{
    FastEJOI();
    Read();
    Solve();
    return 0;
}
