#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e6 + 1;
int N, Q, G;
string S;
int Prefix[MAXN];
int Active[MAXN];
vector<pair<int, int>> Points;

void FastEJOI()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> Q >> G;
    cin >> S;

    stack<int> St;

    for(int i = 0; i < (int)S.size(); i++)
    {
        if(S[i] =='(')
        {
            St.push(i);
            Prefix[i + 1]++;
        }
        else
        {
            if(!St.empty() && S[St.top()] == '(')
            {
                Points.push_back({St.top() + 1, 0});
                Points.push_back({i + 1, 1});
                Prefix[i + 1]--;
                St.pop();
            }
            else
            {
                St.push(i);
            }
        }
    }

    for(int i = 1; i <= (int)S.size(); i++)
    {
        Points.push_back({i, 2});
    }

    sort(Points.begin(), Points.end());

    int Open = 0, Close = 0;

    for(int i = 0; i < Points.size(); i++)
    {
        if(Points[i].second == 0)
        {
            Open++;
        }
        else if(Points[i].second == 1)
        {
            Open--;
        }
        else
        {
            Active[Points[i].first] = Open;
        }
    }

    for(int i = 1; i <= (int)S.size(); i++)
    {
        Prefix[i] += Prefix[i - 1];
    }
}

int Query(int left, int right)
{
    int Size = Prefix[right] - Prefix[left - 1];
    int Ans = Size / 2;

    if(Size % 2 != 0)
    {
        Ans++;
    }

    return Ans;
}

void Solve()
{
     while(Q--)
     {
         int left, right; cin >> left >> right;
         cout << Query(left, right) << '\n';
     }
}

int main()
{
    FastEJOI();
    Read();
    Solve();
    return 0;
}
