#include<bits/stdc++.h>
using namespace std;

#define endl '\n'
#define out(x) #x << " = " << x << " "

const int INF = 1e9 + 10;
const int MAX_N = 4 * 1e5 + 10;

int n, q, g, l, r;
string s = "";
string s_;
int prv[MAX_N];

bool isOk (const string& s) {
    int cnt = 0;
    for (int i = 0; i < s.size(); i ++) {
        if (s[i] == '(') cnt ++;
        else cnt --;

        if (cnt < 0) return false;
    }
    return true;
}

int ans = INF;
void solve (string& s, int depth) {
    if (isOk(s)) {
        ans = min (ans, depth);
    }
    if (depth > 5) return;

    for (int l = 0; l < s.size(); l ++) {
        for (int r = l + 1; r < s.size(); r ++) {
            if (s[l] == s[r]) continue;

            swap(s[l], s[r]);
            solve(s, depth + 1);
            swap(s[l], s[r]);
        }
    }

}
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);


    cin >> n >> q >> g;
    cin >> s_;

    solve(s_, 0);

    cout << ans << endl;

    return 0;
}

/*
1 1 1
))(()(()

1 1 1
)(

1 1 1
)))(()(()

1 1 1
)(()((

1 1 1
(()

1 1 1
)(()(()

1 1 1
)

1 1 1
(()(

1 1 1
((

1 1 1
)(()

*/
