#include<bits/stdc++.h>
using namespace std;

#define endl '\n'
#define out(x) #x << " = " << x << " "
#define cerr if(false) cerr
const int INF = 1e9 + 10;
const int MAX_N = 1e5 + 10;

int q;
vector <int> seq;

int ans = -1;
vector <int> longest;

void tb (int x) {
    for (int i = 0; i < x; i ++) cerr << "\t";
}

void solve (int n, int x, int y, bool needSeq) {
    tb(n); cerr << "In for " << out(n) << out(x) << out(y) << out(needSeq) << endl;
    tb(n); cerr << "Seq: ";
    ///for (int i = 0; i < seq.size(); i ++) {
    ///    cerr << seq[i] << " ";
    ///}
    ///cerr << endl;
    if (n >= x) {
        int sx = 0;
        for (int i = n - x; i <= n - 1; i ++) {
            sx += seq[i];
        }
        if (sx <= 0) return;
    }

    if (n >= y) {
        int sy = 0;
        for (int i = n - y; i <= n - 1; i ++) {
            sy += seq[i];
        }
        if (sy >= 0) return;
    }
    tb(n); cerr << "Check over - OK" << endl;

    if (ans < n) {
        ans = n;
        if (needSeq) {
            longest.clear();
            for (int i = 0; i < seq.size(); i ++) {
                longest.push_back(seq[i]);
            }
        }

        tb(n); cerr << "New Answer = " << ans << endl;
    }

    int minValue = -10;
    int maxValue = 10;


    if (n >= x - 1) {
        int sumX = 0;
        for (int i = max(n - x + 1, 0); i < n; i ++) {
            sumX += seq[i];
        }

        if (sumX <= 0) {
            minValue = abs(sumX) + 1;
        } else {
            minValue = -(sumX - 1);
        }
    }

    if (n >= y - 1) {
        int sumY = 0;
        for (int i = max(n - y + 1, 0); i < n; i ++) {
            sumY += seq[i];
        }

        if (sumY < 0) {
            maxValue = abs(sumY) - 1;
        } else {
            maxValue = -sumY - 1;
        }
    }

    tb(n); cerr << out(minValue) << out(maxValue) << out(n) << endl << endl;

    int real = (minValue + maxValue) / 2;
    for (int offset = 0; real - offset >= minValue || real + offset <= maxValue; offset ++) {
        seq.push_back(real - offset);
        solve(n + 1, x, y, needSeq);
        seq.pop_back();

        seq.push_back(real + offset);
        tb(n); cerr << "Trying " << n + 1 << endl;
        solve(n + 1, x, y, needSeq);
        seq.pop_back();
    }


}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> q;

    for (int i = 0; i < q; i ++) {
        int x, y;
        cin >> x >> y;
        solve(0, x, y, i == 0);
        cout << ans << " ";
        ans = -1;
    }

    cout << endl;
    for (int i = 0; i < longest.size(); i ++) {
        cout << longest[i] << " ";
    }



    return 0;
}


