#include<bits/stdc++.h>
using namespace std;
const long long MAXN=100009LL;
unordered_map<int,int> mas;
vector<pair<int,pair<int,int>>> reb;
long long father[MAXN];
long long siz[MAXN];

long long bin(long long a)
{
    return a*(a-1)/2;
}

long long Lead(int a)
{
    if(father[a]==a)return a;
    return father[a]=Lead(father[a]);
}

long long getSize(int a)
{
    if(Lead(a)!=a)return getSize(Lead(a));
    return siz[a];
}

bool sameSet(int a,int b)
{
    return Lead(a)==Lead(b);
}

void Union(int a,int b)
{
    siz[Lead(a)]+=getSize(b);
    father[Lead(b)]=Lead(a);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int N,Q,curr=0,a,b,c,ans=0;
    for(int i=0;i<MAXN;i++)
    {
        siz[i]=1;
        father[i]=i;
    }
    cin>>N>>Q;
    for(int i=0;i<N-1;i++)
    {
        cin>>a>>b>>c;
        reb.push_back({c,{a,b}});
    }
    sort(reb.begin(),reb.end());
    for(auto i:reb)
    {
        int k=curr;
        if(!sameSet(i.second.first,i.second.second))
        {
            k-=bin(getSize(i.second.first))+bin(getSize(i.second.second));
            Union(i.second.first,i.second.second);
            k+=bin(getSize(i.second.first));
        }
        mas[i.first]+=k-curr;
        ans+=(k-curr)*i.first;
        curr=k;
    }
    cin>>a>>b;
    cout<<ans<<endl;
    return 0;
}
