#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define all(v) v.begin(),v.end();

const int N = 1000+10;

vector<pair<int,ll>>adj[N];
int n, q;
ll mx[N];
unordered_map<ll, ll>m;
map<pair<int,int>, bool> used;
bool visited[N];

void dfs(int node, int gp, ll curr_mx)
{
    visited[node] = true;
    for(auto i : adj[node])
    {
        if(visited[i.first]) continue;
        mx[i.first] = max(curr_mx, i.second);
        int a = gp, b = i.first;
        if(a < b)
        {
            swap(a, b);
        }
        if(!used[{b, a}])
        {
            m[mx[i.first]]++;
            used[{b, a}] = true;
        }
        dfs(i.first, gp, mx[i.first]);
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    cin >> n >> q;
    m.reserve(4*N);
    for(int i = 1; i < n; i++)
    {
        int u, v, w;
        cin >> u >>v >> w;
        adj[u].push_back({v,w});
        adj[v].push_back({u,w});
    }
    for(int i = 1; i <= n; i++)
    {
        dfs(i, i, 0LL);
        memset(mx, 0, sizeof(mx));
        memset(visited,false,sizeof(visited));
    }
    ll ans = 0;
    for(auto i : m)
    {
        ans += i.first*i.second;
    }
    cout << ans << '\n';
    return 0;
}