#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define all(v) v.begin(),v.end();

const int N = 1005;

vector<pair<int,ll>>adj[N];
int n, q;
map<ll, ll>m;
ll mx[N];
map<pair<int,int>, bool> used;
bool visited[N];

void dfs(int node, int gp, ll curr_mx)
{
    visited[node] = true;
    for(auto i : adj[node])
    {
        if(visited[i.first]) continue;
        mx[i.first] = max(curr_mx, i.second);
        int a = gp, b = i.first;
        if(a < b)
        {
            swap(a, b);
        }
        if(!used[{b, a}])
        {
            m[mx[i.first]]++;
            used[{b, a}] = true;
        }
        dfs(i.first, gp, mx[i.first]);
    }
    mx[node] = 0;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    cin >> n >> q;
    for(int i = 1; i < n; i++)
    {
        int u, v, w;
        cin >> u >>v >> w;
        adj[u].push_back({v,w});
        adj[v].push_back({u,w});
    }
    for(int i = 1; i <= n; i++)
    {
        dfs(i, i, 0LL);
        memset(visited,false,sizeof(visited));
    }
    while(q--)
    {
        int l, r;
        cin >> l >> r;
        auto it = m.lower_bound(l);
        auto it2 = m.upper_bound(r);
        ll ans = 0;
        for(;it != it2; it++)
        {
            ans += ((*it).first)*((*it).second);
        }
        cout << ans << '\n';
    }
    return 0;
}