#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define INF 1000000000
struct DSU{
    int n;
    vector<ll> p;
    DSU(int si){
        n = si;
        p.assign(n, -1);
    }
    int fin(int u){
        if (p[u] < 0){
            return u;
        }
        p[u] = fin(p[u]);
        return p[u];
    }
    void merg(int u, int v){
        u = fin(u);
        v = fin(v);
        if (abs(p[u]) < abs(p[v])){
            swap(u, v);
        }
        p[u] += p[v];
        p[v] = u;
    }
};

int main(){
    vector<vector<ll>> v;
    ll ans = 0;
    int n, q, a, b, c, l, r;
    cin>>n>>q;
    DSU ds(n + 1);
    for (int i = 0; i < n - 1; i++){
        cin>>a>>b>>c;
        v.push_back({c, a, b});
    }
    sort(v.begin(), v.end());
    for (auto el : v){
        int u = ds.fin(el[1]), v = ds.fin(el[2]);
        ans += ds.p[u] * ds.p[v] * el[0];
        ds.merg(u, v);
    }
    cin>>l>>r;
    cout<<ans;
}