#include<bits/stdc++.h>
#define ll long long
#define ld long double
#define vl vector<ll>
#define vi vector<int>
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define pii pair<int, int>
#define pll pair<ll, ll>
#define f first
#define s second
#define pb push_back
#define p_b pop_back
using namespace std;
const ll sz = 4e5+5;
ll a[sz], cnt[sz];
pll segtree[4*sz];
void build(ll v, ll l, ll r)
{
    if(l == r)
        segtree[v] = {a[l], a[l]};
    else
    {
        ll mid = (l + r) / 2;
        build(2*v, l, mid);
        build(2*v+1, mid+1, r);
        segtree[v].f = min(segtree[2*v].f, segtree[2*v+1].f);
        segtree[v].s = max(segtree[2*v].f, segtree[2*v+1].s);
    }
}
pll findans(ll v, ll l, ll r, ll tl, ll tr)
{
    if(tl > tr)
        return {LLONG_MAX, LLONG_MIN};
    else    if(tl == l && r == tr)
        return segtree[v];
    else
    {
        ll mid = (l + r) / 2;
        pll lans, rans;
        lans = findans(2*v, l, mid, tl, min(mid, tr));
        rans = findans(2*v+1, mid+1, r, max(mid+1, tl), tr);
        return {min(lans.f, rans.f), max(lans.s, rans.s)};
    }
}
void solve()
{
    ll n, q, g, i;
    cin >> n >> q >> g;
    string s;
    cin >> s;
    if(g == 6)
    {
        n *= 2;
        s += '#';
        stack<ll>st;
        for(i = 1; i <= n; i++)
        {
            if(s[i-1] == ')')
            {
                cnt[i] = -1;
                if(st.size() == 0)
                    a[i] = -1;
                else
                {
                    ll x = st.top();
                    a[i] = x;
                    a[x] = i;
                    st.pop();
                }
            }
            else
            {
                a[i] = -1;
                st.push(i);
                cnt[i] = 1;
            }
            cnt[i] += cnt[i - 1];
        }
        build(1, 1, n);
        while(q--)
        {
            ll l, r;
            cin >> l >> r;
            if(cnt[r] - cnt[l - 1] == 0)
            {
                pll p1 = findans(1, 1, n, l, r);
                if(p1.f >= l && p1.f <= r && p1.s >= l && p1.s <= r)
                    cout << "0\n";
                else
                    cout << "1\n";
            }
            else
                cout << "1\n";
        }
        return;
    }
    while(q--)
    {
        ll l, r;
        cin >> l >> r;
        string str = "";
        for(i = l - 1; i < r; i++)
            str += s[i];
        stack<char>st;
        multiset<ll>ms1, ms2;
        for(i = 0; i < str.size(); i++)
        {
            if(str[i] == '(')
                ms1.insert(i);
            else
                ms2.insert(i);
        }
        ll cnt = 0;
        for(i = 0; i < str.size(); i++)
        {
            if(str[i] == ')')
            {
                if(st.size() == 0)
                {
                    auto iter = ms1.end();
                    iter--;
                    ms1.erase(*iter);
                    ms2.erase(i);
                    ms2.insert(*iter);
                    ms1.insert(i);
                    str[*iter] = ')';
                    str[i] = '(';
                    st.push(str[i]);
                    cnt++;
                }
                else
                    st.pop();
            }
            else
                st.push(s[i]);
        }
        cout << cnt << "\n";
    }
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll tests = 1;
    //cin >> tests;
    while(tests--)
    {
        solve();
    }
}
