#include<bits/stdc++.h>
#define ll long long
#define ld long double
#define vl vector<ll>
#define vi vector<int>
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define pii pair<int, int>
#define pll pair<ll, ll>
#define f first
#define s second
#define pb push_back
#define p_b pop_back
using namespace std;
const ll sz = 1e5+5;
vl g[sz];
ll usize[sz], par[sz];
void makeset(ll v)
{
    usize[v] = 1;
    par[v] = v;
}
ll findpar(ll v)
{
    if(par[v] == v)
        return v;
    return par[v] = findpar(par[v]);
}
pll unionsets(ll a, ll b)
{
    a = findpar(a);
    b = findpar(b);
    if(a != b)
    {
        if(usize[a] < usize[b])
            swap(a, b);
        par[b] = a;
        ll r = usize[a], d = usize[b];
        usize[a] += usize[b];
        usize[b] = usize[a];
        return {r, d};
    }
    return {0, 0};
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, q, i;
    cin >> n >> q;
    vector<pair<ll, pll>>edges;
    for(i = 0; i < n - 1; i++)
    {
        ll x, y, z;
        cin >> x >> y >> z;
        edges.pb({z, {x, y}});
    }
    for(i = 1; i <= n; i++)
        makeset(i);
    sort(all(edges));
    map<ll, ll>mp, pref;
    set<ll>st, st2;
    st.insert(0);
    st.insert(0x3F3F3F3F);
    for(i = 0; i < edges.size(); i++)
    {
        ll z = edges[i].f, x = edges[i].s.f, y = edges[i].s.s;
        pll p1 = unionsets(x, y);
        st.insert(z);
        mp[z] += (p1.f * p1.s);
    }
    ll last = -1;
    for(auto u : mp)
    {
        pref[u.f] = u.s * u.f;
        if(last != -1)
            pref[u.f] += pref[last];
        last = u.f;
    }
    while(q--)
    {
        ll l, r;
        cin >> l >> r;
        auto iter = st.lower_bound(r);
        if(*iter == r)
            r = *iter;
        else
        {
            iter--;
            r = *iter;
        }
        iter = st.lower_bound(l);
        iter--;
        l = *iter;
        cout << pref[r] - pref[l] << "\n";
    }
}
