#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define F first
#define S second
#define sz(x) int(x.size())
#define all(x) x.begin(),x.end()
int n, q, st;
string s;

struct node {
    int op, cnt;
} t[(1 << 19)], nd;

node merge(node lef, node ri) {
    return {
        ri.op + lef.op - min(lef.op, ri.cnt),
        lef.cnt+ri.cnt-min(lef.op, ri.cnt)
    };
}

void build(int l, int r, int x) {
    if (l == r) {
        if (s[l] == '(')t[x] = {1, 0};
        else t[x] = {0, 1};
        return;
    }
    int m = (l + r) >> 1;
    build(l, m, x*2+1);
    build(m+1, r, x*2+2);
    t[x] = merge(t[x*2+1], t[x*2+2]);
}

void get(int li, int ri, int x, int l, int r) {
    if (li >= l && ri <= r) {
        nd = merge(nd, t[x]);
        return;
    }
    if (li > r || ri < l)return;
    int m = (li + ri) >> 1;
    get(li, m, x*2+1, l, r);
    get(m+1, ri, x*2+2, l, r);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> q >> st;
    cin >> s;
    build(0, sz(s)-1, 0);
    while (q--) {
        int l, r;
        cin >> l >> r;
        --l, --r;
        nd = {0, 0};
        get(0, sz(s)-1, 0, l, r);
        cout << (nd.cnt + 1) / 2 << "\n";
    }
}