#include <iostream>
#include <vector>
#include <stack>

#define ll long long

using namespace std;

void fastIO() {
  ios_base::sync_with_stdio(false);
  cin.tie();
  cout.tie();
}

void setIO() {
  freopen("input.in", "r", stdin);
  freopen("output.out", "w", stdout);
}

int n, q, g;
string s;

void solve() {
  if (g == 6) {
    stack <char> st;
    vector <ll> pre(s.size() + 1, 0);
    ll cur = 0;
    for (int i = 0; i < s.size(); i++) {
      if (!(st.empty())) {
        if (s[i] == ')' && st.top() == '(')
          st.pop();
        else
          st.push(s[i]);
      } else {
        st.push(s[i]);
      }
      pre[i + 1] = st.size();
    }
    while (q--) {
      int l, r;
      cin >> l >> r;
      cout << (pre[r] - pre[l] + 1) / 2 << '\n';
    }
  }
}

int main() {

  setIO();
  fastIO();

  cin >> n >> q >> g;
  cin >> s;
  solve();
  return 0;
}