#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>

#define ll long long

using namespace std;

void fastIO() {
  ios_base::sync_with_stdio(false);
  cin.tie();
  cout.tie();
}

void setIO() {
  freopen("input.in", "r", stdin);
  freopen("output.out", "w", stdout);
}

int n, q, g;
string s;

bool dou(int i, int j, string& ss) {
  int sz = s.size();

  stack <char> st;
  swap(ss[i], ss[j]);
  for (int i = 0; i < n; i++) {
    if (!(st.empty())) {
      if (ss[i] == ')' && st.top() == '(')
        st.pop();
      else
        st.push(ss[i]);
    } else {
      st.push(ss[i]);
    }
  }
  ss = "";
  while (!st.empty()) {
    ss.push_back(st.top());
    st.pop();
  }
  reverse(ss.begin(), ss.end());
  return ((sz - s.size()) == 2);
}

void solve() {
  if (g == 6) {
    stack <char> st;
    vector <ll> pre(n + 1, 0);
    ll cur = 0;
    for (int i = 0; i < n; i++) {
      if (!(st.empty())) {
        if (s[i] == ')' && st.top() == '(')
          st.pop();
        else
          st.push(s[i]);
      } else {
        st.push(s[i]);
      }
      pre[i + 1] = st.size();
    }
    while (q--) {
      int l, r;
      cin >> l >> r;
      ll ans = (pre[r] - pre[l] + 1) / 2;
      if (ans > 1)
        ans -= 1;
      cout << ans << '\n';
    }
  } else if (g >= 1 && g <= 4) {
    int l, r;
    cin >> l >> r;
    string sub = s.substr(l - 1, r - l + 1);
    stack <char> st;
    for (int i = 0; i < n; i++) {
      if (!(st.empty())) {
        if (sub[i] == ')' && st.top() == '(')
          st.pop();
        else
          st.push(sub[i]);
      } else {
        st.push(sub[i]);
      }
    }
    int del = 0, sw = 0, sz = sub.size();
    for (int i = 0; i < sz - del; i++)
      for (int j = 0; j < sz - del; j++)
        if (i != j)
          if ((s[i] == '(' && s[j] == ')') || (s[i] == ')' && s[j] == '('))
            if (dou(i, j, sub))
              del += 2,
              sw++;
    cout << sw + (sub.size() / 2) << "\n";
  }
}

int main() {

  setIO();
  fastIO();

  cin >> n >> q >> g;
  cin >> s;
  solve();
  return 0;
}