#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define ss second 
#define ff first
#define mp make_pair
#define sz(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()
#define deb(x) cout << #x << " " << x << endl

const int inf = INT_MAX;
const int N = 2e3 + 5;

int n,Q,p[N],fix[N],out[N],in[N];
vector <vector<pair<int,int>>> v(N);
int a,b,w,timer;
vector <vector<int>> np(N);
queue <int> q;

int mx[N][N];
int lca[N][N];
int nlca;
int sum;

vector <int> ans;
int pref[N*N];

void dfs(int x) {
    fix[x] = 1;
    in[x] = ++timer;
    for (auto to:v[x]) {
        if (fix[to.ff]) continue;
        dfs(to.ff);
    }
    out[x] = ++timer;
}

bool ispar(int a,int b) {
    return (in[a] < in[b] && out[a] > out[b]);
}

inline void test_case() {

    cin >> n >> Q;
    for (int i = 1; i <= n-1; i++) {
        cin >> a >> b >> w;
        v[a].pb(mp(b,w));
        v[b].pb(mp(a,w));
    }
    q.push(1);
    fix[1] = 1;
    p[1] = 0;
    while (!q.empty()) {
        int f = q.front();
        q.pop();
        for (auto to: v[f]) {
            if (fix[to.ff]) continue;
            p[to.ff] = f;
            fix[to.ff] = 1;
            q.push(to.ff);
        }
    }
    for (int i = 2; i <= n; i++) {
        int cp = p[i];
        np[i].pb(cp);
        while (cp != 1) {
            cp = p[cp];
            np[i].pb(cp);
        }
    }
    timer = 0;
    for (int i = 1 ; i <= n; i++) {
        fix[i] = 0;
    }
    dfs(1);
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            fix[j] = 0;
        }
        q.push(i);
        fix[i] = 1;
        fix[p[i]] = 1;
        while (!q.empty()) {
            int f = q.front();
            q.pop();
            for (auto to: v[f]) {
                if (fix[to.ff]) continue;
                fix[to.ff] = 1;
                mx[i][to.ff] = max(mx[i][p[to.ff]],to.ss);
                mx[to.ff][i] = mx[i][to.ff];
                q.push(to.ff);
            }
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = i+1; j <= n; j++) {
            if (ispar(i,j)) {
                lca[i][j] = lca[j][i] = i;
                continue;
            }
            if (ispar(j,i)) {
                lca[i][j] = lca[j][i] = j;
                continue;
            }
            int l = 0; int r = sz(np[i])-1;
            while (l<=r) {
                int mid = (l+r)/2;
                if (ispar(np[i][mid],j)) {
                    r = mid - 1;
                    nlca = np[i][mid];
                } else {
                    l = mid + 1;
                }
            }
            lca[i][j] = nlca;
            lca[j][i] = lca[i][j];
        }
    }
    ans.pb(0);
    for (int i = 1; i <= n; i++) {
        for (int j = i+1; j <= n; j++) {
            sum += max(mx[i][lca[i][j]],mx[j][lca[i][j]]);
        }
    }
    int l; int r;
    cin >> l >> r;
    cout << sum << endl;
    
    
}

signed main () {

    ios :: sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    int T = 1;
    // cin >> T;
    while (T--) {
        test_case();
    }

    return 0;

}