#include <bits/stdc++.h>

using namespace std;
using ll = int;

struct Tree {
	struct Node {
		ll v, L, R;
		Node* l, * r;
		void merge() {
			if (!l) return;
			v = min(l->v, r->v);
		}
		Node() = default;
		Node(ll v, ll L, ll R, Node* l, Node* r): v(v), L(L), R(R), l(l), r(r) {
			if (v == -1) merge();
		}
	};

	Node* r;
	vector<ll> v;
	ll n;

	Node* build(ll L, ll R) {
		if (L + 1 == R) return new Node(v[L], L, R, nullptr, nullptr);
		return new Node(-1, L, R, build(L, (L + R) / 2), build((L + R) / 2, R));
	}

	Tree(vector<ll> v): v(v) {
		ll n = v.size();
		r = build(0, n);
	}

	ll get(Node* r, ll L, ll R) {
		if (R <= r->L || r->R <= L) return 1e9;
		if (L <= r->L && r->R <= R) return r->v;
		return min(get(r->l, L, R), get(r->r, L, R));
	}

	ll Get(ll L, ll R) {
		return get(r, L, R);
	}	
};

int main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(0);
	int n, q, g;
	cin >> n >> q >> g;
	n *= 2;
	vector<ll> v(n), pt(n);
	for (int i = 0; i < n; i++) {
		char x;
		cin >> x;
		v[i] = x == '(';
	}
	pt[0] = (v[0] ? 1 : -1);
	for (int i = 0; i < n; i++) {
		pt[i] = pt[i - 1];
		if (v[i]) {
			pt[i]++;
		} else {
			pt[i]--;
		}
	}

	Tree t(pt);

	for (int i = 0; i < q; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		cout << ( -t.Get(a, b) + (a > 0 ? pt[a - 1] : 0) + 1) / 2 << endl;
	}
}