#include <bits/stdc++.h>

using namespace std;
using int = int;

struct Tree {
	vector<int> W;
	vector<int> v;
	int n;

	void build(int x, int L, int R) {
		if (L + 1 == R) {
			W[x] = v[L];
			return;
		}
		build(x * 2 + 1, L, (L + R) / 2);
		build(x * 2 + 2, (L + R) / 2, R);
		W[x] = min(W[x * 2 + 1], W[x * 2 + 2]);
	}

	Tree(vector<int>& v): v(v) {
		n = v.size();
		W.resize(n * 4 + 100);
		build(0, 0, n);
		//for (int i: W) cout << i << " ";
	}

	int get(int x, int L, int R, int l, int r) {
		if (R <= l || r <= L) return 1e9;
		if (L <= l && r <= R) return W[x];
		int mid = (l + r) / 2;
		return min(get(x * 2 + 1, L, R, l, mid), get(x * 2 + 2, L, R, mid, r));
	}

	int Get(int L, int R) {
		return get(0, L, R, 0, n);
	}	
};

int main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(0);
	int n, q, g;
	cin >> n >> q >> g;
	n *= 2;
	vector<int> v(n), pt(n);
	for (int i = 0; i < n; i++) {
		char x;
		cin >> x;
		v[i] = x == '(';
	}
	pt[0] = (v[0] ? 1 : -1);
	for (int i = 0; i < n; i++) {
		pt[i] = pt[i - 1];
		if (v[i]) {
			pt[i]++;
		} else {
			pt[i]--;
		}
	}

	Tree t(pt);

	for (int i = 0; i < q; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		cout << ( -t.Get(a, b) + (a > 0 ? pt[a - 1] : 0) + 1) / 2 << endl;
	}
}