#include<bits/stdc++.h>

using namespace std;

#define int long long

#define all(x) x.begin(),x.end()

const int MAXN = (1e5)+31;

int p[MAXN];
int sz[MAXN];

int get_head(int v){
    if(p[v] == v) return v;
    else{
        p[v] = get_head(p[v]);
        return p[v];
    }
}

void merge(int a, int b){
    a = p[a];
    b = p[b];
    if(a == b) return;
    if(sz[a] < sz[b]) swap(a, b);
    sz[a] += sz[b];
    p[b] = a;
}

int get_sz(int v){
    return sz[get_head(v)];
}

int decompress[MAXN];

int m;

int pref[MAXN];

signed main(){
    //ios_base::sync_with_stdio(0);
    //cin.tie(0);
    int n, q;
    cin >> n >> q;
    for(int i = 0; i < n; i++) p[i] = i;
    for(int i = 0; i < n; i++) sz[i] = 1;
    vector<int> tmp;
    vector<pair<int, pair<int, int>>> edges;
    for(int i = 0; i < n-1; i++){
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        tmp.push_back(c);
        edges.push_back(make_pair(c, make_pair(a, b)));
    }
    sort(all(edges));
    sort(all(tmp));
    tmp.resize(unique(all(tmp)) - tmp.begin());
    m = tmp.size();
    for(int i = 0; i < m; i++){
        decompress[i] = tmp[i];
    }
    for(int i = 0; i < n-1; i++){
        int c = edges[i].first;
        c = lower_bound(all(tmp), c)-tmp.begin();
        edges[i].first = c;
        //cout << c << "\n";
        auto [a, b] = edges[i].second;
        pref[c] += get_sz(a)*get_sz(b);
        merge(a, b);
    }
    //return 0;
    pref[0] *= decompress[0];
    for(int i = 1; i < m; i++){
        pref[i]*=decompress[i];
        pref[i] += pref[i-1];
    }
    while(q--){
        int l, r;
        cin >> l >> r;
        l = lower_bound(all(tmp), l)-tmp.begin();
        r = upper_bound(all(tmp), r)-tmp.begin();
        r--;
        if(r<0 || r < l || l >= m){
            cout << "0\n";
            continue;
        }
        int ans = pref[r];
        if(l > 0) ans -= pref[l-1];
        cout << ans << "\n";
    }
}


