#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

#ifdef LOC
#define debug(x) cout<<#x<<" = "<<x<<'\n'
#else
#define debug(x)
#endif

void solve() {
    int n, q, pp;
    cin >> n >> q >> pp;
    n *= 2;
    vector<int> v(n);
    for (auto& i : v) {
        char ch;
        cin >> ch;
        if (ch == '(')
            i = 1;
        else
            i = -1;
    }
    vector<int> st;
    vector<int> p(n + 1, 0);
    vector<int> cr(n + 1, 0);
    vector<bool> h(n, 0);
    int d = 0;
    for (int i = n - 1; i >= 0; --i)
    {
        if (v[i] == -1) {
            d--;
        } else {
            if (d < 0) {
                d++;
            } else {
                h[i] = 1;
            }
        }
    }

    for (int i = 0; i < n; ++i)
    {
        p[i + 1] = p[i];
        if (v[i] == 1)
        {
            if (!h[i])
                st.push_back(i);
        }
        else
        {
            if (!st.empty())
            {
                p[i + 1]++;
                st.pop_back();
            }
        }

        cr[i + 1] = st.size();
    }

    for (int qq = 0; qq < q; ++qq)
    {
        int l, r;
        cin >> l >> r;
        l--;
        int m = p[r] - p[l] - cr[l];
        // debug(m);
        // debug(cr[l]);
        // debug(p[l]);
        // debug(p[r]);
        cout << ((r - l - m * 2) / 2 + 1) / 2 << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int q = 1;
#ifdef LOC
    cin >> q;
#endif
    for (int i = 0; i < q; ++i)
        solve();
}