#include <iostream>
#include<string>
#include<cmath>
#include<map>
#include<iomanip>
#include<algorithm>
#include<vector>
#include<set>
#include<cstdio>
#include<stack>
#include<ctime>
#include<queue>
#include<deque>
#include<bitset>
#include<random>
#include<fstream>
using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
ll gcd(ll a, ll b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}
ll lcm(ll a, ll b) {
    return a / gcd(a, b) * b;
}
const int N = 400001;
struct segtree {
    int t[N * 4];
    void build(int v, int l, int r, vector<int> &a) {
        if (r - l == 1) {
            t[v] = a[l];
            return;
        }
        int m = (l + r) >> 1;
        build(v * 2 + 1, l, m, a);
        build(v * 2 + 2, m, r, a);
        t[v] = min(t[v * 2 + 1], t[v * 2 + 2]);
    }
    segtree(vector<int>& a) {
        build(0, 0, a.size(), a);
    }
    int get(int v, int l, int r, int ql, int qr) {
        if (r <= ql || qr <= l) return 1e9;
        if (ql <= l && r <= qr) return t[v];
        int m = (l + r) >> 1;
        return min(get(v * 2 + 1, l, m, ql, qr), get(v * 2 + 2, m, r, ql, qr));
    }
};
//#include "twins.h"
int n, q, g;
string s;

void solve() {
    cin >> n >> q >> g >> s;
    vector<int> p(n * 2 + 1);
    int bal = 0;
    for (int i = 0; i < n * 2; ++i) {
        if (s[i] == '(') ++bal;
        else --bal;
        p[i + 1] = bal;
    }
    segtree t(p);
    while (q--) {
        int l, r;
        cin >> l >> r;
        ++r;
        cout << -(t.get(0, 0, n * 2 + 1, l, r) - p[l - 1] - 1) / 2 << '\n';
    }
}


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("coloring.in", "r", stdin);
    //freopen("coloring.out", "w", stdout);

    //ld time1 = clock();

    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
        cout.flush();
    }

    //ld time2 = clock();
    //cerr << "\n\nTIME: " << (time2 - time1) / CLOCKS_PER_SEC;
    return 0;
}