#include <iostream>
#include<string>
#include<cmath>
#include<map>
#include<iomanip>
#include<algorithm>
#include<vector>
#include<set>
#include<cstdio>
#include<stack>
#include<ctime>
#include<queue>
#include<deque>
#include<bitset>
#include<random>
#include<fstream>
using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
ll gcd(ll a, ll b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}
ll lcm(ll a, ll b) {
    return a / gcd(a, b) * b;
}

void solve() {
    int q;
    cin >> q;
    --q;
    int x, y;
    cin >> x >> y;
    vector<ll> ans;
    bool f = x > y;
    if (x > y) swap(x, y);
    
    if (y % x == 0) {
        ans.resize(y - 1);
        fill(ans.begin(), ans.begin() + y - 1, 1);
    }
    else {
        ans.resize(y + (y - 1) % x);
        ll a = 1e9;
        ll b = -a * (x - 1) + 1;
        for (int i = y - 1; i >= 0; i -= x) ans[i] = b;
        for (auto& i : ans) if (i != b) i = a;
    }

    if (f) {
        for (auto& i : ans) i *= -1;
    }
    cout << ans.size() << ' ';
    while (q--) {
        int x, y;
        cin >> x >> y;
        if (x > y) swap(x, y);
        if (y % x == 0) {
            cout << y - 1 << ' ';
            continue;
        }
        cout << y + (y - 1) % x << ' ';
    }
    cout << '\n';
    for (auto i : ans) cout << i << ' ';
}


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("coloring.in", "r", stdin);
    //freopen("coloring.out", "w", stdout);

    //ld time1 = clock();

    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
        cout.flush();
    }

    //ld time2 = clock();
    //cerr << "\n\nTIME: " << (time2 - time1) / CLOCKS_PER_SEC;
    return 0;
}