#include<iostream>
#include<vector>
#include<string>

using namespace std;

const int LOG = 20;

int main() {
	int n, q, g;
	cin >> n >> q >> g;
	string s;
	cin >> s;
	vector<int> bal(2 * n + 1);
	for (int i = 1; i <= 2 * n; i++) {
		if (s[i - 1] == '(') {
			bal[i] = bal[i - 1] + 1;
		} else {
			bal[i] = bal[i - 1] - 1;
		}
	}
	vector<vector<int>> sparse(LOG, vector<int> (2 * n + 1));
	sparse[0] = bal;
	for (int i = 1; i < LOG; i++) {
		for (int j = 0; j + (1 << i) <= 2 * n + 1; j++) {
			sparse[i][j] = min(sparse[i - 1][j], sparse[i - 1][j + (1 << (i - 1))]);
		}
	}
	vector<int> max2(4e5 + 10);
	for (int i = 2; i < 4e5 + 10; i++) {
		max2[i] = max2[i / 2] + 1;
	}
	while (q--) {
		int l, r;
		cin >> l >> r;
		r++;
		int h = max2[r - l];
		int minimum = min(sparse[h][l], sparse[h][r - (1 << h)]);
		minimum -= bal[l - 1];
		if (minimum >= 0) {
			cout << 0 << endl;
		} else {
			cout << 1 << endl;
		}
	}
}