#include<iostream>
#include<vector>
using namespace std;

vector<vector<pair<long long, long long>>> g;

long long dfs(long long v, long long p, long long l, long long r, long long mx) {
	if (mx > r) {
		return 0;
	}
	long long ans = 0;
	if (l <= mx) {
		//cout << v << " ";
		ans += mx;
	}
	for (auto &i : g[v]) {
		if (i.first == p) {
			continue;
		}
		ans += dfs(i.first, v, l, r, max(mx, i.second));
	}
	return ans;
}

int main() {
	long long n, q;
	cin >> n >> q;
	g.resize(n);
	for (long long i = 0; i < n - 1; i++) {
		long long u, v, w;
		cin >> u >> v >> w;
		u--;
		v--;
		g[u].push_back({v, w});
		g[v].push_back({u, w});
	}
	while (q--) {
		long long l, r;
		cin >> l >> r;
		long long ans = 0;
		for (long long i = 0; i < n; i++) {
			//cout << i << endl;
			ans += dfs(i, -1, l, r, 0);
			//cout << endl;
		}
		cout << ans / 2 << endl;
		//cout << endl;
	}
}