#include<iostream>
#include<vector>
#include<cmath>

using namespace std;

long long first_x = -1, first_y = -1;
vector<long long> prefsums = {0}, ans;
bool first_ret = false;

long long rec(long long x, long long y) {
	if (first_x == -1) {
		if (ans.size() < prefsums.size()) {
			ans = prefsums;
		}
	}
	long long len = prefsums.size() - 1;
	if (first_ret) {
		return len;
	}
	//cout << len << endl;
	for (long long i = -10; i <= 10; i++) {
		prefsums.push_back(i + prefsums.back());
		bool good = true;
		if (prefsums.size() > x) {
			long long summ = prefsums.back() - prefsums[prefsums.size() - x - 1];
			if (summ <= 0) {
				good = false;
			}
		}
		if (prefsums.size() > y) {
			long long summ = prefsums.back() - prefsums[prefsums.size() - y - 1];
			if (summ >= 0) {
				good = false;
			}
		}
		if (good) {
			len = max(len, rec(x, y));
			if (first_ret) {
				return len;
			}
		}
		prefsums.pop_back();
	}
	first_ret = true;
	return len;
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	long long q;
	cin >> q;
	bool first_less_5 = false;
	while (q--) {
		first_ret = false;
		long long x, y;
		cin >> x >> y;
		if (x <= 5 && y <= 5) {
			cout << rec(x, y) << " ";
			if (first_x == -1) {
				first_less_5 = true;
			}
		} else if (x % y == 0 || y % x == 0) {
			cout << max(x, y) - 1 << " ";
		} else {
			cout << max(x, y) * 2 - abs(x - y) * 2 - 1 << " ";
		}
		if (first_x == -1) {
			first_x = x;
			first_y = y;
		}
	}
	cout << endl;
	if (first_less_5) {
		vector<long long> answer;
		for (long long i = 1; i < ans.size(); i++) {
			answer.push_back(ans[i] - ans[i - 1]);
		}
		for (auto &i : answer) {
			cout << i << " ";
		}
		return 0;
	}
	if (first_x % first_y == 0 || first_y % first_x == 0) {
		if (first_x < first_y) {
			for (long long i = 0; i < first_y - 1; i++) {
				cout << 1 << " ";
			}
			cout << endl;
		} else {
			for (long long i = 0; i < first_x - 1; i++) {
				cout << -1 << " ";
			}
			cout << endl;
		}
	} else {
		if (first_x == first_y - 1) {
			long long summ = 1;
			cout << -3 << " ";
			summ += 3;
			for (long long i = 0; i < first_x - 2; i++) {
				cout << -2 << " ";
				summ += 2;
			}
			cout << summ << " ";
			cout << -3 << " ";
			for (long long i = 0; i < first_x - 2; i++) {
				cout << -2 << " ";
			}
			cout << endl;
		} else if (first_x == first_y + 1) {
			long long summ = -1;
			cout << 3 << " ";
			summ += -3;
			for (long long i = 0; i < first_y - 2; i++) {
				cout << 2 << " ";
				summ += -2;
			}
			cout << summ << " ";
			cout << 3 << " ";
			for (long long i = 0; i < first_y - 2; i++) {
				cout << 2 << " ";
			}
			cout << endl;
		}
	}
}