#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

#define f first
#define s second
#define pb push_back
#define pf push_front
#define in insert
#define it iterator
#define nl '\n'
//#define ordered_set tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update>

typedef long double ld;
typedef int64_t int64;
typedef uint64_t uint64;
typedef uint32_t uint;

using namespace std;
//using namespace __gnu_pbds;

struct tree{
    tree *L=NULL,
         *R=NULL;
    int l,r;
    int64 sum=0;
    tree(int l,int r): l(l),r(r){}
    void upd(int x){
        if (l==r){
            sum=int64(sum/l+1)*l;
            return;
        }
        int sr=(l+r)/2;
        if (x<=sr){
            if (L==NULL)
                L = new tree(l,sr);
            L->upd(x);
        }
        else{
            if (R==NULL)
                R = new tree(sr+1,r);
            R->upd(x);
        }
        sum=((L==NULL)?0LL:L->sum)+((R==NULL)?0LL:R->sum);
    }
    int64 get(int _l,int _r){
        if (_l <= l && r <= _r)
            return sum;
        int sr=(l+r)/2;
        int64 ans=0;
        if (_l<=sr)
            ans+=((L==NULL)?0LL:L->get(_l,_r));
        if (sr+1<=_r)
            ans+=((R==NULL)?0LL:R->get(_l,_r));
        return ans;
    }
};

tree tr(0,1e9);
vector <pair <int,int>> v[100000];

void dfs(int x,int pr,int mx){
    if (mx>0)
        tr.upd(mx);
    for (auto u : v[x])
        if (u.f!=pr)
            dfs(u.f,x,max(mx,u.s));
}

main(){
    cin.tie(0); ios_base::sync_with_stdio(0); cout.tie(0);
                iostream::sync_with_stdio(0);
    int n,q;
    cin >> n >> q;
    for (int i=1;i<n;i++){
        int x,y,z;
        cin >> x >> y >> z;
               x--; y--;
        v[x].pb({y,z});
        v[y].pb({x,z});
    }
    for (int i=0;i<n;i++)
        dfs(i,i,0);
    while (q--){
        int l,r;
        cin >> l >> r;
        cout << tr.get(l,r)/2 << nl;
    }
}
