#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int N = 1e5 + 2;
int p[N];
int get (int v) {
    return p[v] == v ? p[v] : p[v] = get (p[v]);
}
int sz[N];
map<int,ll> mp;
void uni (int u, int v, int w) {
    u = get (u), v = get (v);
    mp[w] += 1LL * sz[u] * sz[v] * w;
    p[u] = v;
    sz[v] += sz[u];
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, q;
    cin >> n >> q;
    vector<array<ll,3>> edg;
    for (int i = 1; i <= n; ++i) p[i] = i, sz[i] = 1;
    for (int i = 1; i < n; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        edg.push_back({w, u, v});
    }
    sort (begin (edg), end (edg));
    for (auto to : edg) {
        int u = to[1], v = to[2];
        int w = to[0];
        uni (u, v, w);
    }
    set<pair<int,ll>> st;
    ll S = 0;
    for (auto to : mp) {
        S += to.second;
        st.insert({to.first, S});
    }
    while (q--) {
        int l, r;
        cin >> l >> r;
        auto i1 = st.lower_bound({r + 1, -1e18});
        if (i1 == st.begin()) {
            cout << "0\n";
            continue;
        }
        --i1;
        auto i2 = st.lower_bound ({l, -1e18});
        ll dy = 0;
        if (i2 == st.begin()) {
            dy = 0;
        }
        else {
            --i2;
            dy = (*i2).second;
        }
        cout << (*i1).second - dy << "\n";
    }
    return 0;
}
