#include <bits/stdc++.h>
#define int long long
using namespace std;

vector < vector < pair < int, int > > > g(300009);

int dist[1009][1009];

void dfs(int firs, int v, int max1, int pred = -1) {
    dist[firs][v] = max(dist[firs][v], max1);
    for (auto u : g[v])
        if (u.first != pred) dfs(firs, u.first, max(max1, u.second), v);
}

void solve() {
    int n, q; cin >> n >> q;
    for (int i = 1; i <= n - 1; i++) {
        int u, v, w; cin >> u >> v >> w;
        g[u].push_back({v, w}), g[v].push_back({u, w});
    }

    for (int i = 1; i <= n; i++) dfs(i, i, 0);

//    for (int i = 1; i <= n; i++) {
//        for (int j = 1; j <= n; j++) cout << i << " " << j << " " << dist[i][j] << "\n";
//        cout << "\n";
//    }

    while (q--) {
        int l, r; cin >> l >> r;
        int ans = 0;
        map < int, int > mp; mp.clear();
        for (int i = 1; i <= n - 1; i++)
            for (int j = i + 1; j <= n; j++)
                if (dist[i][j] >= l && dist[i][j] <= r) mp[dist[i][j]]++;

        for (auto u : mp) ans += u.first * u.second;

        cout << ans << "\n";
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int q = 1; //cin >> q;
    while (q--) solve();
}
