#include <bits/stdc++.h>
#define int long long
using namespace std;

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, q;
    cin >> n >> q;
    if (q == 1) {
    vector<pair<int, int>> g[n + 2];
    struct edge {
        int u, v, w;
    };
    struct dsu {
        vector<int> parent, sz;
        void build(int N) {
            parent.assign(N + 5, 0);
            sz.assign(N + 5, 0);
            for (int i = 1; i <= N; ++i) {
                parent[i] = i;
                sz[i] = 1;
            }
            return;
        };
        int get(int v) {
            if (parent[v] == v) return v;
            return parent[v] = get(parent[v]);
        }
        void unite(int u, int v) {
            u = get(u);
            v = get(v);
            if (u == v) return;
            parent[u] = v;

            sz[v] += sz[u];
            sz[u] = 0;
            return;
        }
    };
    dsu T;
    T.build(n + 1);
    vector<edge> edges;
    map<int, vector<pair<int, int>>> mp;
    vector<int> weight;
    weight.push_back(-1);
    for (int i = 1; i < n; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
        mp[w].push_back({u, v});
        weight.push_back(w);
    }
    weight.push_back(1e9 + 9);
    sort(weight.begin(), weight.end());
    vector<int> ans(n + 5);
    for (auto i : mp) {
        int w = i.first;
        int now = 0;
        for (auto [u, v] : i.second) {
            int uu = T.sz[T.get(u)], vv = T.sz[T.get(v)];
            now += uu * vv * w;
            T.unite(u, v);
        }
        int pos = lower_bound(weight.begin(), weight.end(), w) - weight.begin();
        ans[pos] += now;
    }
    for (int i = 1; i <= n + 1; ++i) ans[i] = ans[i - 1] +ans[i];
    while (q--) {
        int l, r;
        cin >> l >> r;
        l = lower_bound(weight.begin(), weight.end(), l) - weight.begin();
        r = upper_bound(weight.begin(), weight.end(), r) - weight.begin() - 1;
        if (l <= r) {
            cout << ans[r] - ans[l - 1] << '\n';
        }
    }
    return 0;
    }
    vector<pair<int, int>> g[n + 2];
    vector<int> weight;
    for (int i = 1; i < n; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
        weight.push_back(w);
    }
    weight.push_back(-100);
    weight.push_back(1e9 + 9);
    vector<int> ans(n + 10);
    sort(weight.begin(), weight.end());
    weight.erase(unique(weight.begin(), weight.end()), weight.end());
    function<void(int, int, int)> dfs = [&](int v, int p, int cost) {
        if(cost != 0) {
            int pos = lower_bound(weight.begin(), weight.end(), cost) - weight.begin();
            ans[pos]++;
        }
        for (auto [to, w] : g[v]) {
            if (to != p) {
                dfs(to, v, max(cost, w));
            }
        }
    };
    for (int i = 1; i <= n; ++i) {
        dfs(i, 0, 0);
    }
    for (int i = 1; i <= n + 1; ++i) {
        ans[i] /= 2;
  //  cout << ans[i] << ' '<< weight[i] << endl;
        //ans[i] = (ans[i - 1] + ans[i] * weight[i]);

    }
    while (q--) {
        int l, r;
        cin >> l >> r;
       /* l = lower_bound(weight.begin(), weight.end(), l) - weight.begin();
        r = lower_bound(weight.begin(), weight.end(), r) - weight.begin();
        in
        cout << ans[r] - ans[l - 1] << '\n';*/
        int res = 0;
        for (int i = 1; i <= n + 1; ++i) {
            if (weight[i] >= l && weight[i] <= r) res += ans[i] * weight[i];
        }
        cout << res << '\n';
    }
    return 0;
}
