#include <bits/stdc++.h>

using namespace std;

const int N = 1 * 1e4 + 1, M = 1e5;
const long long ma = 1e18;

int now = 1;

vector <int> g[N];

long long w[N][N];

bool used[N];

long long d[N][N];

void dfs (int v, long long len) {
    d[now][v] = len;
    used[v] = 1;
    for (auto to : g[v]) {
        if (!used[to]) {
            dfs(to, max(len, w[v][to]));
        }
    }
    return;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n - 1; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        w[a][b] = c;
        w[b][a] = c;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for (int v = 1; v <= n; ++v) {
        now = v;
        dfs(v, 0);
        for (int i = 1; i <= n; ++i) {
            used[i] = 0;
        }
    }
    while (q--) {
        int l, r;
        cin >> l >> r;
        long long ans = 0;
        for (int i = 1; i <= n; ++i) {
            for (int j = i + 1; j <= n; ++j) {
                if (d[i][j] >= l && d[i][j] <= r) {
                    ans += d[i][j];
                }
            }
        }
        cout << ans << '\n';
    }
}
