#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int N = 100009;

int n, q, link[N], sz[N];

int f(int v) { return (v == link[v] ? v : link[v] = f(link[v])); }

void unite(int u, int v) {
    u = f(u), v = f(v);
    if (sz[u] > sz[v]) swap(u, v);
    link[u] = v, sz[v] += sz[u];
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    cin >> n >> q;

    vector < array < int , 3 > > vec;

    for (int i = 1; i < n; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        vec.push_back({w, u, v});
    }

    sort(vec.begin(), vec.end());
    for (int i = 1; i <= n; i++) link[i] = i, sz[i] = 1;

    ll res = 0;

    for (auto x : vec) {
        res += (ll)sz[f(x[1])] * (ll)sz[f(x[2])] * (ll)x[0];
        unite(x[1], x[2]);
    }

    int lg, rg;
    cin >> lg >> rg;

    cout << res;
}
