#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int N = 100009;

bool used[N], bad;
vector < int > vec, g[N];
int n, x[N], y[N], p[N], cl[N];

void dfs(int v) {
    used[v] = 1;
    for (auto u : g[v]) if (!used[u]) dfs(u);
    vec.push_back(v);
}

void dfsc(int v) {
    cl[v] = 1;
    for (auto u : g[v]) {
        if (cl[u] == 1) bad = 1;
        if (!cl[u]) dfsc(u);
    }
    cl[v] = 2;
}

bool can(int cx, int cy, int cn) {
    n = cn;

    for (int i = 0; i <= n; i++) cl[i] = 0, g[i].clear();

    for (int i = 1; i <= n; i++) {
        if (i >= cx) g[i - cx].push_back(i);
        if (i >= cy) g[i].push_back(i - cy);
    }

    bad = 0;
    for (int i = 0; i <= n; i++) if (!cl[i]) dfsc(i);

    return bad == false;
}

int calc(int cx, int cy) {
    int l = max(cx, cy) - 1, r = cx + cy;

    while (l < r) {
        int mid = (l + r + 1) >> 1;
        if (can(cx, cy, mid)) l = mid;
        else r = mid - 1;
    }

    return l;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    int q;
    cin >> q;

    for (int i = 1; i <= q; i++) {
        cin >> x[i] >> y[i];
        cout << calc(x[i], y[i]) << " ";
    }

    cout << "\n";

    n = calc(x[1], y[1]);

    for (int i = 0; i <= n; i++) used[i] = 0, g[i].clear();

    for (int i = 1; i <= n; i++) {
        if (i >= x[1]) g[i - x[1]].push_back(i);
        if (i >= y[1]) g[i].push_back(i - y[1]);
    }

    for (int i = 0; i <= n; i++) if (!used[i]) dfs(i);

    reverse(vec.begin(), vec.end());

    for (int i = 0; i <= n; i++) p[vec[i]] = i;

    for (int i = 1; i <= n; i++) cout << p[i] - p[i - 1] << " ";
}
