# include <bits/stdc++.h>

#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define vec vector
#define pb push_back
#define pw(x) (1ll << x)
#define pii pair<int,int>
#define lv (v << 1)
#define rv (v << 1 | 1)
#define mid (l + r >> 1)

using namespace std;

template <typename T>
bool umx (T &a, const T b) {return a < b ? (a = b, 1) : 0; }

template <typename T>
bool umn (T &a, const T b) {return a > b ? (a = b, 1) : 0; }

const int N = 4e5;

struct node {
    int balik = 0, ans = 0;
};

node merge (node a, node b) {
    node res;
    res.balik = a.balik + b.balik;
    res.ans = min({a.ans, a.balik + b.ans});
    return res;
}

node seg[4 * N];
string s;

const node ZERO = {0, 0};

void build (int v, int l, int r) {
//    cout << l << " " << r << "\n";

    if (l == r) {
        int x = (s[l] == '(' ? 1 : -1);
//        cout << l << " " << x << "\n";
        seg[v] = {x, x};
    } else {
        build(lv, l, mid);
        build(rv, mid + 1, r);
        seg[v] = merge(seg[lv], seg[rv]);
    }
}

node get (int v, int l, int r, int ql, int qr) {
    if (l > qr || r < ql)
        return ZERO;
    if (l >= ql && r <= qr)
        return seg[v];

    return merge(get(lv, l, mid, ql, qr), get(rv, mid + 1, r, ql, qr));
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, q, g;
    cin >> n >> q >> g;
    cin >> s;
    build(1, 0, 2 * n - 1);

//    node x = get(1, 0, 2 * n - 1, 5, 6);
//    cout << x.ans << " ";


    for (int i = 0, l, r; i < q; ++i) {
        cin >> l >> r;
        --l, --r;

        node x = get(1, 0, 2 * n - 1, l, r);
        cout << (abs(x.ans) + 1) / 2 << "\n";

//        int res = 0, b = 0;
//        for (int j = l; j <=r ; ++j) {
//            if (s[j] == '(') b++;
//            else b--;
//            umn(res, b);
//        }
//        cout << (abs(res) + 1) / 2 << "\n";

    }

}
