#include <bits/stdc++.h>

using namespace std;

#define int long long

void solve1();

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int qwerty = 1;
    // cin >> qwerty;
    while (qwerty--) {
        solve1();
    }
}

struct edge {
    int to, w;
};

vector<vector<edge>> gr;
vector<vector<int>> mx;

void dfs(int v, int p, int m, int pr) {
    mx[pr][v] = m;
    for (auto u: gr[v]) {
        if (u.to == p) continue;
        dfs(u.to, v, max(m, u.w), pr);
    }
}

void solve1() {
    int n, q;
    cin >> n >> q;
    gr.resize(n);
    mx.resize(n, vector<int>(n));
    set<int> st;
    for (int i = 0; i < n - 1; i++) {
        int v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;
        st.insert(w);
        gr[v].push_back({u, w});
        gr[u].push_back({v, w});
    }
    vector<int> all = {0};
    for (int i: st) {
        all.push_back(i);
    }
    for (int i = 0; i < n; i++) {
        dfs(i, i, 0, i);
    }
    map<int, int> mp;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            mp[mx[i][j]] += mx[i][j];
        }
    }
    map<int, int> pred;
    for (int i = 1; i < all.size(); i++) {
        pred[all[i]] = all[i - 1];
    }
    while (q--) {
        int l, r;
        cin >> l >> r;
        int ans = 0;
        auto fir = st.lower_bound(l);
        while (*fir <= r) {
            ans += mp[*fir];
            ++fir;
        }
        cout << ans << '\n';
    }
}