#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define en '\n'

struct zxc {
    ll r;
    ll l;
};
string s;
vector<zxc> tree;

void build(ll v, ll vl, ll vr) {
    if (vr - vl == 1) {
        if (s[vl] == '(') {
            tree[v].r = 1;
            tree[v].l = 0;
        } else {
            tree[v].r = 0;
            tree[v].l = 1;
        }
        return;
    }
    ll mid = (vr + vl) / 2;
    build(v * 2, vl, mid);
    build(v * 2 + 1, mid, vr);
    if (tree[v * 2].r >= tree[v * 2 + 1].l) {
        tree[v].r = tree[v * 2].r - tree[v * 2 + 1].l + tree[v * 2 + 1].r;
        tree[v].l = tree[v * 2].l;
        return;
    } else {
        tree[v].l = tree[v * 2 + 1].l - tree[v * 2].r + tree[v * 2].l;
        tree[v].r = tree[v * 2 + 1].r;
        return;
    }
}

vector<pair<zxc, zxc>> p;

zxc sm(ll v, ll vl, ll vr, ll l, ll r) {
    if (r <= vl || vr <= l) {
        return {0, 0};
    }
    if (l <= vl && r >= vr) {
        return tree[v];
    }
    ll mid = (vr + vl) / 2;
    p[v].first = sm(v * 2, vl, mid, l, r);
    p[v].second = sm(v * 2 + 1, mid, vr, l, r);
    if (p[v].first.r >= p[v].second.l) {
        return {p[v].first.r - p[v].second.l + p[v].second.r, p[v].first.l};
    } else {
        return {p[v].second.r, p[v].second.l - p[v].first.r + p[v].first.l};
    }
}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n, q, g;
    cin >> n >> q >> g;
    cin >> s;
    tree.resize(4 * (n * 2));
    p.resize(4 * (n * 2));
    build(1, 0, n * 2);
    for (ll t = 0; t < q; t++) {
        ll l, r;
        cin >> l >> r;
        l--;
        zxc ans = sm(1, 0, n * 2, l, r);
        ll k = (ans.r + ans.l) / 2;
        if (k == 0) {
            cout << 0 << en;
            continue;
        }
        cout << (k - 1) / 2 + 1 << en;
    }
}
