#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define en endl

struct zxc {
    ll b;
    ll ans;
};

vector<vector<zxc>> g;
vector<ll> used;
vector<ll> up;
vector<vector<ll>> pref;
vector<vector<ll>> dist;

void dfs(ll v, ll p, ll m) {
    used[v] = 1;
    up[v] = up[p] + 1;
    pref[v][0] = p;
    dist[v][0] = m;
    for (ll i = 1; i < 30; i++) {
        pref[v][i] = pref[pref[v][i - 1]][i - 1];
        dist[v][i] = max(dist[v][i - 1], dist[pref[v][i - 1]][i - 1]);
    }
    for (auto el: g[v]) {
        if (used[el.b] == 0) {
            dfs(el.b, v, el.ans);
        }
    }
}

ll sum = 0;

ll raz(ll a, ll b) {
    if (up[a] == up[b]) {
        return b;
    } else {
        for (ll i = 1; i < 30; i++) {
            if (up[a] == up[pref[b][i]]) {
                sum = max(sum, dist[b][i]);
                return pref[b][i];
            }
            if (up[a] > up[pref[b][i]]) {
                sum = max(sum, dist[b][i - 1]);
                return raz(a, pref[b][i - 1]);
            }
        }
    }
}

void LCA(ll a, ll b) {
    if (a == b) {
        return;
    } else {
        for (ll i = 1; i < 30; i++) {
            if (pref[a][i] == pref[b][i]) {
                sum = max(sum, dist[b][i - 1]);
                sum = max(sum, dist[a][i - 1]);
                LCA(pref[a][i - 1], pref[b][i - 1]);
                return;
            }
        }
    }
}


int main() {
    ll n, q;
    cin >> n >> q;
    g.resize(n);
    used.resize(n);
    up.resize(n);
    pref.resize(n, vector<ll>(30));
    dist.resize(n, vector<ll>(30));
    ll m = 0;
    for (ll i = 0; i < n - 1; i++) {
        ll a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        m = max(m, c);
        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }
    dfs(0, 0, 0);
    vector<ll> dp(m + 1);
    for (ll i = 0; i < n; i++) {
        for (ll j = i + 1; j < n; j++) {
            ll a = i;
            ll b = j;
            sum = 0;
            if (up[a] > up[b]) {
                swap(a, b);
            }
            b = raz(a, b);
            LCA(a, b);
            dp[sum]++;
        }
    }
    for (ll i = 0; i < q; i++) {
        ll l, r;
        cin >> l >> r;
        ll ot = 0;
        for (ll j = l; j <= r; j++) {
            if (m >= j) {
                ot += (dp[j] * j);
            }
        }
        cout << ot << en;
    }
}
