#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define en endl

struct zxc {
    ll b;
    ll ans;
};

vector<vector<zxc>> g;
vector<ll> used;
vector<ll> dp;

void dfs(ll v, ll mx) {
    used[v] = 1;
    dp[mx]++;
    for (auto el: g[v]) {
        if (used[el.b] == 0) {
            dfs(el.b, max(mx, el.ans));
        }
    }
}


int main() {
    ll n, q;
    cin >> n >> q;
    g.resize(n);
    used.resize(n);
    ll m = 0;
    for (ll i = 0; i < n - 1; i++) {
        ll a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        m = max(m, c);
        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }
    dp.resize(m + 1);
    for (ll i = 0; i < n; i++) {
        used.assign(n, 0);
        dfs(i, 0);
    }
    for (ll i = 0; i < q; i++) {
        ll l, r;
        cin >> l >> r;
        ll col = 0;
        for (ll j = l; j <= r; j++) {
            if (m >= j) {
                col += (dp[j] / 2 * j);
            }
        }
        cout << col << en;
    }
}
