#include <bits/stdc++.h>

using namespace std;
const int INF = 2e9;

struct node {
    int y, c;
};

vector<vector<node>> z;
vector<int> used, used1;
int n;
int l, r, ans = 0;

void dfs(int u, int p) {
    if (used1[u] == 0 && p >= l && p <= r) {
        ans += p;
    }
    used[u] = p;
    for (auto [to, c]: z[u]) {
        if (used[to] == -1) {
            dfs(to, max(p, c));
        }
    }
}

void solve() {
    cin >> l >> r;
    ans = 0;
    used1.clear();
    used1.resize(n, 0);
    for (int i = 0; i < n; i++) {
        used1[i] = 1;
        used.clear();
        used.resize(n, -1);
        dfs(i, 0);
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int e;
    cin >> n >> e;
    z.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int x, y, c;
        cin >> x >> y >> c;
        x--;
        y--;
        z[x].push_back({y, c});
        z[y].push_back({x, c});
    }
    while (e--) {
        solve();
        cout << "\n";
    }
}

