#include <bits/stdc++.h>
using namespace std;
#define int int64_t
struct zapr {
    int v;
    int u;
    int w;
};
struct edge {
    int v;
    int w;
};
vector<int> b;
vector<int> tree;
void build(int v, int l, int r) {
    if(l+1==r) {
        tree[v]=b[l];
        return;
    }
    int m=(l+r)/2;
    build(2*v+1,l,m);
    build(2*v+2,m,r);
    tree[v]=tree[2*v+1]+tree[2*v+2];
}
int get(int v, int l, int r, int ql, int qr) {
    if(l>=qr || ql>=r) {
        return 0;
    }
    if(ql<=l && r<=qr) {
        return tree[v];
    }
    int m=(l+r)/2;
    return get(2*v+1,l,m,ql,qr)+get(2*v+2,m,r,ql,qr);
}
int32_t main() {
    int n;
    cin >> n;
    int q;
    cin >> q;
    vector<zapr> d(n);
    for(int i=1;i<=n-1;i++) {
        cin >> d[i].v >> d[i].u >> d[i].w;
    }
    vector<pair<int,int> > p(q);
    for(int i=0;i<q;i++) {
        cin >> p[i].first >> p[i].second;
    }
    map<int,int> mp;
    for(int i=1;i<n;i++) {
        mp[d[i].w]=0;
    }
    for(int i=0;i<q;i++) {
        mp[p[i].first]=0;
        mp[p[i].second]=0;
    }
    int j=0;
    for(auto &e:mp) {
        e.second=j;
        j++;
    }
    tree=vector<int>(4*j);
    b=vector<int>(j,0);
    vector<vector<edge> > a(n+1);
    for(int i=1;i<n;i++) {
        a[d[i].v].push_back({d[i].u,d[i].w});
        a[d[i].u].push_back({d[i].v,d[i].w});
    }
    vector<vector<bool> > wf(n+1);
    for(int i=1;i<=n;i++) {
        wf[i].resize(n+1,false);
    }
    for(int i=1;i<=n-1;i++) {
        vector<bool> used(n+1,false);
        vector<int> h(n+1,0);
        deque<int> dq;
        dq.push_back(i);
        used[i]=true;
        while(dq.size()!=0) {
            int v=dq.front();
            dq.pop_front();
            for(int l=0;l<a[v].size();l++) {
                int u=a[v][l].v;
                int w=a[v][l].w;
                if(used[u]==true) {
                    continue;
                }
                h[u]=max(h[v],w);
                int y=min(i,u);
                int r=max(i,u);
                if(wf[y][r]==false) {
                        wf[y][r]=true;
                    b[mp[h[u]]]+=h[u];
                }
                dq.push_back(u);
                used[u]=true;
            }
        }
    }
    build(0,0,j);
    for(int i=0;i<q;i++) {
        int l=p[i].first;
        int r=p[i].second;
        l=mp[l];
        r=mp[r];
        r++;
        cout << get(0,0,j,l,r) << '\n';
    }
}
