#include <iostream>
#include <cmath>
#include <string>
#include <vector>
#define ll unsigned long long

using namespace std;

int parentheses(int n, int g, string s) {
	int unfinishedPairs = 0;

	for (char c : s) {
		if (c == '(') unfinishedPairs++;
		else if (unfinishedPairs > 0) unfinishedPairs--;
		else unfinishedPairs++;
	}

	unfinishedPairs /= 2;

	return unfinishedPairs;
}

void parenthesesMain() {
	int n, q, g, tempL, tempR; cin >> n >> q >> g;
	string s; cin >> s;
	vector<int> results;

	for (int i = 0; i < q; i++) {
		cin >> tempL;
		cin >> tempR;
		results.push_back(parentheses(n, g, s.substr(tempL - 1, tempR - tempL + 1)));
	}

	for (int r : results) cout << r << endl;
}

int main()
{
	parenthesesMain();
}