#include <iostream>
#include <cmath>
#include <string>
#include <vector>
#define ll unsigned long long

using namespace std;

//int parentheses(int n, int g, string s, int l, int r) {
//	int unfinishedBrackets = 0;
//
//	for (int i = l - 1; i < r; i++) {
//		if (s[i] == '(' || unfinishedBrackets == 0) unfinishedBrackets++;
//		else unfinishedBrackets--;
//	}
//
//	return unfinishedBrackets / 2;
//}

void parenthesesMain() {
	int n, q, g, tempL, tempR; cin >> n >> q >> g;
	string s; cin >> s;
	vector<int> results, unfinishedBracketsPerSymbol(2 * n);

	unfinishedBracketsPerSymbol[0] = 1;
	for (int i = 1; i < 2 * n; i++) {
		if (s[i] == '(' || unfinishedBracketsPerSymbol[i - 1] == 0) unfinishedBracketsPerSymbol[i] = unfinishedBracketsPerSymbol[i - 1] + 1;
		else unfinishedBracketsPerSymbol[i] = unfinishedBracketsPerSymbol[i - 1] - 1;
	}

	for (int i = 0; i < q; i++) {
		cin >> tempL;
		cin >> tempR;
		results.push_back((unfinishedBracketsPerSymbol[tempR - 1] - unfinishedBracketsPerSymbol[tempL - 1] + 1) / 2);
	}

	for (int r : results) cout << r << endl;
}

int main()
{
	parenthesesMain();
}