#include <iostream>
#include <cmath>
#include <string>
#include <vector>
#define ll unsigned long long

using namespace std;

void parenthesesMain() {
	int n, q, g, tempL, tempR; cin >> n >> q >> g;
	string s; cin >> s;
	vector<int> results, unfinishedBracketsPerSymbol(2 * n);

	unfinishedBracketsPerSymbol[0] = 1;
	for (int i = 1; i < 2 * n; i++) {
		if (s[i] == '(' || unfinishedBracketsPerSymbol[i - 1] == 0) unfinishedBracketsPerSymbol[i] = unfinishedBracketsPerSymbol[i - 1] + 1;
		else unfinishedBracketsPerSymbol[i] = unfinishedBracketsPerSymbol[i - 1] - 1;
	}

	for (int i = 0; i < q; i++) {
		cin >> tempL;
		cin >> tempR;
		if (g != 6) {
			results.push_back((unfinishedBracketsPerSymbol[tempR - 1] - unfinishedBracketsPerSymbol[tempL - 1] + 1) / 2);
		}
		else if (unfinishedBracketsPerSymbol[tempR - 1] == unfinishedBracketsPerSymbol[tempL - 1]) results.push_back(0);
		else results.push_back(1);
	}

	for (int r : results) cout << r << endl;
}

int main()
{
	parenthesesMain();
}