#include <iostream>
#include <cmath>
#include <string>
#include <vector>
#define ll unsigned long long

using namespace std;

void parenthesesMain() {
	int n, q, g, tempL, tempR; cin >> n >> q >> g;
	string s; cin >> s;
	vector<float> unfinishedBracketsPerSymbol(2 * n), results;

	unfinishedBracketsPerSymbol[0] = 0.5f;
	for (int i = 1; i < 2 * n; i++) {
		if (s[i] == '(' || unfinishedBracketsPerSymbol[i - 1] == 0) unfinishedBracketsPerSymbol[i] = unfinishedBracketsPerSymbol[i - 1] + 0.5f;
		else unfinishedBracketsPerSymbol[i] = unfinishedBracketsPerSymbol[i - 1] - 0.5f;
	}

	for (int i = 0; i < q; i++) {
		cin >> tempL;
		cin >> tempR;
		results.push_back(unfinishedBracketsPerSymbol[tempR - 1] - unfinishedBracketsPerSymbol[tempL - 1] + 0.5f);
	}

	for (int r : results) cout << r << endl;
}

int main()
{
	parenthesesMain();
}