#include <iostream>
#include <cmath>
#include <string>
#include <vector>
#include <climits>
#define ll unsigned long long

using namespace std;

void parenthesesMain() {
	int n, q, g, tempL, tempR, minL = INT16_MAX, maxR = INT16_MIN; cin >> n >> q >> g;
	string s; cin >> s;
	vector<float> unfinishedPairsPerSymbol(2 * n), results;
	vector<int> Ls(q), Rs(q);

	for (int i = 0; i < q; i++) {
		cin >> tempL;
		cin >> tempR;
		Ls[i] = tempL - 1;
		Rs[i] = tempR - 1;
		//minL = min(tempL, minL);
		maxR = max(tempR, maxR);
	}

	unfinishedPairsPerSymbol[0] = 0.5f;
	for (int i = 1; i < maxR; i++) {
		if (s[i] == '(' || unfinishedPairsPerSymbol[i - 1] == 0) unfinishedPairsPerSymbol[i] = unfinishedPairsPerSymbol[i - 1] + 0.5f;
		else unfinishedPairsPerSymbol[i] = unfinishedPairsPerSymbol[i - 1] - 0.5f;
	}

	for (int i = 0; i < q; i++) {
		cout << unfinishedPairsPerSymbol[Rs[i]] - unfinishedPairsPerSymbol[Ls[i]] + 0.5f << endl;
	}
}

int main()
{
	parenthesesMain();
}