#include <iostream>
#include <vector>
#include <string>

using namespace std;

void parenthesesMain() {
	int n, q, g, tempL, tempR, difference; cin >> n >> q >> g;
	string s, res; cin >> s;
	vector<float> unfinishedPairsPerSymbol(2 * n);

	unfinishedPairsPerSymbol[0] = 0.5f;
	for (int i = 1; i < 2 * n; i++) {
		if (s[i] == '(' || unfinishedPairsPerSymbol[i - 1] == 0) unfinishedPairsPerSymbol[i] = unfinishedPairsPerSymbol[i - 1] + 0.5f;
		else unfinishedPairsPerSymbol[i] = unfinishedPairsPerSymbol[i - 1] - 0.5f;
	}

	for (int i = 0; i < q; i++) {
		cin >> tempL;
		cin >> tempR;
		cout << (int)(unfinishedPairsPerSymbol[tempR - 1] - unfinishedPairsPerSymbol[tempL - 1] + 0.5f) << endl;
	}
}

int main()
{
	parenthesesMain();
}