#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <queue>
#include <stack>
#include <string>
using namespace std;
using ll = long long;
using vll = vector<ll>;
using vvl = vector<vll>;
using vb = vector<bool>;
using pll = pair<ll,ll>;
using vpl = vector<pll>;
#define f first
#define s second
#define pb push_back
#define all(v) v.begin(),v.end()
struct Node{
    ll l, r, m, val;
    Node *ls=nullptr, *rs=nullptr;
    Node(ll l, ll r):l(l),r(r),m((l+r)/2),val(1e9){
        if(l+1<r){
            ls = new Node(l,m);
            rs = new Node(m,r);
        }
    }
    void upd(ll i, ll x){
        if(l+1==r){val=x;return;}
        if(i>=m)rs->upd(i,x);
        else ls->upd(i,x);
        val = min(ls->val,rs->val);
    }
    ll query(ll a, ll b){
        if(r<=a || b<=l)return 1e9;
        if(a<=l && r<=b)return val;
        return min(ls->query(a,b),rs->query(a,b));
    }
};
int main(){
    ios_base::sync_with_stdio(0);cin.tie(NULL);
    ll n, q, g, l, r;
    cin >> n >> q >> g;
    vll se(n*2), ras(2*n+1);
    char c;
    Node *seg = new Node(0, 1<<(32-__builtin_clz(n*2)));
    for(ll i = 0; i < n*2; ++i){
        cin >> c;
        if(c=='(')se[i]=1;
        else se[i]=-1;
    }
    for(ll i = 0; i < n*2; ++i){
        ras[i+1] = ras[i] + se[i];
    }
    for(ll i = 0; i <= n*2; ++i){
        seg->upd(i, ras[i]);
    }
    ll mn;
    while(q--){
        cin >> l >> r;
        r++;
        mn = seg->query(l,r)-ras[l-1];
        mn = (mn-1)/2;
        cout << -mn << "\n";
    }
}
