#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <queue>
#include <stack>
#include <string>
using namespace std;
using ll = int;
using vll = vector<ll>;
using vvl = vector<vll>;
using vb = vector<bool>;
using pll = pair<ll,ll>;
using vpl = vector<pll>;
#define f first
#define s second
#define pb push_back
#define all(v) v.begin(),v.end()
struct Node{
    ll n;
    vll bl;
    Node(ll n, vll b):n(n){
        bl = vll(n*2,1e9);
        for(ll i = 0; i < b.size();i++){
            bl[i+n] = b[i];
        }
        for(ll i = n-1; i;i--){
            bl[i] = min(bl[i*2],bl[i*2+1]);
        }
    }
    ll query(ll a, ll b){
        a+=n;b+=n;
        ll ans=1e9;
        for(;a<=b;a/=2, b/=2){
            if(a%2==1)ans = min(ans,bl[a++]);
            if(b%2==0)ans = min(ans,bl[b--]);
        }
        return ans;
    }
};
int main(){
    ios_base::sync_with_stdio(0);cin.tie(NULL);
    ll n, q, g, l, r;
    cin >> n >> q >> g;
    vll se(n*2), ras(2*n+1);
    char c;
    for(ll i = 0; i < n*2; ++i){
        cin >> c;
        if(c=='(')se[i]=1;
        else se[i]=-1;
    }
    for(ll i = 0; i < n*2; ++i){
        ras[i+1] = ras[i] + se[i];
    }
    Node *seg = new Node(1<<(32-__builtin_clz(n*2)), ras);

    ll mn;
    while(q--){
        cin >> l >> r;
        mn = seg->query(l,r)-ras[l-1];
        mn = (mn-1)/2;
        cout << -mn << "\n";
    }
}
