#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <queue>
#include <stack>
#include <string>
#include <map>
using namespace std;
using ll = long long;
using vll = vector<ll>;
using vvl = vector<vll>;
using vb = vector<bool>;
using pll = pair<ll,ll>;
using vpl = vector<pll>;
using vvp = vector<vpl>;
#define f first
#define s second
#define pb push_back
#define all(v) v.begin(),v.end()


struct Node{
    ll n;
    vll bl;
    Node(ll n, vll b):n(n){
        bl = vll(n*2,0);
        for(ll i = 0; i < b.size();i++){
            bl[i+n] = b[i];
        }
        for(ll i = n-1; i;i--){
            bl[i] = bl[i*2]+bl[i*2+1];
        }
    }
    ll query(ll a, ll b){
        a+=n;b+=n;
        ll ans=0;
        for(;a<=b;a/=2, b/=2){
            if(a%2==1)ans += bl[a++];
            if(b%2==0)ans += bl[b--];
        }
        return ans;
    }
};


vll par, sz, len;
ll find_par(ll a){
    if(a==par[a])return a;
    else return par[a] = find_par(par[a]);
}
void unite(ll a, ll b){
    a = find_par(a);
    b = find_par(b);
    if(sz[a]<sz[b])swap(a,b);
    par[b] = a;
    sz[a] += sz[b];
}
ll plac(ll w, ll q=0){
    ll a = lower_bound(all(len),w)-len.begin();
    if(len[a]==w)return a;
    else return a+q;
}
//fstream fin("C:\\Users\\Default\\Desktop\\IATI\\C5_tolls\\in.txt");
int main(){
    ios_base::sync_with_stdio(0);cin.tie(NULL);
    ll n, q, l, r, u, v, w;
    cin >> n >> q;
    vector<pair<ll,pll>> edg;
    vll ans;map<ll,ll> chek;
    for(ll i = 1; i < n; ++i){
        cin >> u >> v >> w;
        edg.pb({w, {u,v}});
        if(!chek.count(w)){
            len.pb(w);
            chek[w]=1;
        }
    }
    sort(all(edg));
    sort(all(len));
    par = sz = vll(n+1, 1);
    ans = vll(len.size());
    for(ll i = 0 ; i <= n; ++i)par[i]=i;
    for(auto [W,c]:edg){
        auto [a,b] = c;
        ll A = sz[find_par(a)];
        ll B = sz[find_par(b)];
        ans[plac(W)]+=A*B;
        unite(a,b);
    }
    for(ll i = 0; i < len.size(); ++i){
        ans[i] *= len[i];
    }
    ll ret;
    Node *seg = new Node(1<<(32-__builtin_clz(len.size()-1)), ans);
    while(q--){
        cin >> l >> r;
        ret = seg->query(plac(l), plac(r,-1));
        cout << ret << "\n";
    }
}