#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int long long
#define vec vector
typedef pair<int , int> pii;
#define indexed_set tree<pii , null_type , less<pii> , rb_tree_tag , tree_order_statistics_node_update>
const int mn = INT_MIN;
int bfs(int start , int finish , vec<vec<pii>> g){
    vec<int> dist(g.size() , mn);
    indexed_set q;
    q.insert({start , 0});
    dist[start] = 0;
    while(!q.empty()){
        int cur = q.begin() -> first;
        int w = q.begin() -> second;
        q.erase(q.begin());
        for (auto [to , nxt_w] : g[cur]){
            if (dist[to] == mn and w < nxt_w){
                dist[to] = nxt_w;
                q.insert({to , nxt_w});
            }
        }
    }
    return dist[finish];
}
signed main()
{
    int n , t;
    cin >> n >> t;
    vec<vec<pii>> g(n);
    for (int i = 1; i < n; i++){
        int x , y , w;
        cin >> x >> y >> w;
        x -- , y -- ;
        g[x].push_back({y , w});
        g[y].push_back({x , w});
    }
    vec<vec<int>> dist(n , vec<int> (n , mn));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++){
            if (i != j) {
                int i_j = bfs(i, j, g);
                dist[i][j] = i_j;
            }
            else dist[i][j] = dist[j][i] = 0;
        }
    }
    for (auto a : dist){
        for (auto x : a){
            if (x != mn)
            cout << x << " ";
            else cout << "0 ";
        }
        cout << "\n";
    }
    while(t--){
        int l , r;
        cin >> l >> r;
        int ans = 0;
        for (int i = l; i <= r; i++){
            int cnt = 0;
            for (int a = 0; a < n; a++){
                for (int b = 0; b < n; b++){
                    if (dist[a][b] == i)cnt++;
                }
            }
            ans += cnt * i;
        }
        cout << ans << "\n";
    }
}