#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;

#define int long long

template<class t> using ordered_set =
        __gnu_pbds::tree<t, __gnu_pbds::null_type, less<t>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

template<class t> using ordered_multiset =
        __gnu_pbds::tree<t, __gnu_pbds::null_type, less_equal<t>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

template<class t, class u>
bool chmin(t &a, u b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<class t, class u>
bool chmax(t &a, u b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int mod = 1e9 + 7;

int binpow(int n, int e){
    int res = 1;
    while(e){
        if(e & 1) res = (res * n) % mod;
        n = (n * n) % mod;
        e >>= 1;
    }
    return res;
}

int divide(int a, int b){
    return a * binpow(b, mod - 2) % mod;
}

void f12(vector<int> x1, vector<int> y1) {
    int res = 0, cnt = 0, q = x1.size();
    bool flag = true;
    for (int i = 0; i < q; ++i) {
        int x = x1[i], y = y1[i];
        if (!cnt) {
            if (x > y) {
                res = x;
            } else {
                res = y;
                flag = false;
            }
            cnt++;
        }
        cout << max(x, y) - 1 << ' ';
        cnt ++;
    }
    cout << '\n';
    for (int i = 1; i < res; ++i) {
        if (flag) cout << -1 << ' ';
        else cout << 1 << ' ';
    }
}

void f5(vector<int> x1, vector<int> y1) {
    int res = 0;
    bool flag = false;
    for (int i = 0; i < x1.size(); ++i) {
        int x = x1[i], y = y1[i];
        if (i == 0) {
            if (x > y) {
                res = y;
            } else {
                res = x;
                flag = true;
            }
        }
        cout << (min(x, y) - 1) * 2 + 1 << ' ';
    }
    cout << '\n';
    for (int i = 1; i < res; ++i) {
        if (flag) cout << -2 << ' ';
        else cout << 2 << ' ';
    }
    if (flag) cout << res * 2 - 1 << ' ';
    else cout << -(res * 2 - 1) << ' ';
    for (int i = 1; i < res; ++i) {
        if (flag) cout << -2 << ' ';
        else cout << 2 << ' ';
    }
}

void f3(vector<int> x1, vector<int> y1) {

}

void solve() {
    int q;
    cin >> q;
    vector<int> x(q), y(q);
    bool is12 = true;
    bool is3 = q == 1;
    bool is5 = true;
    for (int i = 0; i < q; ++i) {
        cin >> x[i] >> y[i];
        chmin(is12, x[i] % y[i] == 0 || y[i] % x[i] == 0);
        chmin(is3, x[i] <= 5 && y[i] <= 5);
        chmin(is5, abs(x[i] - y[i]) == 1);
    }
    if (is12) {
        f12(x, y);
        return;
    }
    if (is3) {
        f3(x, y);
        return;
    }
    if (is5) {
        f5(x, y);
        return;
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
//  int tt; cin >> tt; while(tt--) // DON'T FORGET
    solve();
}