#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;

#define int long long

template<class t> using ordered_set =
        __gnu_pbds::tree<t, __gnu_pbds::null_type, less<t>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

template<class t> using ordered_multiset =
        __gnu_pbds::tree<t, __gnu_pbds::null_type, less_equal<t>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

template<class t, class u>
bool chmin(t &a, u b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<class t, class u>
bool chmax(t &a, u b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int mod = 1e9 + 7;

int binpow(int n, int e){
    int res = 1;
    while(e){
        if(e & 1) res = (res * n) % mod;
        n = (n * n) % mod;
        e >>= 1;
    }
    return res;
}

int divide(int a, int b){
    return a * binpow(b, mod - 2) % mod;
}

void solve() {
    int q;
    cin >> q;
    vector<int> x(q), y(q);
    bool is12 = false, is5 = false;
    for (int i = 0; i < q; ++i) {
        cin >> x[i] >> y[i];
    }
    int res, my, mx, md;
    bool tr = false;
    for (int i = 0; i < 1; ++i) {
        int X = x[i], Y = y[i], sz = 0;
        if (X > Y) swap(X, Y), tr = true;
        mx = X, my = Y;
        int XD = X / 2;
        int kal = Y / X;
        int m = X / 2;
        m++;
        if (X % Y == 0 || Y % X == 0) {
            res = Y - 1;
            is12 = true;
            break;
        }
        if (abs(X - Y) == 1) {
            res = (X - 1) * 2 + 1;
            is5 = true;
            break;
        }
        md = m;
        Y %= X;
        if (Y < m) {
            cout << (res = max(x[i], y[i]) - 1) << ' ';
        } else {
            cout << (res = max(x[i], y[i]) + m - 1) << ' ';
        }
    }
    for (int i = 1; i < q; ++i) {
        int X = x[i], Y = y[i], sz = 0;
        if (X > Y) swap(X, Y);
        int XD = X / 2;
        int kal = Y / X;
        int m = X / 2;
        if (X % 2 == 0) m++;
        if (X % Y == 0 || Y % X == 0) {
            cout << Y - 1 << ' ';
            continue;
        }
        if (abs(X - Y) == 1) {
            cout << (X - 1) * 2 + 1 << ' ';
            continue;
        }
        Y %= X;
        if (Y < m) {
            cout << max(x[i], y[i]) - 1 << ' ';
        } else {
            cout << max(x[i], y[i]) + m - 1 << ' ';
        }
    }
    cout << '\n';
    vector<int> X;
    if (is12)
        for (int i = 1; i <= res; ++i) X.emplace_back(1);
    else if (is5) {
        for (int i = 1; i < res; ++i) {
            X.emplace_back(2);
        }
        X.emplace_back(-(res * 2 - 1));
        for (int i = 1; i < res; ++i) {
            X.emplace_back(2);
        }
    } else
    for (int i = 1; i <= mx; ++i) {
        if (i == md) X.emplace_back(-(1e4 * (mx - 1)) + 1);
        else X.emplace_back(1e4);
    }
    int str = 0;
    for (int i = 0; i < res; ++i) {
        if (i - str >= mx) str = i;
        if (tr) cout << -X[i - str] << ' ';
        else cout << X[i - str] << ' ';
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
//  int tt; cin >> tt; while(tt--) // DON'T FORGET
    solve();
}