#include <iostream>
#include <vector>
using namespace std;

int main() {
    int Q;
    cin >> Q;

    vector<int> answers(Q);
    for (int i = 0; i < Q; i++) {
        int X, Y;
        cin >> X >> Y;

        // Функция для нахождения максимальной длины последовательности
        // с требуемыми свойствами для заданных X и Y
        auto findMaxSequenceLength = [](int X, int Y) {
            int maxLength = X + Y - 1;
            return maxLength;
        };

        // Находим ответ на i-й запрос и сохраняем его
        answers[i] = findMaxSequenceLength(X, Y);
    }

    // Выводим ответы на запросы
    for (int i = 0; i < Q; i++) {
        cout << answers[i] << " ";
    }
    cout << endl;

    // Выводим максимальную последовательность для первого запроса
    int X = 3; // Пример значения X для первого запроса
    int Y = 4; // Пример значения Y для первого запроса
    int maxLength = max(X, Y);
    for (int i = 0; i < maxLength; i++) {
        if (i < X) {
            cout << i + 1 << " ";
        } else {
            cout << -1 * (i - X + 1) << " ";
        }
    }
    cout << endl;

    return 0;
}