#include <bits/stdc++.h>

using namespace std;

const int M = 1<<23, lg = 22, inf=369000000;

int seg[M],lazy[M],n,pre[M];

void push(int v)
{
	int lc=v*2,rc=lc+1;
	seg[lc]+=lazy[v],seg[rc]+=lazy[v];
	lazy[lc]+=lazy[v],lazy[rc]+=lazy[v];
	lazy[v]=0;
}

void make(int s=0,int e=2*n,int v=1)
{
	if (s+1==e)
	{
		seg[v]=pre[e];
		return;
	}
	int lc=v*2,rc=lc+1,mid=(s+e)/2;
	make(s,mid,lc);
	make(mid,e,rc);
	seg[v]=max(seg[lc],seg[rc]);
}

void modify(int l,int r,int x,int v=1,int s=0,int e=2*n)
{
	if (s>=r or e<=l)
		return;
	if (l<=s and e<=r)
	{
		seg[v]+=x;
		lazy[v]+=x;
		return;
	}
	int mid=(s+e)/2,lc=v*2,rc=lc+1;
	push(v);
	modify(l,r,x,lc,s,mid);
	modify(l,r,x,rc,mid,e);
	seg[v]=max(seg[lc],seg[rc]);
}

int get(int l,int r,int v=1,int s=0,int e=2*n)
{
	if (l==-1)
		return 0;
	if (s>=r or e<=l)
		return -inf;
	if (l<=s and e<=r)
		return seg[v];
	int mid=(s+e)/2,lc=v*2,rc=lc+1;
	push(v);
	return max(get(l,r,lc,s,mid),get(l,r,rc,mid,e));
}

bool valid(int l,int r)
{
	return (get(l-1,r)-get(l-2,l-1)<=0);
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(NULL),cout.tie(NULL);
	int g,q;
	cin>>n>>q>>g;
	string s;
	cin>>s;
	deque<int> ind[2];
	for (int i=0;i<2*n;i++)
	{
		pre[i+1]=pre[i]+1;
		if (s[i]=='(')
		{
			pre[i+1]=pre[i]-1;
			ind[0].push_back(i);
		}
		else
			ind[1].push_back(i);
	}
	make();
	while (q--)
	{
		int l,r,ans=0;
		cin>>l>>r;
		while (!valid(l,r))
		{
			int x=ind[1].front(),y=ind[0].back();
			ind[1].pop_front(),ind[0].pop_back();
			modify(x,y,-2);
			ans++;
		}
		cout<<ans<<'\n';
	}
	return 0;
}