#include <iostream>

using namespace std;

#define MAXN 200000
#define OPEN 0
#define CLOSED 1

int original[2*MAXN];
int queu[2*MAXN],pozQ[2*MAXN];
int isStart[2*MAXN],isEnd[2*MAXN];
int start[2*MAXN],End[2*MAXN+1];
int sum2End[2*MAXN+1];
int nStart,nEnd;
int nrClosed[2*MAXN],nrOpen[2*MAXN];

int binary(int val){
    int mij,st=0,dr=nEnd;
    while(dr-st>1){
        mij=(st+dr)/2;
        if(End[mij]>val)
            dr=mij;
        else
            st=mij;
    }
    return st;
}

int main()
{
    int n,q,g,i,top,sum,deschise,inchise,corecte,dr,st;
    char c;
    scanf("%d%d%d", &n, &q, &g);
    fgetc(stdin);
    top=0;
    for(i=0; i<2*n; i++){
        c=fgetc(stdin);
        if(c=='('){
            original[i]=OPEN;
            pozQ[top]=i;
            queu[top++]=OPEN;
        }else{
            original[i]=CLOSED;
            if(top>0&&queu[top-1]==OPEN){
                isStart[pozQ[top-1]]=1;
                isEnd[i]=1;
                top--;
            }else{
                pozQ[top]=i;
                queu[top++]=CLOSED;
            }
        }
    }
    nStart=0;
    End[0]=-1;
    nEnd=1;
    for(i=0; i<2*n; i++){
        if(isStart[i]){
            start[nStart++]=i;
        }else if(isEnd[i]){
            End[nEnd++]=i;
        }
    }
    sum=0;
    sum2End[0]=0;
    for(i=1; i<nEnd; i++){
        sum+=2;
        sum2End[i]=sum;
    }
    if(original[0]==OPEN)
        nrOpen[0]=1;
    else
        nrClosed[0]=1;
    for(i=1; i<2*n; i++){
        nrOpen[i]=nrOpen[i-1];
        nrClosed[i]=nrClosed[i-1];
        if(original[i]==OPEN)
            nrOpen[i]++;
        else
            nrClosed[i]++;
    }
    for(i=0; i<q; i++){
        scanf("%d%d", &st, &dr);
        st--;
        dr--;
        if(st>0)
            deschise=nrOpen[dr]-nrOpen[st-1];
        else
            deschise=nrOpen[dr];
        if(st>0)
            inchise=nrClosed[dr]-nrClosed[st-1];
        else
            inchise=nrClosed[dr];
        st=binary(st);
        dr=binary(dr);
        corecte=sum2End[dr]-sum2End[st];
        deschise-=corecte/2;
        inchise-=corecte/2;
        cout<<(deschise%2+deschise/2)<<'\n';
    }
    return 0;
}
