#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const int LG = 19;
const int N = 2e5 + 5;

int a[N], lg[N];
int rmq[LG][N];

int n;
void build() {
  for (int i = 1; i <= n; ++i) rmq[0][i] = a[i];
  for (int h = 1; h < LG; ++h) {
    for (int i = 1; i <= n; ++i) {
      rmq[h][i] = rmq[h - 1][i];
      if (i + (1 << (h - 1)) <= n) rmq[h][i] = min(rmq[h][i], rmq[h - 1][i + (1 << (h - 1))]);
    }
  }
}
int query(int l, int r) {
  if (l == r) return a[l];
  int L = lg[r - l + 1];
  return min(rmq[L][l], rmq[L][r - (1 << (L - 1)) + 1]);
}

int32_t main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  
  lg[1] = 0;
  for (int i = 2; i < N; ++i) lg[i] = lg[i / 2] + 1;
  
  int q, G;
  string s;
  cin >> n >> q >> G >> s;
  n *= 2;
  
  s = '$' + s;
  for (int i = 1; i <= n; ++i) {
    a[i] = a[i - 1];
    if (s[i] == '(') ++a[i];
    else --a[i];
  }
  for (int i = n + 1; i < N; ++i) a[i] = n + 100;
  build();
  
  cout << endl << endl;
  while (q--) {
    int l, r;
    cin >> l >> r;
    
    int minbal = query(l, r) - a[l - 1];
    int ans = (-minbal + 1) / 2;
    
    cout << ans << endl;
  }
}
/*
5 1 1
()))(()(()
7 10
*/
