#include <bits/stdc++.h>
using namespace std;

using ll = long long;

int32_t main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  
  int n, q, G;
  string s;
  cin >> n >> q >> G >> s;
  s = '$' + s;
  n *= 2;
  
  vector<int> lg(n + 1);
  lg[1] = 0;
  for (int i = 2; i <= n; ++i) lg[i] = lg[i / 2] + 1;
  const int LG = lg[n] + 1;
  
  vector<vector<int>> rmq(LG, vector<int>(n + 1));
  vector<int> a(n + 1);
  for (int i = 1; i <= n; ++i) {
    a[i] = a[i - 1];
    if (s[i] == '(') ++a[i];
    else --a[i];
    
    rmq[0][i] = a[i];
  }
  
  for (int h = 1; h < LG; ++h) {
    for (int i = 1; i <= n; ++i) {
      rmq[h][i] = rmq[h - 1][i];
      if (i + (1 << (h - 1)) <= n) rmq[h][i] = min(rmq[h][i], rmq[h - 1][i + (1 << (h - 1))]);
    }
  }
  
  auto query = [&](int l, int r) -> int {
    if (l == r) return a[l];
    int len = r - l + 1, L = lg[len];
    return min(rmq[L][l], rmq[L][r - (1 << (L - 1)) + 1]);
  };
  
  cout << endl << endl;
  while (q--) {
    int l, r;
    cin >> l >> r;
    
    int minbal = query(l, r) - a[l - 1];
    int ans = (-minbal + 1) / 2;
    
    cout << ans << endl;
  }
}
/*
5 1 1
()))(()(()
7 10
*/
