#include <iostream>
#include <algorithm>
#include <vector>
#include <climits>
#define mp make_pair

using namespace std;

const int nmax = 100005;

struct noduri{
int vecin, c;
};
int cost[nmax], fr[nmax], n, q;
vector<noduri> a[nmax];

static void Dfs(int nod)
{
    fr[nod] = 1;
    for(auto x : a[nod])
        if(!fr[x.vecin])
        {
            cost[x.vecin] = max(cost[nod], x.c);
            Dfs(x.vecin);
        }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> q;
    for(int i = 1; i < n; i ++)
    {
        int x, y, c;
        cin >> x >> y >> c;
        a[x].push_back({y, c});
        a[y].push_back({x, c});
    }

    for(int i = 1; i <= q; i ++)
    {
        int x, y;
        long long sumi = 0;
        cin >> x >> y;

        for(int p = 1; p <= n; p ++)
        {
            Dfs(p);
            for(int j = p + 1; j <= n; j ++)
                if(x <= cost[j] && y >= cost[j])
                    sumi += cost[j];

            for(int j = 1; j <= n; j ++)
                cost[j] = fr[j] = 0;
        }

        cout << sumi << '\n';
    }
    return 0;
}
