#include <iostream>
#include <vector>
using namespace std;

pair<int,int> v[1600001];
string s;

void build(int nod,int st,int dr){
    if(st==dr){
        if(s[st]==')') v[nod].first=1;
        else v[nod].second=1;
        return ;
    }
    int mij=(st+dr)/2;
    build(2*nod,st,mij);
    build(2*nod+1,mij+1,dr);
    if(v[2*nod].second>v[2*nod+1].first){
        v[nod].second=v[2*nod].second+v[2*nod+1].second-v[2*nod+1].first;
        v[nod].first=v[2*nod].first;
    }else{
        v[nod].second=v[2*nod+1].second;
        v[nod].first=v[2*nod].first+v[2*nod+1].first-v[2*nod].second;
    }

}

pair<int,int> query(int nod,int st,int dr,int a,int b){
    if(b<st || dr<a){
        return {0,0};
    }
    if(a<=st && dr<=b){
        ///printf("%d %d (%d %d)\n",st,dr,v[nod].second,v[nod].first);
        return v[nod];
    }
    int mij=(st+dr)/2;
    pair<int,int> f,s,aux;
    f=query(2*nod,st,mij,a,b);
    s=query(2*nod+1,mij+1,dr,a,b);
    if(f.second>s.first){
        aux.second=f.second+s.second-s.first;
        aux.first=f.first;
    }else{
        aux.second=s.second;
        aux.first=f.first+s.first-f.second;
    }///printf("%d %d %d | %d (%d %d)\n",st,dr,aux.first,f.second,f.first,s.first);
    return aux;
}

signed main()
{
    int n,q,g,i,a,b,j,rasp,st,dr;
    cin>>n>>q>>g>>s;
    s=" "+s;
    build(1,1,s.size());
    for(i=1;i<=q;i++){
        cin>>st>>dr;
        pair<int,int> aux=query(1,1,s.size(),st,dr);
        cout<<(aux.first+1)/2<<"\n";
    }
    return 0;
}
