#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

long long i, n, x, y, q, visited[1005], j, val;
vector<pair<int,int>> edges[1005];
vector<long long> sums;

void dfs(int org, int node, int s)
{
	visited[node] = 1;
	if (org < node)sums.push_back(s);
	for (int ind = 0; ind < edges[node].size(); ind++){
		if (visited[edges[node][ind].first] == 0)
		{
			visited[edges[node][ind].first] = 1;
			dfs(org, edges[node][ind].first, max(s, edges[node][ind].second));
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
    cin >> n >> q;
    for (i = 1; i < n; i++)
	{
		cin >> x >> y >> val;
		edges[x].push_back(make_pair(y, val));
		edges[y].push_back(make_pair(x, val));
	}
	for (i = 1; i <= n; i++)
	{
		for (j = 1; j <= n; j++) visited[j] = 0;
		dfs(i, i, 0);
	}
	sort(sums.begin(), sums.end());
	while (q--)
	{
		cin >> x >> y;
		int st = 0, dr = sums.size(), poz1, poz2, mij;
		while (st <= dr)
		{
			mij = (st+dr)/2;
			if (sums[mij] < x)
			{
				st = mij + 1;
			}
			else {
				poz1 = mij;
				dr = mij - 1;
			}
		}
		st = 0, dr = sums.size();
		while (st <= dr)
		{
			mij = (st+dr)/2;
			if (sums[mij] > y)
			{
				dr = mij - 1;
			}
			else {
				poz2 = mij;
				st = mij + 1;
			}
		}
		unsigned long long ans = 0;
		for (i = poz1; i <= poz2; i++)
		{
			ans+=sums[i];
		}
		cout << ans << '\n';
	}
    return 0;
}
