#include <iostream>
#include <vector>
#include <map>
using namespace std;

long long i, n, x, y, q, visited[100005], j, val;
vector<pair<int,int>> edges[100005];
vector<long long> sums;
map<int, long long> mp;

void dfs(int org, int node, int s)
{
	visited[node] = 1;
	if (org < node)sums.push_back(s);
	for (int ind = 0; ind < edges[node].size(); ind++){
		if (visited[edges[node][ind].first] == 0)
		{
			visited[edges[node][ind].first] = 1;
			dfs(org, edges[node][ind].first, max(s, edges[node][ind].second));
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
    cin >> n >> q;
    for (i = 1; i < n; i++)
	{
		cin >> x >> y >> val;
		edges[x].push_back(make_pair(y, val));
		edges[y].push_back(make_pair(x, val));
	}
	for (i = 1; i <= n; i++)
	{
		for (j = 1; j <= n; j++) visited[j] = 0;
		dfs(i, i, 0);
	}

	for (i = 0; i < sums.size(); i++)
	{
		mp[sums[i]] += 1LL*sums[i];
	}
	while (q--)
	{
		cin >> x >> y;
		long long ans = 0;
		for (auto it:mp)
		{
			if (it.first <= y && it.first >= x)
			{
				ans += it.second;
			}
		}
		cout << ans << '\n';
	}
    return 0;
}
