#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 2 * 100001
#define pii pair <int, int>
using namespace std;

pair <int, int> tree[4 * MAXN];
string s;

/**
tree[node] = '('.first and ').second
*/

void build (int node, int start, int end)
{
    if (start == end)
    {
        if (s[start - 1] == '(')
        {
            tree[node].first++;
        }
        else tree[node].second++;
        return;
    }

    int mid = (start + end) / 2;
    build(2 * node, start, mid);
    build(2 * node + 1, mid + 1, end);

    tree[node].first = tree[2 * node].first + tree[2 * node + 1].first;
    tree[node].second = tree[2 * node].second + tree[2 * node + 1].second;
}

int br = 0;

pair <int, int> query (int node, int start, int end, int le, int ri)
{
    if (ri < start || le > end) return {0, 0};
    if (start >= le && end <= ri)
    {
        return tree[node];
    }

    int mid = (start + end) / 2;
    pair <int, int> p1 = query(2 * node, start, mid, le, ri);
    pair <int, int> p2 = query(2 * node + 1, mid + 1, end, le, ri);

    if (p1.first + p2.first < p1.second + p2.second) br++;
    return {p1.first + p2.first, p1.second + p2.second};
}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, q, g;
    cin >> n >> q >> g;
    cin >> s;
    build (1, 1, s.size());
    for (int i = 0; i < q; i++)
    {
        int a, b;
        br = 0;
        cin >> a >> b;
        pair <int, int> t = query(1, 1, s.size(), a, b);
        cout << br << endl;
    }
}
