#include<bits/stdc++.h>
using namespace std;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

struct edge
{
    int ver,dist;
    edge(){};
    edge(int ve,int di)
    {
        ver=ve;
        dist=di;
    }
};

const int maxn=55;
int n,q;
vector<edge>v[maxn];
//int d[maxn];
bool used[maxn];
map<int,int>m;
long long ans[maxn];

void dfs(int node,int maxc)
{
    m[maxc]++;
    used[node]=true;
    for(int i=0;i<v[node].size();i++)
    {
        if(!used[v[node][i].ver])
        {
            dfs(v[node][i].ver,max(maxc,v[node][i].dist));
        }
    }
}

void read()
{
    cin>>n>>q;
    edge e(0,0);
    int a,b,c;
    for(int i=1;i<n;i++)
    {
        cin>>a>>b>>c;
        e.ver=b;
        e.dist=c;
        v[a].push_back(e);
        e.ver=a;
        v[b].push_back(e);
    }
    int l,r;
    for(int i=1;i<=n;i++)
    {
        dfs(i,0);
        memset(used,false,sizeof(used));
    }
    //for(int i=1;i<=n;i++)cout<<m[i]/2<<endl;
    for(int i=1;i<=n-1;i++)
    {
        ans[i]=ans[i-1]+(m[i]/2)*i;
    }
    for(int i=1;i<=q;i++)
    {
        cin>>l>>r;
        /*cout<<ans[r]<<endl;
        cout<<ans[l-1]<<endl;*/
        cout<<ans[r]-ans[l-1]<<endl;
    }
}

int main()
{
    speed();
    read();
}
