#include <iostream>
#include <vector>
#include <queue>
#include <map>
#include <cstring>
using namespace std;
int n, q;
int a[1005][1005];
struct edge
{
    int ver, w;
};
vector <edge> v[100005];
void read()
{
    cin >> n >> q;
    int ui, vi, wi;
    for(int i = 1; i < n; i++)
    {
        cin >> ui >> vi >> wi;
        v[ui].push_back({vi, wi});
        v[vi].push_back({ui, wi});
    }
}
int used[1024];
void BFS(int beg)
{
    queue <int> q;
    q.push(beg);
    used[beg] = 1;
    while(!q.empty())
    {
        int ver = q.front();
        q.pop();
        for(int i = 0; i < v[ver].size(); i++)
        {
            if(!used[v[ver][i].ver])
            {
                a[beg][v[ver][i].ver] = max(a[beg][ver], v[ver][i].w);
                ///cout << beg << " " << ver << " " << v[ver][i].ver << " " << a[beg][ver] << " " << v[ver][i].w << endl;
                q.push(v[ver][i].ver);
                used[v[ver][i].ver] = 1;
            }
        }
    }
}
void fill_a()
{
    for(int i = 1; i <= n; i++)
    {
        memset(used, 0, sizeof(used));
        BFS(i);
    }
}
map <int, int> m;
void fill_m()
{
    for(int i = 1; i < n; i++)
    {
        for(int j = i+1; j <= n; j++)
        {
            ///cout << i << " " << j << " " << a[i][j] << endl;
            m[a[i][j]]++;
        }
    }
}
void query(int l, int r)
{
    long long sum = 0;
    for(int i = l; i <= r; i++)
    {
        sum += m[i]*i;
    }
    cout << sum << endl;
}
void solve()
{
    int l, r;
    for(int i = 1; i <= q; i++)
    {
        cin >> l >> r;
        query(l, r);
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    fill_a();
    fill_m();
    solve();
    return 0;
}
