#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
#define left first.first
#define right first.second
#define id second
#define int3 pair<pair<int, int>, int>
char in[2000005];
int level[2000005];
int ans[2000005];
int prefMin[2000005];
int sufMin[2000005];

vector<int3> query;

void divAndConq(const vector<int3>& cur, int l, int r) {
//    cout << l << " " << r << " ";
//    cout << cur.size() << " <- l r size\n";
    if (l >= r || cur.size() == 0) {
        return;
    }
    int m = (l + r) / 2;
    vector<int3> to[2];
    vector<int3> now;
    int lBord = m, rBord = m;
    for (int i = 0; i < cur.size(); i++) {
        if (cur[i].left <= m && cur[i].right >= m) {
            now.push_back(cur[i]);
            lBord = min(lBord, cur[i].left);
            rBord = max(rBord, cur[i].right);
        } else {
            if (cur[i].left < m) {
                to[0].push_back(cur[i]);
            } else {
                to[1].push_back(cur[i]);
            }
        }
    }
    int curMin = level[m];
    for (int i = m; i >= lBord; i--) {
        curMin = min(curMin, level[i]);
        prefMin[i] = curMin;
    }
    sufMin[m] = level[m];
    curMin = level[m + 1];
    for (int i = m + 1; i <= rBord; i++) {
        curMin = min(curMin, level[i]);
        sufMin[i] = curMin;
    }
    for (int i = 0; i < now.size(); i++) {
//        cout << now[i].id << " " << prefMin[now[i].left] << " " << sufMin[now[i].right] << "\n";
        ans[now[i].id] = min(prefMin[now[i].left], sufMin[now[i].right]);
    }
    divAndConq(to[0], l, m - 1);
    divAndConq(to[1], m + 1, r);
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, q, g;
    cin >> n >> q >> g >> in;
    int curLevel = 0;
    for (int i = 0; i < 2 * n; i++) {
        if (in[i] == '(') {
            curLevel++;
        } else {
            curLevel--;
        }
        level[i] = curLevel;
    }
    for (int i = 0; i < q; i++) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        int temp = 0;
        for (int j = l; j <= r; j++) {
            temp = min(temp, level[j]);
        }
//        cout << temp << " ";
        query.push_back(make_pair(make_pair(l, r), i));
    }
    divAndConq(query, 0, 2 * n);
//    cout << "\n";
    for (int i = 0; i < q; i++) {
//        cout << ans[i] << " ";
        int rem = 0;
        if (query[i].left == 0) {
            rem = 0;
        } else {
            rem = level[query[i].left - 1];
        }
        cout << (-(ans[i] - rem) + 1) / 2 << "\n";
    }
}
