#include <bits/stdc++.h>
using namespace std;

void fastIO(){
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int N = 1e3+1;
int n, q;
vector<pair<int, int>> to[N];
map<int, int> cnt;
bool v[N];
int start;

void dfs(int curr, int pr){
    if(!v[curr]){
        if(pr > 0){
           cnt[pr]++;
           cout<<start<<" - "<<curr<<": "<<pr<<endl;
        }
        v[curr] = true;
    }
    for(auto &it:to[curr]){
        if(pr < it.second)dfs(it.first, it.second);
        else dfs(it.first, pr);
    }
    return;
}

int main(){
    fastIO();
    cin>>n>>q;
    for(int i=1; i<=n-1; i++){
        int a, b, c; cin>>a>>b>>c;
        to[a].push_back({b, c});
        to[b].push_back({a, c});
    }
    for(int i=1; i<=n; i++){
        memset(v, false, sizeof(v));
        start = i;
        dfs(i, 0);
    }
    for(int i=1; i<=5; i++){
        cout<<cnt[i]<<" ";
    }
    cout<<endl;
    while(q--){
        int l, r;
        cin>>l>>r;
        int sum = 0;
        for(int i=l; i<=r; i++){
            sum += cnt[i]*i;
        }
        cout<<sum<<endl;
    }
    return 0;
}

/*

7 5
1 2 1
3 1 3
1 4 1
4 5 2
5 7 4
3 6 2
1 4
2 3
2 4
1 3
2 5

*/











