#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N_max = 2e5 + 1;

int dp[N_max];
int pref[N_max];
int N, Q, G;
string s;

void precalc()
{
    int br = 0;

    for (int i = 1; i <= N; i++)
    {
        if (s[i] == '(')
        {
            br++;
        }
        else
        {
            br--;
        }

        pref[i] = br;
    }
}

struct SGT
{
    int t[4* N_max];

    void build(int node, int l, int r)
    {
        if (l == r)
        {
            t[node] = pref[l];

            return;
        }

        int mid = (l + r) / 2;

        build(2 * node, l, mid);
        build(2 * node + 1, mid + 1, r);

        t[node] = t[2 * node] + t[2 * node + 1];
    }

    int query(int node, int l, int r)
    {
        if (l == r)
        {
            return t[node];
        }

        int mid = (l + r) / 2;

        return min(query(2 * node, l, mid), query(2 * node + 1, mid + 1, r));
    }
};
SGT tree;

bool check(int l, int r)
{
    int mini = tree.query(1, 1, N);

    mini += pref[l - 1];

    return mini >= 0;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> N >> Q >> G;
    cin >> s;

    s = "#" + s;
    N *= 2;

    if (G <= 5)
    {
        int l, r;

        cin >> l >> r;

        int ans = 0;
        int maxi = 0, curr = 0;

        for (int i = 1; i <= N; i++)
        {
            if (s[i] == ')')
            {
                curr--;
            }
            else
            {
                curr++;
            }

            if (curr <= 0)
            {
                maxi = min(maxi, curr);
            }
        }

        maxi = -maxi;

        cout << maxi / 2 + maxi % 2 << endl;

        return 0;
    }

    if (G == 6)
    {
        precalc();
        tree.build(1, 1, N);

        while (Q--)
        {
            int l, r;

            cin >> l >> r;

            if (check(l, r))
            {
                cout << 0;
            }
            else
            {
                cout << 1;
            }

            cout << endl;
        }
    }

    return 0;
}
