#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const ll MAXN = 5e5 + 10;
const ll MAXLOG = 20;

ll n,q,g;
string s;
ll h[MAXN];
ll pref[MAXN];
ll minh[MAXN][MAXLOG];
ll lg[MAXN];

void read()
{
    cin >> n >> q >> g;
    n *= 2;
    cin >> s;
}

void fill_h()
{
    for(int i = 1; i <= n; i++)
    {
        h[i] = h[i - 1];
        if(s[i - 1] == '(')
            h[i]++;
        else
            h[i]--;
        minh[i][0] = h[i];
        ///cout << h[i] << " ";
    }
    ///cout << endl;
}

void fill_minh()
{
    for(int j = 1; j < MAXLOG; j++)
    {
        for(int i = 1; i <= n; i++)
        {
            minh[i][j] = min(minh[i][j - 1], minh[i + (1 << (j - 1))][j - 1]);
           /// cout << minh[i][j] << " ";
        }
       /// cout << endl;
    }
    for(int i = 2; i <= n; i++)
    {
        lg[i] = lg[i / 2] + 1;
    }
}

ll query_minh(ll left, ll right)
{
    ll len = right - left + 1;
    ll k = lg[len];

    ll cur_min = min(minh[left][k], minh[right - (1 << k) + 1][k]);

    return cur_min - h[left - 1];
}

void process_queries()
{
    for(int i = 1; i <= q; i++)
    {
        ll left, right;
        cin >> left >> right;
        ll c = query_minh(left, right);
        if(c < 0)
            cout << (llabs(c) + 1) / 2 << endl;
        else
            cout << 0 << endl;
    }
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    fill_h();
    fill_minh();
    process_queries();

    return 0;
}
