# include <iostream>
using namespace std;

const int MAX=4e5+11,INF=1e9;
int p[MAX];
int n,q,g;

int tree[MAX*4];

void build(int v=1, int l=1, int r=n)
{
    if(l==r)
    {
        tree[v]=p[l];
        return ;
    }

    int mid=(l+r)/2;
    build(v*2,l,mid);
    build(v*2+1,mid+1,r);
    tree[v]=min(tree[v*2],tree[v*2+1]);
}

int query(int le, int ri, int v=1, int l=1, int r=n)
{
    if(ri<l or r<le) return INF;
    if(le<=l and r<=ri) return tree[v];

    int mid=(l+r)/2;
    return min(query(le,ri,v*2,l,mid),query(le,ri,v*2+1,mid+1,r));
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n>>q>>g;
    n*=2;
    for(int i=1;i<=n;i++)
    {
        char x;
        cin>>x;

        p[i]=p[i-1];
        if(x=='(') p[i]++;
        else p[i]--;
    }

    build();
    while(q--)
    {
        int l,r;
        cin>>l>>r;

        int ans=query(l,r)-p[l-1];
        if(ans>=0) cout<<0<<"\n";
        else cout<<(-ans+1)/2<<"\n";
    }

    return 0;
}

