#include<bits/stdc++.h>
using namespace std;

#define endl '\n'
#define out(x) #x << " = " << x << " "

const int INF = 1e9 + 10;
const int MAX_N = 1e5 + 10;
const int MAX_W = 1e9 + 10;
int n, q;

vector <pair <int, int>> susNa[MAX_N];

unordered_map<int, int> um;

bool visited[MAX_N];
void bfs(int start) {
    memset(visited, false, sizeof(visited));

    queue<pair<int, int>> q;
    q.push({start, 0});



    while (!q.empty()) {
        int curr = q.front().first;
        int weight = q.front().second;
        q.pop();

        if (visited[curr]) continue;

        visited[curr] = true;

        for (int i = 0; i < susNa[curr].size(); i ++) {
            int sus = susNa[curr][i].first;
            int wgh = susNa[curr][i].second;

            if (visited[sus]) continue;

            int new_w = max(weight, wgh);
            if (start < sus) um[new_w] += new_w;
            q.push({sus, new_w});
        }
    }
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> q;

    for (int i = 0; i < n - 1; i ++) {
        int a, b, w;
        cin >> a >> b >> w;

        susNa[a].push_back({b, w});
        susNa[b].push_back({a, w});
    }

    //for (int i = 1; i <= n; i ++) {
        bfs(0);
    //}


    for (int i = 0; i < q; i ++) {
        int a, b;
        cin >> a >> b;
        int ans = 0;
        for (int j = a; j <= b; j ++) {
            ans += um[j];
        }
        cout << ans << endl;
    }
    return 0;
}

