#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

const long long MAX=(1e6);

long long n,k,p[MAX],r[MAX],z[MAX],pre[MAX],idx=0;

unordered_map<long long,long long>htol,ltoh;

struct Cell
{
    long long x,y,w;
} a[MAX],q[MAX];

bool Cmp(Cell a,Cell b)
{
    return a.w<b.w;
}

long long FindL(long long i)
{
    if(p[i]==i)
        return i;
    return p[i]=FindL(p[i]);
}

void Connect(long long i,long long j,long long op)
{
    i=FindL(i);
    j=FindL(j);
    z[op]+=r[i]*r[j];
    p[j]=i;
    r[i]+=r[j];
}

vector<long long>v;

void Read()
{
    cin>>n>>k;
    for(long long i=1; i<n; i++)
    {
        cin>>a[i].x>>a[i].y>>a[i].w;
        v.push_back(a[i].w);
    }
    sort(a+1,a+n,Cmp);
    for(long long i=1; i<=k; i++)
    {
        cin>>q[i].x>>q[i].y;
        v.push_back(q[i].x);
        v.push_back(q[i].y);
    }
    sort(v.begin(),v.end());
    for(long long i=0; i<v.size(); i++)
    {
        if(i==0||v[i]!=v[i-1])
            idx++;
        htol[v[i]]=idx;
        ltoh[idx]=v[i];
    }
    for(long long i=1; i<=n; i++)
    {
        p[i]=i;
        r[i]=1;
    }
}

void Solve()
{
    Read();
    for(long long i=1; i<n; i++)
    {
        Connect(a[i].x,a[i].y,htol[a[i].w]);
    }
    for(long long i=1; i<=idx; i++)
    {
        pre[i]=pre[i-1]+z[i]*ltoh[i];
        //cout<<z[i]<<endl;
    }
    for(long long i=1; i<=k; i++)
    {
        cout<<pre[htol[q[i].y]]-pre[htol[q[i].x]-1]<<endl;
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    Solve();
    return 0;
}
