#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define MP make_pair
#define pb push_back
#define ppb pop_back
#define PII pair <int, int>
#define endl '\n'
#define all(v) (v).begin(), (v).end()
#define lower lower_bound
#define upper upper_bound
#define checking cout << "OK" << endl

void fastIO(){
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
}

const int N = 1007;
int n, q;
vector <pair <int, ll> > T[N];
vector <ll> dist(N), prices[N], pref[N];

void dfs(int node, int parent, int d){
    for(PII u : T[node]){
        if(u.first == parent){
            continue;
        }
        dist[u.first] = max(d, u.second);
        dfs(u.first, node, max(d, u.second));
    }
}

int main(){
    fastIO();

    cin >> n >> q;
    for(int i = 1; i <= n - 1; i++){
        ll u, v, w;
        cin >> u >> v >> w;

        T[u].pb(MP(v, w));
        T[v].pb(MP(u, w));
    }

    for(int i = 1; i <= n; i++){
        dist.clear();
        dfs(i, -1, 0);

        for(int j = 1; j <= n; j++){
            if(j == i){
                continue;
            }
            prices[i].pb(dist[j]);
        }

        sort(all(prices[i]));
    }

    for(int i = 1; i <= n; i++){
        pref[i].assign(N, 0);
        //cout << i << ") ";
        for(int j = 0; j < prices[i].size(); j++){
            //cout << prices[i][j] << ' ';
            pref[i][j + 1] = pref[i][j] + prices[i][j];
        }
        //cout << endl;
    }

    while(q--){
        ll x, y;
        cin >> x >> y;

        ll ans = 0;
        for(int i = 1; i <= n; i++){
            int a = upper(all(prices[i]), y) - prices[i].begin();
            int b = lower(all(prices[i]), x) - prices[i].begin();

            //cout << pref[i][a] - pref[i][b] << endl;
            ans += pref[i][a] - pref[i][b];
        }

        cout << ans / 2 << endl;
    }

    return 0;
}