#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define all(v) v.begin(),v.end();

const int N = 1e5+10;

vector<pair<int,ll>>adj[N];
int n, q;
ll ans, mx[N], mx2[N];
ll sub[N];
map<ll, ll>m;
map<pair<int,int>, bool> used;
bool visited[N];

void dfs(int node, int gp, ll curr_mx)
{
    visited[node] = true;
    for(auto i : adj[node])
    {
        if(visited[i.first]) continue;
        mx[i.first] = max(curr_mx, i.second);
        int a = gp, b = i.first;
        if(a < b)
        {
            swap(a, b);
        }
        if(!used[{b, a}])
        {
            m[mx[i.first]]++;
            used[{b, a}] = true;
        }
        dfs(i.first, gp, mx[i.first]);
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    cin >> n >> q;
    for(int i = 1; i < n; i++)
    {
        int u, v, w;
        cin >> u >>v >> w;
        adj[u].push_back({v,w});
        adj[v].push_back({u,w});
    }
    for(int i = 1; i <= n; i++)
    {
        memset(mx, 0, sizeof(mx));
        memset(visited,false,sizeof(visited));
        dfs(i, i, 0LL);
    }
    while(q--)
    {
        int l, r;
        cin >> l >> r;
        ll ans = 0;
        for(int i = l; i <= r; i++)
        {
            ans += m[i] * i;
        }
        cout << ans << '\n';
    }
    return 0;
}