#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define INF 1000000000
struct DSU{
    int n;
    vector<ll> p;
    DSU(int si){
        n = si;
        p.assign(n, -1);
    }
    int fin(int u){
        if (p[u] < 0){
            return u;
        }
        p[u] = fin(p[u]);
        return p[u];
    }
    void merg(int u, int v){
        u = fin(u);
        v = fin(v);
        if (abs(p[u]) < abs(p[v])){
            swap(u, v);
        }
        p[u] += p[v];
        p[v] = u;
    }
};

int main(){
    vector<vector<ll>> v;
    ll ans = 0;
    int n, q, a, b, c, l, r;
    cin>>n>>q;
    DSU ds(n + 1);
    for (int i = 0; i < n - 1; i++){
        cin>>a>>b>>c;
        v.push_back({c, a, b});
    }
    vector<vector<ll>> so;
    vector<ll> pr(n);
    pr[0] = 0;
    sort(v.begin(), v.end());
    for (auto el : v){
        int u = ds.fin(el[1]), v = ds.fin(el[2]);
        so.push_back({el[0], ds.p[u] * ds.p[v] * el[0]});
        ds.merg(u, v);
    }
    sort(so.begin(), so.end());
    vector<vector<int>> pri;
    vector<vector<ll>> que(q);
    for (int i = 0; i < q; i++){
        cin>>l>>r;
        pri.push_back({l - 1, i});
        pri.push_back({r, i});
    }
    sort(pri.begin(), pri.end());
    ll su = 0, ind = 0;
    for (int i = 0; i < pri.size(); i++)
    {
        for (; ind < n - 1 && pri[i][0] >= so[ind][0]; ind++){
            su += so[ind][1];
        }
        que[pri[i][1]].push_back(su);
    }
    for (int i = 0; i < q; i++){
        cout<<max(que[i][0], que[i][1]) - min(que[i][0], que[i][1])<<"\n";
    }
}