#include <bits/stdc++.h>
#include <unistd.h>
#include <ext/pb_ds/assoc_container.hpp> 
#include <ext/pb_ds/tree_policy.hpp> 
#define run  ios_base::sync_with_stdio(false);cin.tie(0);
 
#define ll long long
#define pll pair<ll, ll>
#define plll pair<pair<ll, ll>, ll>
#define ull unsigned ll
#define ld double
#define endl "\n"
#define pb push_back
#define fi first
#define se second
 
#define pi 3.14159265
#define N 1007
#define minimum -9223372036854775807
#define maximum -minimum
#define mod 1000000007

using namespace std;
using namespace __gnu_pbds;
template <class t>
using ordered_set=tree<t, null_type,less<t>, rb_tree_tag,tree_order_statistics_node_update>;

ll n, q;
vector<ll>v[N];
bool used[N];
ll dp[N][N], par[N], cost[N][N];
map<ll, ll>mp;

void dfs(ll start, ll node)
{
	used[node]=1;
	if(node==start)
	{
		dp[start][node]=0;
	}
	else
	{
		dp[start][node]=max(dp[start][par[node]], cost[par[node]][node]);
	}
	for(ll i:v[node])
	{
		if(!used[i])
		{
			par[i]=node;
			dfs(start, i);
		}
	}
}

ll a[N], t[N*4];

void build(ll node, ll l, ll r)
{
	if(l==r)
	{
		t[node]=a[l];
		return;
	}
	ll mid=(l+r)/2;
	build(node*2, l, mid);
	build(node*2+1, mid+1, r);
	t[node]=t[node*2]+t[node*2+1];
}

ll get(ll node, ll l, ll r, ll ql, ll qr)
{
	if(qr<l || r<ql)
		return 0;
	if(ql<=l && r<=qr)
		return t[node];
	ll mid=(l+r)/2;
	return get(node*2, l, mid, ql, qr)+get(node*2+1, mid+1, r, ql, qr);
}

int main()
{
    run;
	cin>>n>>q;
	for(ll i=1; i<n; i++)
	{
		ll x, y, z;
		cin>>x>>y>>z;
		cost[x][y]=z;
		cost[y][x]=z;
		v[x].pb(y);
		v[y].pb(x);
	}
	for(ll i=1; i<=n; i++)
	{
		memset(used, 0, sizeof(used));
		dfs(i, i);
	}
	for(ll i=1; i<=n; i++)
	{
		for(ll j=i+1; j<=n; j++)
		{
			// cout<<i<<" "<<j<<"= "<<dp[i][j]<<" ";
			mp[dp[i][j]]++;
		}
	}
	ll k=1;
	ll maxx=minimum;
	for(ll i=1; i<=n; i++)
	{
		a[i]=i*mp[i];
	}
	build(1, 1, n);
	while(q--)
	{
		ll l, r;
		cin>>l>>r;
		cout<<get(1, 1, n, l, r)<<endl;
	}
}
/*
7 5
1 2 1
3 1 3
1 4 1
4 5 2
5 7 1000
3 6 2
1 2
2 3
5 6
3 9
899 1000
*/
// By Xanlar