#include<bits/stdc++.h>
#define ll long long
#define ld long double
#define vl vector<ll>
#define vi vector<int>
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define pii pair<int, int>
#define pll pair<ll, ll>
#define f first
#define s second
#define pb push_back
#define p_b pop_back
using namespace std;
const ll sz = 1e5+5;
vl g[sz];
ll lev[sz], subtree[sz], st[4*sz], p[sz], id[sz], val[sz], tp[sz], vis[sz], intime[sz], outtime[sz], n, k = 1, t = 1;
void dfs(ll node)
{
    vis[node] = 1;
    subtree[node] = 1;
    intime[node] = t++;
    for(auto u : g[node])
    {
        if(vis[u])
            continue;
        lev[u] = lev[node] + 1;
        p[u] = node;
        dfs(u);
        subtree[node] += subtree[u];
    }
    outtime[node] = t++;
}
void update(ll idx, ll val)
{
    st[idx+=n] = val;
    for(idx /= 2; idx; idx /= 2)
        st[idx] = max(st[2*idx], st[2*idx+1]);
}
ll query(ll l, ll r)
{
    ll x = 0, y = 0;
    for(l += n, r += n + 1; l < r; l /= 2, r /= 2)
    {
        if(l & 1)
            x = max(x, st[l++]);
        if(r & 1)
            y = max(y, st[--r]);
    }
    return max(x, y);
}
void dfs_hld(ll node, ll par, ll top)
{
    id[node] = k++;
    tp[node] = top;
    update(id[node], val[node]);
    ll h_chi = -1, h_sz = -1;
    for(auto u : g[node])
    {
        if(u == par)
            continue;
        if(subtree[u] > h_sz)
        {
            h_sz = subtree[u];
            h_chi = u;
        }
    }
    if(h_chi == -1)
        return;
    dfs_hld(h_chi, node, top);
    for(auto u : g[node])
    {
        if(u == par || u == h_chi)
            continue;
        dfs_hld(u, node, u);
    }
}
ll path(ll x, ll y)
{
    ll k = 0;
    while(lev[tp[x]] != lev[tp[y]])
    {
        if(lev[tp[x]] < lev[tp[y]])
            swap(x, y);
        k = max(k, query(id[tp[x]], id[x]));
        x = p[tp[x]];
    }
    if(lev[x] > lev[y])
        swap(x, y);
    k = max(k, query(id[x], id[y]));
    return k;
}
void solve()
{
    ll q, i, j;
    cin >> n >> q;
    vector<pair<ll, pll>>edges;
    for(i = 0; i < n - 1; i++)
    {
        ll x, y, z;
        cin >> x >> y >> z;
        g[x].pb(y);
        g[y].pb(x);
        edges.pb({z, {x, y}});
    }
    dfs(1);
    for(auto u : edges)
    {
        ll z = u.f, x = u.s.f, y = u.s.s;
        if(p[x] == y)
            val[x] = z;
        else
            val[y] = z;
    }
    dfs_hld(1, 1, 1);
    map<ll, ll>mp;
    for(i = 1; i <= n; i++)
    {
        for(j = i + 1; j <= n; j++)
        {
            ll cost;
            if((intime[i] > intime[j] && outtime[i] < outtime[j]) || (intime[i] < intime[j] && outtime[i] > outtime[j]))
            {
                if(intime[i] > intime[j] && outtime[i] < outtime[j])
                {
                    ll v = val[j];
                    update(id[j], 0);
                    cost = path(i, j);
                    update(id[j], v);
                }
                else
                {
                    ll v = val[i];
                    update(id[i], 0);
                    cost = path(i, j);
                    update(id[i], v);
                }
            }
            else
                cost = path(i, j);
            mp[cost]++;
        }
    }
    while(q--)
    {
        ll l, r, ans = 0;
        cin >> l >> r;
        for(auto u : mp)
        {
            if(u.f >= l && u.f <= r)
                ans += (u.f * u.s);
        }
        cout << ans << "\n";
    }
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll tests = 1;
    //cin >> tests;
    while(tests--)
    {
        solve();
    }
}
