#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define F first
#define S second
#define sz(x) int(x.size())
#define all(x) x.begin(),x.end()
ll n, q, p[100000], sz[100000], cur, nxt = 0;
pair<ll, ll> vv[100000];
ll pref[100000];

int findp(int u) {
    return p[u] = (p[u] == u ? u : findp(p[u]));
}

void merge(int u, int v) {
    u = findp(u), v = findp(v);
    if (sz[u] < sz[v])swap(u, v);
    vv[nxt++] = make_pair(cur, ll(sz[u]) * ll(sz[v]));
    sz[u] += sz[v];
    p[v] = u;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> q;
    if (n == 1) {
        while (q--) {
            int l, r;
            cin >> l >> r;
            cout << 0 << "\n";
        }
        return 0;
    }
    vector<array<int, 3>> eds(n-1);
    for (int i = 0; i+1 < n; i++) {
        p[i] = i;
        sz[i] = 1;
        cin >> eds[i][1] >> eds[i][2] >> eds[i][0];
        --eds[i][1], --eds[i][2];
    }
    p[n-1] = n-1;
    sz[n-1] = 1;
    sort(all(eds));
    for (int i = 0; i+1 < n; i++) {
        int j = i;
        cur = eds[i][0];
        merge(eds[i][1], eds[i][2]);
        while (j+2 < n && eds[j+1][0] == eds[i][0]) {
            j++;
            merge(eds[j][1], eds[j][2]);
        }
        i = j;
    }
    sort(vv, vv+n-1);
    for (int i = 0; i+1 < n; i++) {
        pref[i] = (i ? pref[i-1] : 0) + vv[i].S * vv[i].F;
    }
    while (q--) {
        ll l, r;
        cin >> l >> r;
        ll st = 0, ed = n-2, f = -1, ss = -1;
        while (st <= ed) {
            ll m = (st + ed) >> 1;
            if (vv[m].F >= l) {
                f = m;
                ed = m-1;
            } else {
                st = m+1;
            }
        }
        if (~f) {
            st = f, ed = n-2;
            while (st <= ed) {
                ll m = (st + ed) >> 1;
                if (vv[m].F <= r) {
                    ss = m;
                    st = m+1;
                } else {
                    ed = m-1;
                }
            }
            cout << (~ss ? pref[ss] - (f ? pref[f-1] : 0) : 0) << "\n";
        } else {
            cout << 0 << "\n";
        }
    }
}