#include <bits/stdc++.h>

using namespace std;

#define int long long

const int N = 2e5+5;
vector<pair<int, int>>adj[N];
int vis[N];
int ans = 0;

void dfs(int src, int maxi, int l, int r)
{
	if(src >= l && src <= r)
	{
		ans += maxi;
	}
	vis[src] = true;
	for(auto [it, c]:adj[src])
	{
		if(vis[it]) continue;
		maxi = max(maxi, c);
		dfs(it, maxi,l, r);
	}
}

signed main()
{
	ios_base::sync_with_stdio();
	cin.tie();
	cout.tie();
	int n, q;
	cin >> n >> q;
	for(int i = 0; i < n-1; i++)
	{
		int u, v, w;
		cin >> u >> v >> w;
		adj[u].push_back({v, w});
		adj[v].push_back({u, w});
	}
	while(q--)
	{
		int l, r;
		cin >> l >> r;
		ans = 0;
		memset(vis, 0, sizeof(vis));
		vector<int>v(n+1);
		for(int i = 1; i <= n; i++)
		{
			//cout << "       " << i << "   \n";
			//dfs(i, 0,l, r);
			queue<int>q;
			q.push(i);
			vector<int>dep(n+1);
			while(q.size())
			{
				int u = q.front();
				vis[u] = true;
				q.pop();
				v[dep[u]]++;
				for(auto [it, c]:adj[u])
				{
					if(vis[it]) continue;
					dep[it] = max(dep[u], c);
					q.push(it);
				}
			}
			//cout << endl;
			memset(vis, 0, sizeof(vis));
		}
		for(int i = l; i <= r; i++) 
		{
			//cout << i << ' ' << v[i] << endl;
			ans += v[i]/2*i;
		}
		cout << ans << endl;
	}
}