#include <bits/stdc++.h>

using namespace std;

#define int long long

const int N = 2e5+5;
vector<pair<int, int>>adj[N];
int vis[N];
int ans = 0;

signed main()
{
    ios_base::sync_with_stdio();
    cin.tie();
    cout.tie();
    int n, q;
    cin >> n >> q;
    for(int i = 0; i < n-1; i++)
    {
        int u, v, w;
        cin >> u >> v >> w;
        adj[u].push_back({v, w});
        adj[v].push_back({u, w});
    }
    memset(vis, 0, sizeof(vis));
    map<int, int>mp;
    for(int i = 1; i <= n; i++)
    {
        queue<int>q;
        q.push(i);
        vector<int>dep(n+1);
        while(q.size())
        {
            int u = q.front();
            vis[u] = true;
            q.pop();
            mp[dep[u]]++;
            for(auto [it, c]:adj[u])
            {
                if(vis[it]) continue;
                dep[it] = max(dep[u], c);
                q.push(it);
            }
        }
   	 	memset(vis, 0, sizeof(vis));
    }
    while(q--)
    {
        int l, r;
        cin >> l >> r;
        ans = 0;
        for(int i = l; i <= r; i++)
        {
        	ans += mp[i]*i;
        	//cout << i << ' ' << mp[i] << ' ' << ans << endl;
        }
        cout << ans/2 << endl;
    }
}