#include <iostream>
#include <vector>
#include <stack>
#include <deque>

#define ll long long

using namespace std;

void fastIO() {
  ios_base::sync_with_stdio(false);
  cin.tie();
  cout.tie();
}

void setIO() {
  freopen("input.in", "r", stdin);
  freopen("output.out", "w", stdout);
}

int main() {

  setIO();
  fastIO();

  int q;
  cin >> q;
  vector <int> v;
  vector <pair<int,int>> que(q);
  for (pair <int, int>& p : que)
    cin >> p.first >> p.second;
  
  for (pair <int, int> p : que)
    if (p.first == p.second || p.first % p.second == 0 || p.second % p.first == 0)
      v.push_back(max(p.first, p.second) - 1);

  for (int i = 0; i < q; i++)
    cout << v[i] << " ";
  cout << "\n";

  if (v[0] == max(que[0].first, que[0].second) - 1) {
    int num = 1;
    if (max(que[0].first, que[0].second) == que[0].first)
      num *= -1;
    for (int i = 0; i < max(que[0].first, que[0].second) - 1; i++)
      cout << num << " ";
  }

  return 0;
}