#include <bits/stdc++.h>

using namespace std;
using ll = int;

struct Tree {
	struct Node {
		ll v, L, R;
		ll l, r;
		Node() = default;
		Node(ll v, ll L, ll R, ll l, ll r): v(v), L(L), R(R), l(l), r(r) {}
	};

	vector<Node> W;
	vector<ll> v;
	ll n;

	ll build(ll L, ll R) {
		if (L + 1 == R) {
			W.push_back(Node(v[L], L, R, -1, -1));
			return W.size() - 1;
		}
		ll l = build(L, (L + R) / 2);
		ll r = build((L + R) / 2, R);
		W.push_back(Node(min(W[l].v, W[r].v), L, R, l, r));
		return W.size() - 1;
	}

	Tree(vector<ll>& v): v(v) {
		ll n = v.size();
		build(0, n);
	}

	ll get(ll r, ll L, ll R) {
		if (R <= W[r].L || W[r].R <= L) return 1e9;
		if (L <= W[r].L && W[r].R <= R) return W[r].v;
		return min(get(W[r].l, L, R), get(W[r].r, L, R));
	}

	ll Get(ll L, ll R) {
		return get(W.size() - 1, L, R);
	}	
};

int main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(0);
	int n, q, g;
	cin >> n >> q >> g;
	n *= 2;
	vector<ll> v(n), pt(n);
	for (int i = 0; i < n; i++) {
		char x;
		cin >> x;
		v[i] = x == '(';
	}
	pt[0] = (v[0] ? 1 : -1);
	for (int i = 0; i < n; i++) {
		pt[i] = pt[i - 1];
		if (v[i]) {
			pt[i]++;
		} else {
			pt[i]--;
		}
	}

	Tree t(pt);

	for (int i = 0; i < q; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		cout << ( -t.Get(a, b) + (a > 0 ? pt[a - 1] : 0) + 1) / 2 << endl;
	}
}