#include <bits/stdc++.h>

using namespace std;

int N = 1, n;

struct Node{
    int l, r;
    int val = 1e9;
};

vector<Node> tr;
vector<int> pref;

void build(int i = 1, int l = 0, int r = N) {
    tr[i].l = l;
    tr[i].r = r;
    if (r - l == 1) {
        if (l < 2 * n) {
            tr[i].val = pref[l];
        }
        return;
    }
    int m = (l + r) / 2;
    build(2 * i, l, m);
    build(2 * i + 1, m, r);
    tr[i].val = min(tr[2 * i].val, tr[2 * i + 1].val);
}

int get(int ql, int qr, int i = 1) {
    if (tr[i].l >= qr || ql >= tr[i].r) {
        return 1e9;
    }
    if (ql <= tr[i].l && tr[i].r <= qr) {
        return tr[i].val;
    }
    return min(get(ql, qr, 2 * i), get(ql, qr, 2 * i + 1));
}

int main() {
    int q, g;
    cin >> n >> q >> g;
    string s;
    cin >> s;
    pref.resize(2 * n);
    int bal = 0, mi = 0;
    for (int i = 0; i < 2 * n; i++) {
        pref[i] = bal;
        if (s[i] == '(') {
            bal++;
        } else {
            bal--;
        }
    }
    while (N < 2 * n) {
        N *= 2;
    }
    tr.resize(2 * N + 1);
    build();
    //cout << __LINE__ << endl;
    while (q--) {
        int l, r;
        cin >> l >> r;
        l--;
        int mi = min(0, get(l + 1, r) - pref[l]);
        cout << ((-mi) + 1) / 2 << endl;
    }
}