#include <bits/stdc++.h>

using namespace std;

#define int long long

vector<vector<pair<int, pair<int, int>>>> gr;
vector<vector<int>> vr;
int cur_used = 1;
int curi = 0;
vector<int> used;

int dfs(int i, int maxw) {
    used[i] = cur_used;
    int ans = 1;
    for (auto &j : gr[i]) {
        if (used[j.first] != cur_used && (j.second.first < maxw || (j.second.first == maxw && j.second.second < curi))) {
            ans += dfs(j.first, maxw);
        }
    }
    //cout << i << " " << ans << endl;
    return ans;
}

signed main() {
    int n, q;
    cin >> n >> q;
    gr.resize(n);
    used.resize(n);
    vector<int> f;
    for (int i = 1; i < n; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        vr.push_back({u, v, w});
        gr[v].push_back({u, {w, i - 1}});
        gr[u].push_back({v, {w, i - 1}});
        f.push_back(w);
    }
    vector<pair<int, int>> v;
    for (int i = 0; i < n - 1; i++) {
        curi = i;
        v.push_back({vr[i][2], dfs(vr[i][0], vr[i][2]) * dfs(vr[i][1], vr[i][2])});
        //cout << v[i].first << " " << v[i].second << endl;
        cur_used++;
    }
    sort(v.begin(), v.end());
    vector<int> pref(n, 0);
    for (int i = 1; i < n; i++) {
        pref[i] = pref[i - 1] + v[i - 1].first * v[i - 1].second;
        //cout << pref[i] << endl;
    }
    while (q--) {
        int l, r;
        cin >> l >> r;
        int nl = lower_bound(f.begin(), f.end(), l) - f.begin() - 1;
        int nr = upper_bound(f.begin(), f.end(), r) - f.begin();
        //cout << nl << " " << nr << endl;
        cout << pref[nr] - pref[nl + 1] << endl;
    }
}