#include<bits/stdc++.h>

using namespace std;

const int MAXN = (2e5)+31;

int tree[MAXN];
int pref[MAXN];

void build(int id, int l, int r){
    if(l == r){
        tree[id] = pref[l];
        return;
    }
    int m = (r+l)/2;
    build(id*2, l, m);
    build(id*2+1, m+1, r);
    tree[id] = min(tree[id*2], tree[id*2+1]);
}

int get(int id, int l, int r, int lq, int rq){
    if(rq < l || r < lq) return MAXN+1;
    if(lq <= l && r <= rq) return tree[id];
    int m = (r+l)/2;
    return min(get(id*2, l, m, lq, rq), get(id*2+1, m+1, r, lq, rq));
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, q, g;
    cin >> n >> q >> g;
    n*=2;
    string s;
    cin >> s;
    for(int i = 1; i <= n; i++){
        pref[i] = pref[i-1];
        if(s[i-1] == '(') pref[i]++;
        else pref[i]--;
    }
    build(1, 1, n);
    while(q--){
        int l, r;
        cin >> l >> r;
        int mn = min(get(1, 1, n, l, r)-pref[l-1], 0);
        cout << (abs(mn)+1)/2 << "\n";
    }
}
