#include<iostream>
#include<vector>
#include<string>

using namespace std;

const long long LOG = 18;

int main() {
	long long n, q, g;
	cin >> n >> q >> g;
	string s;
	cin >> s;
	vector<long long> bal(2 * n + 1);
	for (long long i = 1; i <= 2 * n; i++) {
		if (s[i - 1] == '(') {
			bal[i] = bal[i - 1] + 1;
		} else {
			bal[i] = bal[i - 1] - 1;
		}
	}
	vector<vector<long long>> sparse(LOG, vector<long long> (2 * n + 1));
	sparse[0] = bal;
	for (long long i = 1; i < LOG; i++) {
		for (long long j = 0; j + (1 << i) <= 2 * n + 1; j++) {
			sparse[i][j] = min(sparse[i - 1][j], sparse[i - 1][j + (1 << (i - 1))]);
		}
	}
	vector<long long> max2(2e5 + 10);
	for (long long i = 2; i < 2e5 + 10; i++) {
		max2[i] = max2[i / 2] + 1;
	}
	while (q--) {
		long long l, r;
		cin >> l >> r;
		r++;
		long long h = max2[r - l];
		if (r - (1 << h) < 0) {
			cout << -1 << endl;
		}
		long long minimum = min(sparse[h][l], sparse[h][r - (1 << h)]);
		minimum -= bal[l - 1];
		if (minimum >= 0) {
			cout << 0 << endl;
		} else {
			cout << 1 << endl;
		}
	}
}