#include<iostream>
#include<vector>

using namespace std;

vector<vector<pair<int, int>>> g;

long long dfs(int v, int p, int l, int r, int mx) {
	if (mx > r) {
		return 0;
	}
	long long ans = 0;
	if (l <= mx) {
		//cout << v << " ";
		ans += mx;
	}
	for (auto &i : g[v]) {
		if (i.first == p) {
			continue;
		}
		ans += dfs(i.first, v, l, r, max(mx, i.second));
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, q;
	cin >> n >> q;
	g.resize(n);
	for (int i = 0; i < n - 1; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		u--;
		v--;
		g[u].push_back({v, w});
		g[v].push_back({u, w});
	}
	while (q--) {
		int l, r;
		cin >> l >> r;
		long long ans = 0;
		for (int i = 0; i < n; i++) {
			//cout << i << endl;
			ans += dfs(i, -1, l, r, 0);
			//cout << endl;
		}
		cout << ans / 2 << "\n";
		//cout << endl;
	}
}