#include<iostream>
#include<vector>
using namespace std;

long long first_x = -1, first_y = -1;
vector<long long> prefsums = {0}, ans;


long long rec(long long x, long long y) {
	if (first_x == -1) {
		if (ans.size() < prefsums.size()) {
			ans = prefsums;
		}
	}
	long long len = prefsums.size() - 1;
	//cout << len << endl;
	for (long long i = -7; i <= 7; i++) {
		prefsums.push_back(i + prefsums.back());
		bool good = true;
		if (prefsums.size() > x) {
			long long summ = prefsums.back() - prefsums[prefsums.size() - x - 1];
			if (summ <= 0) {
				good = false;
			}
		}
		if (prefsums.size() > y) {
			long long summ = prefsums.back() - prefsums[prefsums.size() - y - 1];
			if (summ >= 0) {
				good = false;
			}
		}
		if (good) {
			len = max(len, rec(x, y));
		}
		prefsums.pop_back();
	}
	return len;
}

int main() {
	long long q;
	cin >> q;
	while (q--) {
		long long x, y;
		cin >> x >> y;
		cout << rec(x, y) << " ";
		if (first_x == -1) {
			first_x = x;
			first_y = y;
		}
	}
	cout << endl;
	vector<long long> answer;
	for (long long i = 1; i < ans.size(); i++) {
		answer.push_back(ans[i] - ans[i - 1]);
	}
	for (auto &i : answer) {
		cout << i << " ";
	}
}