#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int N = 1e5 + 2;

vector<int> g[N];
bool bad = false;
void dfs (int v, vector<int>& used) {
    used[v] = 1;
    for (auto to : g[v]) {
        if (!used[to]) {
            dfs (to, used);
        }
        else if (used[to] == 1) {
            bad = true;
        }
    }
    used[v] = -1;
}
bool check (int len, int x, int y) {
    bad = false;
    vector<int> used (len + 1, false);
    for (int i = 1; i <= len; ++i) g[i].clear ();
    for (int i = 1; i <= len; ++i) {
        if (i - x >= 0) {
            g[i - x].push_back (i);
        }
        if (i + y - 1 <= len) {
            g[i + y - 1].push_back (i - 1);
        }
    }
    for (int i = 0; i <= len; ++i) {
        if (!used[i]) {
            dfs (i, used);
        }
    }
    return !bad;
}
void top (int v, vector<bool>&used, vector<int>&ans) {
    used[v] = 1;
    for (auto to : g[v]) {
        if (!used[to]) {
            top (to, used, ans);
        }
    }
    ans.push_back(v);
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int Q;
    cin >> Q;
    int n = Q;
    vector<int> a (n + 1), b (n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> a[i] >> b[i];
        int l = max (a[i], b[i]) - 1, r = max (a[i], b[i]) * 4;
        while (l < r) {
            int mid  = (r + l + 1) >> 1;
            if (check (mid, a[i], b[i])) l = mid;
            else r = mid - 1;
        }
        cout << l << ' ';
    }
//    cout << check (7, 3, 5) << endl;
    cout << '\n';
    int l = max (a[1], b[1]) - 1, r = max (a[1], b[1]) * 4;
    while (l < r) {
        int mid  = (r + l + 1) >> 1;
        if (check (mid, a[1], b[1])) l = mid;
        else r = mid - 1;
    }
    for (int i =1 ; i <= l; ++i) g[i].clear();
    for (int i = 1; i <= l; ++i) {
        if (i - a[1] >= 0) {
            g[i - a[1]].push_back (i);
        }
        if (i + b[1] - 1 <= l) {
            g[i + b[1] - 1].push_back (i - 1);
        }
    }

    int cnt = 0;
    vector<int> ans;
    vector<bool> used (l + 1, false);
    for (int i = 0; i <= l; ++i) {
        if (!used[i]) {
            top (i, used, ans);
        }
    }
    reverse (begin (ans), end (ans));
    vector<int> d (l + 2);
    for (auto it : ans) d[it] = ++cnt;
    for (int i = l; i >= 0; --i) d[i] -= d[0];
    for (int i = 1; i <= l; ++i) cout << d[i] - d[i - 1] <<  ' ';
    cout << '\n';
    return 0;
}
