#include <bits/stdc++.h>

using namespace std;
#define int long long

const int N = 210000;
const int LOGN = 20;

int table[LOGN][N], sum[N];

int get(int l, int r) {
    int sz = 31 - __builtin_clz(r - l + 1);
    return min(table[sz][l], table[sz][r - (1 << sz) + 1]);
}

int32_t main() {
	ios::sync_with_stdio(0); cin.tie(0);
    int n, q, g; cin >> n >> q >> g; n = n + n;
    string s; cin >> s;
    sum[0] = 0;
    for (int i = 1; i <= n; i++)
		sum[i] = sum[i - 1] + (s[i - 1] == '(' ? 1 : -1);
    for (int i = 1; i <= n; i++)
		table[0][i] = sum[i];
	for (int k = 1; k < LOGN; k++)
	for (int i = 1; i + (1 << k) - 1 <= n; i++)
		table[k][i] = min(table[k - 1][i], table[k - 1][i + (1 << (k - 1))]);
    while (q--) {
		int l, r; cin >> l >> r;
        int val = get(l, r) - sum[l - 1];
        int ans = 0;
        if (val < 0) ans = (-val + 1) / 2;
        cout << ans << '\n';
    }
}
