#include <bits/stdc++.h>

using namespace std;
#define int unsigned long long

const int N = 110000;

vector<pair<int, pair<int, int>>> edge;
vector<pair<int, int>> vec;

int p[N], s[N];

int getp(int x) {return p[x] == x ? x : p[x] = getp(p[x]);}

int32_t main() {
	ios::sync_with_stdio(0); cin.tie(0);
	int n, q; cin >> n >> q;
	for (int i = 1; i <= n - 1; i++) {
		int u, v, w; cin >> u >> v >> w;
		edge.push_back({w, {u, v}});
	}
	sort(begin(edge), end(edge));
	for (int i = 1; i <= n; i++) {
		s[i] = 1;
		p[i] = i;
	}
    for (auto wuv : edge) {
		int w = wuv.first;
		auto uv = wuv.second;
		int u = uv.first;
		int v = uv.second;
        u = getp(u);
        v = getp(v);
        vec.push_back({w, s[u] * s[v] * w});
        if (s[u] < s[v]) swap(u, v);
        s[u] += s[v];
        p[v] = u;
    }
    vec.push_back({0, 0});
    sort(begin(vec), end(vec));
    for (int i = 1; i < (int) vec.size(); i++)
		vec[i].second += vec[i - 1].second;
    while (q--) {
		int l, r; cin >> l >> r;
        auto itl = lower_bound(begin(vec), end(vec), pair<int, int>{l, 0});
        auto itr = lower_bound(begin(vec), end(vec), pair<int, int>{r + 1, 0});
        itl--;
        itr--;
        cout << itr->second - itl->second << '\n';
    }
}
