#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n, q, p;
    cin >> n >> q >> p;
    n = n + n;
    string s;
    cin >> s;
    s = " " + s;
    struct node {
        int open, close;
        int good;
    };
    vector<node> tree(4 * n + 1);
    auto merge = [&](node a, node b) {
        node res;
        res.open = a.open + b.open;
        res.close = a.close + b.close;
        int mn = min(a.open, b.close);
        res.open -= mn;
        res.close -= mn;
        res.good = a.good + b.good + mn;
        return res;
    };
    function<void(int, int, int)> build = [&](int v, int tl, int tr) {
        if (tl == tr) {
            tree[v].open += (s[tl] == '(');
            tree[v].close += (s[tl] == ')');
            return;
        }
        int tm = (tl + tr) >> 1;
        build(v * 2, tl, tm);
        build(v * 2 + 1, tm + 1, tr);
        tree[v] = merge(tree[v * 2], tree[v * 2 + 1]);
        return;
    };
    function<node(int, int, int, int, int)> get = [&](int v, int tl, int tr, int l, int r) {
        if (l > r) {
            return node{0, 0, 0};
        }
        if (tl == l && tr == r) {
            return tree[v];
        }
        int tm = (tl + tr) >> 1;
        return merge(get(v * 2, tl, tm, l, min(r, tm)), get(v * 2 + 1,tm + 1, tr, max(l, tm + 1), r));
    };
    build(1, 1, n);
    while (q--) {
        int l, r;
        cin >> l >> r;
        node g = get(1, 1, n, l, r);
        int f = r - l + 1;
        f -= g.good * 2;
        cout << f / 4 + (f % 4 != 0) << '\n';
    }
    return 0;
}

