#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n, q;
    cin >> n >> q;
    vector<pair<int, int>> g[n + 2];
    vector<int> weight;
    for (int i = 1; i < n; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
        weight.push_back(w);
    }
    weight.push_back(-100);
    weight.push_back(1e9 + 9);
    vector<int> ans(n + 10);
    sort(weight.begin(), weight.end());
    weight.erase(unique(weight.begin(), weight.end()), weight.end());
    function<void(int, int, int)> dfs = [&](int v, int p, int cost) {
        if(cost != 0) {
            int pos = lower_bound(weight.begin(), weight.end(), cost) - weight.begin();
            ans[pos]++;
        }
        for (auto [to, w] : g[v]) {
            if (to != p) {
                dfs(to, v, max(cost, w));
            }
        }
    };
    for (int i = 1; i <= n; ++i) {
        dfs(i, 0, 0);
    }
    for (int i = 1; i <= n + 1; ++i) {
        ans[i] /= 2;
  //  cout << ans[i] << ' '<< weight[i] << endl;
        ans[i] = (ans[i - 1] + ans[i] * weight[i]);

    }
    while (q--) {
        int l, r;
        cin >> l >> r;
        l = lower_bound(weight.begin(), weight.end(), l) - weight.begin();
        r = lower_bound(weight.begin(), weight.end(), r) - weight.begin();

        cout << ans[r] - ans[l - 1] << '\n';
    }
    return 0;
}
