#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int N = 100009;

ll res[N];
int n, q, link[N], sz[N];

int f(int v) { return (v == link[v] ? v : link[v] = f(link[v])); }

void unite(int u, int v) {
    u = f(u), v = f(v);
    if (sz[u] > sz[v]) swap(u, v);
    link[u] = v, sz[v] += sz[u];
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    cin >> n >> q;

    vector < array < ll , 3 > > e;
    vector < array < int , 3 > > vec;

    for (int i = 1; i < n; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        vec.push_back({w, u, v});
    }

    sort(vec.begin(), vec.end());
    for (int i = 1; i <= n; i++) link[i] = i, sz[i] = 1;

    for (auto x : vec) {
        e.push_back({x[0], -1ll, (ll)sz[f(x[1])] * (ll)sz[f(x[2])] * (ll)x[0]});
        unite(x[1], x[2]);
    }

    for (int i = 1; i <= q; i++) {
        int lg, rg;
        cin >> lg >> rg;
        e.push_back({lg - 1, i, -1ll});
        e.push_back({rg, i, 1ll});
    }

    sort(e.begin(), e.end());

    ll s = 0;

    for (auto x : e) {
        if (x[1] < 1) s += x[2];
        else res[x[1]] += x[2] * s;
    }

    for (int i = 1; i <= q; i++) cout << res[i] << "\n";
}
