# include <bits/stdc++.h>

#define siz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define vec vector
#define pb push_back
#define ll long long
#define pw(x) (1ll << x)
#define pii pair<int,int>
#define lv (v << 1)
#define rv (v << 1 | 1)
#define f first
#define s second
#define mid (l + r >> 1)

using namespace std;

template <typename T>
bool umx (T &a, const T b) {return a < b ? (a = b, 1) : 0; }

template <typename T>
bool umn (T &a, const T b) {return a > b ? (a = b, 1) : 0; }

const int N = 1e5;

//array < int, 3 > ed[N];

vec < pii > query[2 * N + 1], e[2 * N + 1];
pii qd[N];
int p[2 * N + 1], par[N], sz[N], cc[2 * N + 1];

ll cur = 0;
ll ans[N];

int get (int x) {
    if (x == par[x]) return x;
    return par[x] = get(par[x]);
}

ll kol (int n) {
    return n * 1ll * (n - 1) / 2;
}

ll get (int l, int r) {
    if (l) return p[r] - p[l - 1];
    return p[r];
}

void merge (int x, int y) {
    x = get(x), y = get(y);
    if (x == y) return;

    cur -= kol(sz[x]);
    cur -= kol(sz[y]);
    if (sz[x] > sz[y]) swap(x, y);
    par[x] = y;
    sz[y] += sz[x];
    cur += kol(sz[y]);
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    vec < int > c;
    int n, q;
    cin >> n >> q;
    iota(par, par + N, 0);
    fill(sz, sz + N, 1);
    vec < array < int, 3 > > ed(n - 1);
    for (int i = 0, u, v, w; i < n - 1; ++i) {
        cin >> u >> v >> w;
        --u, --v;
        c.pb(w);
        ed[i] = {w, u, v};
    }

    for (int i = 0, l, r; i < q; ++i) {
        cin >> l >> r;
        qd[i] = {l, r};
        c.pb(l);
        c.pb(r);
    }

    sort(all(c));
    c.erase(unique(all(c)), c.end());

    for (auto [w, u, v] : ed) {

        int wc = lower_bound(all(c), w) - c.begin();
        e[wc].pb({u, v});
    }

    for (int i = 0; i < q; ++i) {
        int lc = lower_bound(all(c), qd[i].f) - c.begin(), rc = lower_bound(all(c), qd[i].s) - c.begin();
        query[rc].pb({lc, i});
    }

    for (int wi = 0; wi < siz(c); ++wi) {

        for (auto [u, v] : e[wi]) {
//            cout << wi << " " << u << " " << v << "\n";
            merge(u, v);
        }
        p[wi] += (cur - (wi ? cc[wi - 1] : 0)) * 1ll * c[wi] + (wi ? p[wi - 1] : 0);
        cc[wi] = cur;

        for (auto [l, i] : query[wi]) {

            ans[i] = get(l, wi);

        }
    }

    for (int i = 0; i < q; ++i)
        cout << ans[i] << "\n";
}
