#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define en '\n'


struct zxc {
    ll b;
    ll cnt;
};

vector<ll> used;
vector<vector<zxc>> g;
vector<vector<ll>> pref;
vector<vector<ll>> mx;
vector<ll> up;


void dfs(ll v, ll p, ll c) {
    used[v] = 1;
    up[v] = up[p] + 1;
    pref[v][0] = p;
    mx[v][0] = c;
    for (ll i = 1; i < 40; i++) {
        pref[v][i] = pref[pref[v][i - 1]][i - 1];
        mx[v][i] = max(mx[pref[v][i - 1]][i - 1], mx[v][i - 1]);
    }
    for (auto el: g[v]) {
        if (used[el.b] == 0) {
            dfs(el.b, v, el.cnt);
        }
    }
}

ll sum = 0;

ll raz(ll a, ll b) {
    if (up[a] == up[b]) {
        return b;
    } else {
        for (ll i = 1; i < 40; i++) {
            if (up[a] == up[pref[b][i]]) {
                sum = max(sum, mx[b][i]);
                return pref[b][i];
            }
            if (up[a] > up[pref[b][i]]) {
                sum = max(sum, mx[b][i - 1]);
                return raz(a, pref[b][i - 1]);
            }
        }
    }
}

void LCA(ll a, ll b) {
    if (a == b) {
        return;
    }
    for (ll i = 1; i < 40; i++) {
        if (pref[a][i] == pref[b][i]) {
            sum = max(sum, max(mx[a][i - 1], mx[b][i - 1]));
            LCA(pref[a][i - 1], pref[b][i - 1]);
            return;
        }
    }
}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n, q;
    cin >> n >> q;
    up.resize(n + 10);
    g.resize(n + 10);
    used.resize(n + 10);
    pref.resize(n + 10, vector<ll>(40 + 10, 0));
    mx.resize(n + 10, vector<ll>(40 + 10, 0));
    ll m = 0;
    for (ll i = 0; i < n - 1; i++) {
        ll a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        m = max(m, c);
        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }
    dfs(0, 0, 0);
    vector<ll> dp(m + 1);
    for (ll i = 0; i < n; i++) {
        for (ll j = i + 1; j < n; j++) {
            ll a = i;
            ll b = j;
            sum = 0;
            if (up[a] > up[b]) {
                swap(a, b);
            }
            dp[sum]++;
        }
    }
    for (ll i = 0; i < q; i++) {
        ll l, r;
        cin >> l >> r;
        ll otv = 0;
        for (ll j = l; j <= r; j++) {
            if (m < j) {
                continue;
            } else {
                otv += dp[j] * j;
            }
        }
        cout << otv << en;
    }
}
