#include <bits/stdc++.h>

#define int long long
using namespace std;
const int INF = 2e9;

struct node {
    int y, c;
};
vector<multiset<int>> ans;
vector<vector<node>> z;
vector<int> used, used1;
int n;
int l, r;
int pr = -1;

void dfs(int u, int p) {
    if (used1[u] == 0) {
        ans[u].insert(p);
    }
    used[u] = pr + 1;
    for (auto [to, c]: z[u]) {
        if (used[to] == pr) {
            dfs(to, max(p, c));
        }
    }
}

void solve() {
    cin >> l >> r;
    int sm = 0;
    for (int i = 0; i < n; i++) {
        for (auto it: ans[i]) {
            if (it >= l && it <= r) {
                sm += it;
            }
        }
    }
    cout << sm;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int e;
    cin >> n >> e;
    z.resize(n);
    ans.resize(n);
    used.resize(n, 0);
    used1.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int x, y, c;
        cin >> x >> y >> c;
        x--;
        y--;
        z[x].push_back({y, c});
        z[y].push_back({x, c});
    }
    for (int i = 0; i < n; i++) {
        used1[i] = 1;
        pr++;
        dfs(i, 0);
    }
    while (e--) {
        solve();
        cout << "\n";
    }
}

