#include <bits/stdc++.h>
using namespace std;
#define int int64_t
const int nl=0;
string s;
vector<pair<int,int> > tree;
void build(int v, int l, int r) {
    if(l+1==r) {
        if(s[l]==')') {
            tree[v]={1,0};
            return;
        }
        if(s[l]=='(') {
            tree[v]={0,1};
            return;
           }
    }
    int m=(l+r)/2;
    build(2*v+1,l,m);
    build(2*v+2,m,r);
    tree[v]={tree[2*v+1].first+max(nl,tree[2*v+2].first-tree[2*v+1].second),tree[2*v+2].second+max(nl,tree[2*v+1].second-tree[2*v+2].first)};
}
pair<int,int> get(int v, int l, int r, int ql, int qr) {
    if(l>=qr || ql>=r) {
        return {0,0};
    }
    if(ql<=l && r<=qr) {
        return tree[v];
    }
    int m=(l+r)/2;
    pair<int,int> x=get(2*v+1,l,m,ql,qr);
    pair<int,int> y=get(2*v+2,m,r,ql,qr);
    return {x.first+max(nl,y.first-x.second),y.second+max(nl,x.second-y.first)};
}
int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, q, g;
    cin >> n >> q >> g;
    cin >> s;
    tree=vector<pair<int,int> >(8*n);
    build(0,0,2*n);
    while(q--) {
        int l, r;
        cin >> l >> r;
        pair<int,int> x=get(0,0,2*n,l-1,r);
        cout << x.first/2+x.first%2 << '\n';
    }
}
