#include <iostream>
#include <vector>

using namespace std;

void parenthesesMain() {
	int n, q, g, tempL, tempR; cin >> n >> q >> g;
	string s; cin >> s;
	vector<float> unfinishedPairsPerSymbol(2 * n), res(q);

	unfinishedPairsPerSymbol[0] = 0.5f;
	for (int i = 1; i < 2 * n; i++) {
		if (s[i] == '(' || unfinishedPairsPerSymbol[i - 1] == 0) unfinishedPairsPerSymbol[i] = unfinishedPairsPerSymbol[i - 1] + 0.5f;
		else unfinishedPairsPerSymbol[i] = unfinishedPairsPerSymbol[i - 1] - 0.5f;
	}

	for (int i = 0; i < q; i++) {
		cin >> tempL;
		cin >> tempR;
		res[i] = unfinishedPairsPerSymbol[tempR - 1] - unfinishedPairsPerSymbol[tempL - 1] + 0.5f;
	}

	for (float f : res) cout << f << endl;
}

int main()
{
	parenthesesMain();
}