#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <queue>
#include <stack>
#include <string>
#include <map>
using namespace std;
using ll = long long;
using vll = vector<ll>;
using vvl = vector<vll>;
using vb = vector<bool>;
using pll = pair<ll,ll>;
using vpl = vector<pll>;
using vvp = vector<vpl>;
#define f first
#define s second
#define pb push_back
#define all(v) v.begin(),v.end()
vll par, sz, len;
ll find_par(ll a){
    if(a==par[a])return a;
    else return par[a] = find_par(par[a]);
}
void unite(ll a, ll b){
    a = find_par(a);
    b = find_par(b);
    if(sz[a]<sz[b])swap(a,b);
    par[b] = a;
    sz[a] += sz[b];
}
ll plac(ll w){
    return upper_bound(all(len),w)-len.begin()-1;
}
int main(){
    ios_base::sync_with_stdio(0);cin.tie(NULL);
    ll n, q, l, r, u, v, w;
    cin >> n >> q;
    vector<pair<ll,pll>> edg;
    vll ans(n);map<ll,ll> chek;
    for(ll i = 1; i < n; ++i){
        cin >> u >> v >> w;
        edg.pb({w, {u,v}});
        if(!chek.count(w)){
            len.pb(w);
            chek[w]=1;
        }
    }
    sort(all(edg));
    sort(all(len));
    par = sz = vll(n+1, 1);
    for(ll i = 0 ; i <= n; ++i)par[i]=i;
    for(auto [W,c]:edg){
        auto [a,b] = c;
        ll A = sz[find_par(a)];
        ll B = sz[find_par(b)];
        ans[plac(W)]+=A*B;
        unite(a,b);
    }
    for(ll i = 0; i < len.size(); ++i){
        ans[i] *= len[i];
    }
    ll ret;
    while(q--){
        cin >> l >> r;
        ret = 0;
        for(ll i = plac(l); i <= plac(r); ++i){
            ret += ans[i];
        }
        cout << ret << "\n";
    }
}