#include<iostream>
#include<vector>
#include<algorithm>
#include<math.h>

using namespace std;
using ll = long long;
using vll = vector<ll>;
using vvll = vector<vll>;
using pll = pair<ll, ll>;
using vpll = vector<pll>;

vector<pair<ll,pll>> tree;
ll n, np;

pair<ll, pll> rec(ll index) {
	if (index >= np) {
		return tree[index];
	}
	pair<ll, pll> right = rec(2 * index + 1);
	pair<ll, pll> left = rec(2 * index);
	tree[index] = { left.first + right.first, {left.second.first, right.second.second} };
	return tree[index];
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	
	ll n, q, g;
	cin >> n >> q >> g;
	n *= 2;
	string a;
	cin >> a;
	vll num(n);
	for (ll i = 0; i < n; i++) {
		if (a[i] == '(') {
			num[i] = 1;
		}
		else {
			num[i] = -1;
		}
	}
	np = pow(2, ll(log2(n)) + 1);
	tree.resize(2 * np, { 0, {-1, -1} });
	for (ll i = 0; i < np; i++) {
		if (i < n) {
			tree[np + i] = { num[i], {i, i} };
		}
		else {
			tree[np + i] = { 0, {i, i} };
		}
	}
	rec(1);
	ll r, l;
	for (ll i = 0; i < q; i++) {
		cin >> l >> r;
		l--, r--;
		ll now = np + l;
		ll count = 0, ans = 0;
		while (l <= r) {
			if (l == r) {
				count += tree[now].first;
				if (count < 0) {
					ans++;
				}
				break;
			}else{
				if (now % 2 == 0) {
					if (tree[now / 2].second.second <= r) {
						if (tree[now].first + count < 0) {
							ans++;
							count = 0;
							count += 2 * abs(tree[now].first);
						}
						else {
							count += tree[now].first;
						}
						now /= 2;
						l = tree[now].second.second;
					}else{
						if (tree[now].first + count < 0) {
							ans++;
							count = 0;
							count += 2 * abs(tree[now].first);
						}
						else {
							count += tree[now].first;
						}
						l += 1;
						now = np + l;
					}
				}else{
					if (tree[now].first + count < 0) {
						ans++;
						count = 0;
						count += 2 * abs(tree[now].first);
					}
					else {
						count += tree[now].first;
					}
					l += 1;
					now = np + l;
				}
			}
		}
		cout << ans << endl;
	}
	
}