#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;
using vll = vector<ll>;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll n, q, g;
	cin >> n >> q >> g;
	n *= 2;
	string s;
	cin >> s;
	while (q--) {
		ll l, r;
		cin >> l >> r;
		vll pref(n);
		pref[0] = -1;
		if (s[0] == '(') {
			pref[0] = 1;
		}
		vll arr(n);
		for (ll i = 1; i < n; i++) {
			if (s[i] == '(') arr[i] = 1;
			else arr[i] = -1;
			pref[i] = pref[i - 1] + arr[i];
		}
		ll j = n - 1;
		while (arr[j] != 1) {
			j--;
		}
		ll add = 0;
		ll ans = 0;
		for (ll i = 0; i < n; i++) {
			if (i >= j) {
				break;
			}
			if (pref[i] + add < 0) {
				ans++;
				add += 2;
				j--;
				while (j >= i && arr[j] != 1) {
					j--;
				}
			}
		}
		cout << ans << endl;
	}
}