#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;
using vll = vector<ll>;
using pll = pair<ll, ll>;
using vpll = vector<pll>;
using vvpll = vector<vpll>;

ll const INF = 1e18;

vvpll g;
ll ans = 0;

void dfs(ll s, ll n, vector<bool>& vis, ll mx, ll l, ll r, vector<vector<bool>>& vis2) {
	vis[n] = true;
	//cout << "n = " << n << endl;
	for (auto u : g[n]) {
		//cout << "u.first = " << u.first << endl;
		if (vis[u.first]) continue;
		ll t = max(mx, u.second);
		if (t < l || t > r) {
			continue;
		}
		if (!vis2[u.first][s] && (!vis2[s][u.first])) {
			//cout << "added" << endl;
			ans += t;
			vis2[u.first][s] = true;
			vis2[s][u.first] = true;
		}
		//ans += t;
		dfs(s, u.first, vis, t, l, r, vis2);
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	ll n, q;
	cin >> n >> q;
	g.resize(n);
	for (ll i = 0; i < n - 1; i++) {
		ll a, b, c;
		cin >> a >> b >> c;
		a--, b--;
		g[a].push_back({ b, c });
		g[b].push_back({ a, c });
	}
	while (q--) {
		ll a, b;
		cin >> a >> b;
		ans = 0;
		vector<vector<bool>> vis2(n, vector<bool>(n, false));
		for (ll i = 0; i < n; i++) {
			vector<bool> vis(n, false);
			dfs(i, i, vis, 0, a, b, vis2);
		}
		/*for (ll i = 0; i < n; i++) {
			for (ll j = 0; j < n; j++) {
				if (vis2[i][j]) {
					cout << "T ";
				}
				else {
					cout << "F ";
				}
			}
			cout << endl;
		}*/
		cout << ans << endl;
	}
}