#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ff first
#define ss second
#define all(x) x.begin(),x.end()
#define pb push_back

// udachi davay

const int INF = 1e18,N = 2e5 + 1;

int pref[N],t[N * 4];

void build(int v,int tl,int tr){

	if(tl == tr){
		t[v] = pref[tl];
	} else{
		int tm = (tl + tr) >> 1;
		build(v * 2,tl,tm);
		build(v * 2 + 1,tm + 1,tr);
		t[v] = min(t[v * 2],t[v * 2 + 1]);
	}

}

int get(int v,int tl,int tr,int l,int r){
	
	if(l <= tl && tr <= r){
		return t[v];
	}
	if(l > tr || tl > r){
		return INF;
	}
	int tm = (tl + tr) >> 1;
	return min(get(v * 2,tl,tm,l,r),get(v * 2 + 1,tm + 1,tr,l,r));

}

signed main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0),cout.tie(0);
    
    int n,q;
    cin >> n >> q;
	int g;
	cin >> g;
	string s;
	cin >> s;
	n = n * 2;
	for(int i = 0;i < n;i++){
		int type = 0;
		if(s[i] == '('){
			type = 1;
		} else{
			type = -1;
		}
		pref[i + 1] = pref[i] + type;
	}
	build(1,1,n);
	vector<int> ans(n + 1,INF);
	for(int i = 1;i <= n;i++){
		int l = i,r = n;
		while(l <= r){
			int mid = (l + r) >> 1;
			if(get(1,1,n,i,mid) < pref[i - 1]){
				ans[i] = mid;
				r = mid - 1;
			} else{
				l = mid + 1;
			}
		}
	}
	for(int i = 0;i < q;i++){
		int l,r;
		cin >> l >> r;
		if(ans[l] > r){
			cout << 0 << "\n";
		} else{
			cout << 1 << "\n";
		}
	}
	

}
