#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define ff first
#define ss second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

const int INF = 1e9;
const int mod = 1e9 + 7;
const int N = 1e5 + 1;
map<int,int> mp;
int baty[N], sz[N];
vector<pair<int,int> > a;
int t[4 * N];

int find_baty(int v){
	if(v == baty[v]) return v;
	return baty[v] = find_baty(baty[v]);
}

void unin(int u, int v){
	u = find_baty(u);
	v = find_baty(v);
	
	if(u == v) return;
	
	if(sz[u] > sz[v]) swap(u, v);
	baty[u] = v;
	sz[v] += sz[u];
}

void build(int v, int tl, int tr){
	if(tl == tr){
		t[v] = a[tl].ss;
	}else{
		int tm = (tl + tr) >> 1;
		build(v << 1, tl, tm);
		build(v << 1 | 1, tm + 1, tr);
		t[v] = t[v << 1] + t[v << 1 | 1];
	}
}

int get(int l, int r, int v = 1, int tl = 1, int tr = (int)a.size()){
	if(tl > r or tr < l) return 0;
	if(l <= tl and tr <= r) return t[v];
	int tm = (tl + tr) >> 1;
	return get(l, r, v << 1, tl, tm) + get(l, r, v << 1 | 1, tm + 1, tr);
}

void solve(){
	int n, q;
	cin >> n >> q;
	for(int i = 1; i <= n; i++){
		baty[i] = i;
		sz[i] = 1;
	}
	vector<tuple<int,int,int> > edges;
	for(int i = 1; i < n; i++){
		int u, v, cost;
		cin >> u >> v >> cost;
		edges.pb({cost, u, v});
	}
	sort(all(edges));
	for(int i = 0; i < n - 1; i++){
		auto [cost, u, v] = edges[i];
		
		int b_u = find_baty(u);
		int b_v = find_baty(v);
		
		mp[cost] += sz[b_u] * sz[b_v] * cost;
		
		unin(b_u, b_v);
	}
	
	a.pb({0, 0});
	for(auto [cost, cnt] : mp){
		a.pb({cost, cnt});
	}
	build(1, 1, (int)a.size());
	
	while(q--){
		int l, r;
		cin >> l >> r;
		
		int al = 1, ar = (int)a.size(), ansl = 1;
		while(al <= ar){
			int am = (al + ar) >> 1;
			if(a[am].ff <= l){
				al = am + 1;
				ansl = am;
			}else{
				ar = am - 1;
			}
		}
		
		al = 1; ar = (int)a.size();
		int ansr = (int)a.size();
		while(al <= ar){
			int am = (al + ar) >> 1;
			if(a[am].ff >= r){
				ar = am - 1;
				ansr = am;
			}else{
				al = am + 1;
			}
		}
		
		cout << get(ansl, ansr) << '\n';
	}
}

main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int tt = 1;
    //cin >> tt;
    while(tt--){
        solve();
    }
}
