#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int long long
#define vec vector
typedef pair<int , int> pii;
using indexed_set = tree<pii , null_type , less<pii> , rb_tree_tag , tree_order_statistics_node_update>;
const int mn = INT_MIN , num = 1e5;
vec<int> cnt(num + 1);
int bfs(int start , int finish , vec<vec<pii>> g , int n){
    vec<int> dist(n , mn);
    indexed_set q;
    q.insert({start , 0});
    dist[start] = 0;
    while(!q.empty()){
        int cur = q.begin() -> first;
        int w = q.begin() -> second;
        q.erase(q.begin());
        for (auto [to , nxt_w] : g[cur]){
            if (dist[to] == mn and w < nxt_w){
                dist[to] = nxt_w;
                q.insert({to , nxt_w});
            }
        }
    }
    return dist[finish];
}
signed main()
{
    int n , t;
    cin >> n >> t;
    vec<vec<pii>> g(n);
    vec<vec<int>> dist(n , vec<int> (n , mn));
    cout << "OK";
    for (int i = 1; i < n; i++){
        int x , y , w;
        cin >> x >> y >> w;
        x -- , y -- ;
        g[x].emplace_back(y , w);
        g[y].emplace_back(x , w);
        dist[x][y] = dist[y][x] = w;
    }
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++){
            if (dist[i][j] == mn){
                int i_j = bfs(i , j , g , n);
                dist[i][j] = dist[j][i] = i_j;
                cnt[i_j]++;
            }
        }
    }
    while(t--){
        int l , r;
        cin >> l >> r;
        int ans = 0;
        for (int i = l; i <= r; i++){
            ans += cnt[i] * i;
        }
        cout << ans << "\n";
    }
}