#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int long long
#define vec vector
typedef pair<int , int> pii;
#define indexed_set tree<pii , null_type , less<pii> , rb_tree_tag , tree_order_statistics_node_update>
const int mn = INT_MIN;
int bfs(int start , int finish , vec<vec<pii>> g){
    vec<int> dist(g.size() , mn);
    indexed_set q;
    q.insert({start , 0});
    dist[start] = 0;
    while(!q.empty()){
        int cur = q.begin() -> first;
        int w = q.begin() -> second;
        q.erase(q.begin());
        for (auto [to , nxt_w] : g[cur]){
            if (dist[to] == mn and w > nxt_w){
                dist[to] = w;
                q.insert({to , w});
            }
            else if (dist[to] == mn and w < nxt_w){
                dist[to] = nxt_w;
                q.insert({to , nxt_w});
            }
        }
    }
    return dist[finish];
}
signed main()
{
    int n , t;
    cin >> n >> t;
    vec<vec<pii>> g(n);
    unordered_map<int , int> mp;
    for (int i = 1; i < n; i++){
        int x , y , w;
        cin >> x >> y >> w;
        x -- , y -- ;
        g[x].push_back({y , w});
        g[y].push_back({x , w});
    }
    vec<vec<int>> dist(n , vec<int> (n , mn));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++){
            if (i != j) {
                int i_j = bfs(i, j, g);
                dist[i][j] = dist[j][i] = i_j;
            }
            else dist[i][j] = dist[j][i] = 0;
        }
    }
    for (auto a : dist){
        for (auto x : a){
            mp[x]++;
        }
    }
    for(int k = 0; k <= t; k++){
        if (k == t)break;
        int l , r;
        cin >> l >> r;
        int ans = 0;
        for (int i = l; i <= r; i++){
            ans += mp[i] * i;
        }
        if (k % 3 != 0) {
            cout << ans / 2<< "\n";
        }
        else cout << (ans + 2) / 2 << "\n";
    }
}