#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;

#define int long long

template<class t> using ordered_set =
        __gnu_pbds::tree<t, __gnu_pbds::null_type, less<t>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

template<class t> using ordered_multiset =
        __gnu_pbds::tree<t, __gnu_pbds::null_type, less_equal<t>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

template<class t, class u>
bool chmin(t &a, u b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<class t, class u>
bool chmax(t &a, u b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int mod = 1e9 + 7;

int binpow(int n, int e){
    int res = 1;
    while(e){
        if(e & 1) res = (res * n) % mod;
        n = (n * n) % mod;
        e >>= 1;
    }
    return res;
}

int divide(int a, int b){
    return a * binpow(b, mod - 2) % mod;
}

void solve() {
    int q;
    cin >> q;
    int res = 0, cnt = 0;
    bool flag = true;
    while (q--) {
        int x, y;
        cin >> x >> y;
        if (!cnt) {
            if (x > y) {
                res = x;
            } else {
                res = y;
                flag = false;
            }
            cnt++;
        }
        cout << max(x, y) - 1 << ' ';
        cnt ++;
    }
    for (int i = 1; i < res; ++i) {
        if (flag) cout << -1 << ' ';
        else cout << 1 << ' ';
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
//  int tt; cin >> tt; while(tt--) // DON'T FORGET
    solve();
}