#include <iostream>
#include <vector>

using namespace std;
const int N = 4e5 + 10;
vector<pair<int,int>> Q[N];
int n,q,g;
string s;
int seg[N * 4];
int ans[N];

void insert(int i,int cur = 1,int st = 1,int en = N){
	if (i >= en or i < st)
		return;
	if (en - st == 1){
		seg[cur] = 1;
		return;
	}
	int lc = cur + cur,rc = lc + 1,mid = (st + en)/2;
	insert(i,lc,st,mid);
	insert(i,rc,mid,en);
	seg[cur] = seg[lc] + seg[rc];
}

int get(int l,int r,int cur = 1,int st = 1,int en = N){
	if (l >= en or r <= st)
		return 0;
	if (l <= st and r >= en)
		return seg[cur];
	int lc = cur + cur,rc = lc + 1,mid = (st + en)/2;
	return get(l,r,lc,st,mid) + get(l,r,rc,mid,en);
}

int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);


	cin>>n>>q>>g>>s;
	s = '0' + s;

	for (int i=1;i<=q;i++){
		int l,r;
		cin>>l>>r;
		Q[r].push_back({l,i});
	}

	vector<pair<int,int>> v;

	for (int i=1;i<=n + n;i++){
		int cur = (s[i] == '(');
		if (v.size() > 0 and (v.back()).first == 1 and cur == 0){
			insert((v.back()).second);
			v.pop_back();
		}
		else
			v.push_back({cur,i});
		for (auto [l,ind] : Q[i]){
			ans[ind] = (i - l + 1) / 2;
			ans[ind] -= get(l,i + 1);
			ans[ind] = (ans[ind] + 1) / 2;
		}
	}
	for (int i=1;i<=q;i++)
		cout<<ans[i]<<'\n';
}