#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
#define int long long
const int N = 1e5 + 10;
int par[N];
int sz[N];

int arrc[N];
int arrcnt[N];

int root(int v){
	if (par[v] == -1)
		return v;
	par[v] = root(par[v]);
	return par[v];
}

signed main(){
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int n,q;
	cin>>n>>q;

	vector<pair<int,pair<int,int>>> E;

	for (int i=1;i<n;i++){
		int a,b,c;
		cin>>a>>b>>c;
		E.push_back({c,{a,b}});
	}

	sort(begin(E),end(E));

	for (int i=1;i<=n;i++)
		par[i] = -1,sz[i] = 1;

	int lst = 0;
	int ind = 0;
	//////////////////////////////// long long fix me
	for (auto [c,p] : E){
		if (c != lst){
			ind++;
			lst = c;
			arrc[ind] = c;
		}

		int a = root(p.first);
		int b = root(p.second);

		arrcnt[ind] += sz[a] * sz[b];
		par[a] = b;
		sz[b] += sz[a];
	}

	ind++;
	arrc[ind] = 1e9 + 10;

	for (int i=1;i<=ind;i++)
		arrcnt[i] = arrcnt[i] * arrc[i] + arrcnt[i-1];

	while (q--){
		int c1,c2;
		cin>>c1>>c2;
		int l = upper_bound(arrc,arrc + ind + 1,c1-1) - arrc;
		int r = upper_bound(arrc,arrc + ind + 1,c2) - arrc;
		cout<<arrcnt[r - 1] - arrcnt[l - 1]<<'\n';
	}
}