#include <bits/stdc++.h>

using namespace std;

const int Max = 1e5;
const int Inf = 1e6;
struct Relatie {
    int x, y, c;
};
vector<Relatie> a[Max + 2];
int n, q, i, j, x, y, c, aib[Inf + 2];
bool fr[Max + 2];
//int lca[log + 2][Max + 2];

static inline int Maxim(int a, int b) {
    if(a < b) return b;
    return a;
}

static inline int Ub(int x) {
    return (x & -x);
}

static inline void Update(int poz, int val) {
    for(int i = poz; i <= Inf; i += Ub(i)) aib[i] += val;
}

static inline int Sum(int poz) {
    int sum = 0;
    for(int i = poz; i >= 1; i -= Ub(i)) sum += aib[i];
    return sum;
}

static inline void Parc(const int start, int nod, int cost) {
    fr[nod] = true;
    if(start > nod) Update(cost, cost);
    for(auto it : a[nod]) {
        int c = it.c;
        int urm = it.y;

        if(fr[urm]) continue;

        int ma = Maxim(c, cost);
        Parc(start, urm, ma);
    }
    fr[nod] = false;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> q;
    for(i = 1; i < n; i++) {
        cin >> x >> y >> c;
        a[x].push_back({x, y, c});
        a[y].push_back({y, x, c});
    }

    for(i = 1; i <= n; i++)
        Parc(i, i, 0);

    while(q--) {
        cin >> x >> y;
        cout << Sum(y) - Sum(x - 1) << "\n";
    }

    return 0;
}
