#include <bits/stdc++.h>
#define int long long
using namespace std;
const int NMAX = 1e5+2;
using edge = tuple<int, int, int>;
using pii = pair<int, int>;
int n,q,vf[NMAX],k;
vector<pii> v[NMAX];
vector<edge> edges;
map<int, int> sp;

void dfs(int nod, int w, int tata = -1){
    k++;
    vf[nod] = 1;
    for(auto [fiu, cost]: v[nod]){
        if(cost > w || fiu == tata){
            continue;
        }
        dfs(fiu, w, nod);
    }
}

int cnt(int w){
    for(int i = 1; i <= n; i++){
        vf[i] = 0;
    }
    int ans = 0;
    for(int i = 1; i <= n; i++){
        if(vf[i] == 0){
            k = 0;
            dfs(i, w);
            ans += k * (k-1)/2;
        }
    }
    return ans;
}

signed main()
{
    cin >> n >> q;
    set<int> s;
    for(int i = 1; i < n; i++){
        int x, y, w;
        cin >> x >> y >> w;
        v[x].push_back({y, w});
        v[y].push_back({x, w});
        s.insert(w);
    }
    int sum = 0;
    vector<pii> misto;
    for(int it: s){
        int x = cnt(it) - cnt(it-1);
        sum += it * x;
        misto.push_back({it, it * x});
    }
    while(q--){
        int l, r;
        cin >> l >> r;
        int ans = 0;
        for(auto [pos, pay]: misto){
            if(l <= pos && pos <= r){
                ans += pay;
            }
        }
        cout << ans << "\n";
    }
    return 0;
}
