#include <bits/stdc++.h>
#define int long long
using namespace std;
const int NMAX = 1e5+2;
using edge = tuple<int, int, int>;
using pii = pair<int, int>;
int n,q,vf[NMAX],k;
vector<pii> v[NMAX];
vector<edge> edges;
map<int, int> sp;

void dfs(int nod, int w, int tata = -1){
    k++;
    vf[nod] = 1;
    for(auto [fiu, cost]: v[nod]){
        if(cost > w || fiu == tata){
            continue;
        }
        dfs(fiu, w, nod);
    }
}

int cnt(int w){
    for(int i = 1; i <= n; i++){
        vf[i] = 0;
    }
    int ans = 0;
    for(int i = 1; i <= n; i++){
        if(vf[i] == 0){
            k = 0;
            dfs(i, w);
            ans += k * (k-1)/2;
        }
    }
    return ans;
}

signed main()
{
    cin >> n >> q;
    set<int> s;
    for(int i = 1; i < n; i++){
        int x, y, w;
        cin >> x >> y >> w;
        v[x].push_back({y, w});
        v[y].push_back({x, w});
        s.insert(w);
    }
    int sum = 0, cntprev = 0;
    vector<pii> misto;
    misto.push_back({0, 0});
    for(int it: s){
        int x = cnt(it) - cntprev;
        sum += it * x;
        misto.push_back({it, sum});
        cntprev = cnt(it);
    }
    while(q--){
        int l, r;
        cin >> l >> r;
        auto getIdx = [&](int pos) -> int {
            int st = 0, dr = misto.size()-1;
            int ans = 0;
            while(st <= dr){
                int mid = (st+dr)/2;
                if(misto[mid].first <= pos){
                    ans = mid;
                    st = mid+1;
                }else{
                    dr = mid-1;
                }
            }
            return ans;
        };
        cout << misto[getIdx(r)].second - misto[getIdx(l-1)].second << "\n";
    }
    return 0;
}
