#include <iostream>

using namespace std;
#define MAXN 10000

int cate[MAXN],sef[MAXN],pret[MAXN],x[MAXN],y[MAXN],preturi[MAXN];
long long drumuri[MAXN];

int findSef(int i){
    int aux=i,aux2;
    while(sef[i]!=i){
        i=sef[i];
    }
    while(aux!=i){
        aux2=sef[aux];
        sef[aux]=i;
        aux=aux2;
    }
    return i;
}

void myQsort(int Begin, int End){
    int b=Begin, e=End, pivot=(Begin + End)/2, aux;

    while(pret[b]<pivot)
        b++;
    while(pret[e]>pivot)
        e--;

    while(b<e){
        aux=pret[b];
        pret[b]=pret[e];
        pret[e]=aux;
        aux=x[b];
        x[b]=x[e];
        x[e]=aux;
        aux=y[b];
        y[b]=y[e];
        y[e]=aux;

        do{
            b++;
        }while(pret[b]<pivot);
        do{
            e--;
        }while(pret[e]>pivot);
    }
    if(Begin<e)
        myQsort(Begin, e);
    if(e+1<End)
        myQsort(e+1, End);
}

int main()
{
    int k,n,q,i,pret1,pret2;
    cin>>n>>q;
    for(i=0; i<n-1; i++){
        cin>>x[i]>>y[i]>>pret[i];
    }
    for(i=0; i<n; i++){
        sef[i]=i;
        cate[i]=1;
    }
    pret[n-1]=2000000000;
    //myQsort(0, n-1);
    k=1;
    preturi[0]=0;
    preturi[k++]=pret[0];
    for(i=1; i<n-1; i++)
        if(pret[i]!=pret[i-1])
            preturi[k++]=pret[i];
    preturi[k]=2000000000;
    k=0;
    for(i=0; i<n-1; i++){
        if(i==0||pret[i]!=pret[i-1])
            k++;
        x[i]=findSef(x[i]);
        y[i]=findSef(y[i]);
        drumuri[k]+=(long long)cate[x[i]]*cate[y[i]];
        cate[x[i]]+=cate[y[i]];
        sef[y[i]]=x[i];
    }
    for(i=1; i<=k; i++)
        drumuri[i]=drumuri[i]*preturi[i]+drumuri[i-1];
    for(i=0; i<q; i++){
        cin>>pret1>>pret2;
        pret1=*(lower_bound(preturi, preturi+k+1, pret1)-1);
        pret2=*(lower_bound(preturi, preturi+k+1, pret2+1)-1);
        cout<<drumuri[pret2]-drumuri[pret1]<<'\n';
    }
    return 0;
}
