#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#warning That's not AS, that's my AS

typedef long long ll;

const int NMAX = 4e5;
const int LGMAX = 19;

int rmq[LGMAX][NMAX + 1];
int lg2[NMAX + 1];
int sum[NMAX + 1];

std::string s;

int query(int l, int r) {
  int k = lg2[r - l + 1];
  return std::min(rmq[k][l], rmq[k][r - (1 << k) + 1]);
}

int main() {
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(0);
  std::cout.tie(0);

  int n, q, subtask;
  std::cin >> n >> q >> subtask;
  n *= 2;

  std::cin >> s;
  s = '$' + s;

  for (int i = 1; i <= n; i++) {
    sum[i] = sum[i - 1] + (s[i] == '('? +1 : -1);
    rmq[0][i] = sum[i];
  }


  for (int j = 1; j < LGMAX; j++) {
    for (int i = 1; i + (1 << j) - 1 <= n; i++) {
      rmq[j][i] = std::min(rmq[j - 1][i], rmq[j - 1][i + (1 << (j - 1))]);
    }
  }
  for (int i = 2; i <= n; i++) {
    lg2[i] = lg2[i >> 1] + 1;
  }

  while (q--) {
    int l, r;
    std::cin >> l >> r;
    int minPref = query(l, r) - sum[l - 1];
    std::cout << (-minPref + 1) / 2 << '\n';
  }

  return 0;
}
