#include <bits/stdc++.h>
using namespace std;

#define msc __attribute__((target("avx2"), optimize("O3,unroll-loops")))

using ll = long long;

struct BIT {
  int n;
  vector<int> bit;
  
  msc void update(int i, int x) {
    for (; i <= n; i += (i & -i)) bit[i] = min(bit[i], x);
  }
  msc int query(int i) {
    int ret = n + 1;
    for (; i > 0; i -= (i & -i)) ret = min(ret, bit[i]);
    return ret;
  }
  
  msc BIT(int n) {
    this->n = n;
    bit.assign(n + 1, n + 1);
  }
};

struct Query {
  int l, r, idx;
  bool operator<(Query b) const {
    return l > b.l;
  }
};

msc int32_t main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  
  int n, q, G;
  string s;
  cin >> n >> q >> G >> s;
  n *= 2;
  
  vector<int> a(n + 1);
  for (int i = 1; i <= n; ++i) {
    a[i] = a[i - 1];
    if (s[i - 1] == '(') ++a[i];
    else --a[i];
  }
  
  vector<int> ans(q);
  vector<Query> queries(q);
  for (int i = 0; i < q; ++i) {
    cin >> queries[i].l >> queries[i].r;
    queries[i].idx = i;
  }
  sort(queries.begin(), queries.end());
  
  BIT fen(n);
  int ptr = 0;
  for (int i = n; i >= 1; --i) {
    fen.update(i, a[i]);
    while (ptr < q && queries[ptr].l == i) {
      int minbal = 0;
      minbal = min(minbal, fen.query(queries[ptr].r));
      minbal -= a[i - 1];
      
      ans[queries[ptr].idx] = (-minbal + 1) / 2;
      ++ptr;
    }
  }
  
  cout << endl;
  for (int i = 0; i < q; ++i) cout << ans[i] << endl;
  
  /*while (q--) {
    int l, r;
    cin >> l >> r;
    
    int minbal = 0;
    minbal = min(minbal, aint.query(l, r));
    //for (int i = l; i <= r; ++i) minbal = min(minbal, a[i]);
    
    minbal -= a[l - 1];
    int ans = (-minbal + 1) / 2;
    
    cout << ans << endl;
  }*/
}
/*
5 1 1
()))(()(()
7 10
*/
