#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
using ll = long long;
#define int ll

int mod(int a, int b) {
  return (a % b + b) % b;
}
int get_ans(int x, int y) {
  if (x < y) {
    int use = x / __gcd(x, y);
    return y + mod(use - 1, x);
  } else {
    int use = y / __gcd(x, y);
    return x + mod(use - 1, y);
  }
}

const int N = 2e5 + 5, INF = 1e9 + 1;

bool vis[N];
vector<int> adj[N];

vector<int> order;
void topdfs(int u) {
  vis[u] = true;
  for (int v : adj[u]) {
    if (!vis[v]) topdfs(v);
  }
  order.push_back(u);
}

int32_t main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  
  int t, x1 = 0, y1 = 0;
  cin >> t;
  
  for (int test = 0; test < t; ++test) {
    int x, y;
    cin >> x >> y;
    if (test == 0) {
      x1 = x; y1 = y;
    }
    
    int len = get_ans(x, y) - 1;
    
    cout << len << " ";
  }
  cout << endl;
  
  int x = x1, y = y1;
  int len = get_ans(x, y) -1;
  
  for (int i = 0; i <= len; ++i) {
    if (i + x <= len) adj[i].push_back(i + x);
    if (i - y >= 0) adj[i].push_back(i - y);
  }

  for (int i = 0; i <= len; ++i) {
    if (!vis[i]) topdfs(i);
  }
  reverse(order.begin(), order.end());
  
  vector<int> val(len + 1);
  for (int u : order) {
    for (int v : adj[u]) {
      val[v] = max(val[v], val[u] + 1);
    }
  }
  
  for (int i = len; i >= 0; --i) val[i] -= val[0];
  assert(val[0] == 0);
  for (int i = len; i >= 1; --i) val[i] -= val[i - 1];
  for (int i = 1; i <= len; ++i) cout << val[i] << " ";
}
