#include <bits/stdc++.h>
#define int long long

using namespace std;

const int MAXN=1e5+5;

struct edge
{
    int u, v;
    int c;
};

bool cmp(edge a, edge b)
{
    return a.c < b.c;
}

vector<edge> much;
int n, q, m;

struct DSU
{
    int parent[MAXN];
    int sizes[MAXN];

    void init()
    {
        for(int i=1; i<=n; i++)
            parent[i]=i, sizes[i]=1;
    }

    int find(int u)
    {
        if(u == parent[u])
            return u;
        return parent[u]=find(parent[u]);
    }

    void unite(int u, int v)
    {
        u=find(u);
        v=find(v);
        if(u == v) // nu cred ca se intampla dar anyway
            return;
        // adaug v la u
        if(sizes[v] > sizes[u])
            swap(u, v);
        sizes[u]+=sizes[v];
        parent[v]=u;
    }

    int cmps(int u)
    {
        return sizes[parent[u]];
    }
};

int vals[MAXN];
int sussy[MAXN];
int sp[MAXN];

map<int, bool> amongus;

int getp(int c) // pozitita lui c in vals
{
    int st=-1, dr=m+1;
    while(st+1 < dr)
    {
        int mid=(st+dr)/2;
        if(vals[mid] >= c)
            dr=mid;
        else
            st=mid;
    }
    return dr;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>q;
    int u, v, c;
    for(int i=1; i<n; i++)
    {
        cin>>u>>v>>c;
        much.push_back({u, v, c});
        amongus[c]=true;
    }
    for(auto it:amongus)
    {
        vals[++m]=it.first;
    }
    sort(much.begin(), much.end(), cmp);
    DSU dsu;
    dsu.init();
    for(auto [u, v, c]:much)
    {
        //cout<<u<<' '<<v<<' '<<c<<' '<<dsu.cmps(u)<<' '<<dsu.cmps(v)<<'\n';
        sussy[getp(c)]+=dsu.cmps(u)*dsu.cmps(v);
        dsu.unite(u, v);
    }
    // while(q--)
    // {
    //     cin>>u>>u;
    // }
    // return 0;
    for(int i=1; i<=m+1; i++)
    {
        //cout<<sussy[i]<<'\n';
        sussy[i]*=vals[i];
        sp[i]=sussy[i]+sp[i-1];
    }
    int l, r;
    while(q--)
    {
        cin>>l>>r;
        //cout<<getp(r)<<' '<<getp(l)<<'\n';
        cout<<sp[getp(r)]-sp[getp(l-1)]<<'\n';
    }
    return 0;
}

/*
3 2
1 2 1
2 3 3
1 2
1 3

3 2
1 2 1
2 3 3
1 1
3 3
*/
