#include <bits/stdc++.h>

using namespace std;

using ll = long long;
const int MAXN = 400228;
int pref[MAXN], nxt1[MAXN], nxt2[MAXN];
int anc[20][MAXN];
int n, q, g;
string s;

int get(int x, int l) {
    int res = 0;
    for (int j = 19; j >= 0; j--) {
        if (anc[j][x] <= l) {
            res += (1 << j);
            x = anc[j][x];
        }
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> q >> g >> s;
    s = "#" + s;
    for (int i = 1; i <= 2 * n; i++) {
        pref[i] = pref[i - 1] + (s[i] == '(' ? +1 : -1);
    }

    map<int, int> last;
    for (int i = 2 * n; i >= 0; i--) {
        nxt1[i] = last[pref[i] - 1];
        nxt2[i] = last[pref[i] - 2];
        last[pref[i]] = i;
    }
    for (int i = 0; i <= 2 * n; i++) {
        if (nxt1[i] == 0) {
            nxt1[i] = 2 * n + 1;
        }
        if (nxt2[i] == 0) {
            nxt2[i] = 2 * n + 1;
        }
    }
    nxt2[2 * n + 1] = 2 * n + 1;
    for (int i = 0; i <= 2 * n + 1; i++) {
        anc[0][i] = nxt2[i];
    }
    for (int i = 1; i < 20; i++) {
        for (int j = 1; j <= 2 * n + 1; j++) {
            anc[i][j] = anc[i - 1][anc[i - 1][j]];
        }
    }

    while (q--) {
        int l, r;
        cin >> l >> r;
        int res = 0, delta = -pref[l - 1], old = -1;
        int x = nxt1[l - 1];
        if (x <= r) {
            res++;
            res += get(x, r);
        }
        // while (x <= r) {
        //     res++;
        //     x = nxt2[x];
        // }
        delta += 2 * res;
        res += (pref[r] + delta) / 2;
        cout << res / 2 << '\n';
    }
    return 0;
}
/*
5 1 6
()))(()(()
1 10
*/
