#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#define mp make_pair

using namespace std;

const int nmax = 100005;

struct noduri{
int vecin, c;
};
int cost[nmax], fr[nmax], n, q, maxi;
vector<noduri> a[nmax];
map<long long, long long> nr;

static void Dfs(int nod)
{
    fr[nod] = 1;
    for(auto x : a[nod])
        if(!fr[x.vecin])
        {
            cost[x.vecin] = max(cost[nod], x.c);
            Dfs(x.vecin);
        }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> q;
    for(int i = 1; i < n; i ++)
    {
        int x, y, c;
        cin >> x >> y >> c;
        a[x].push_back({y, c});
        a[y].push_back({x, c});
        maxi = max(maxi, c);
    }

    for(int p = 1; p <= n; p ++)
    {
        Dfs(p);
        for(int j = p + 1; j <= n; j ++)
            nr[cost[j]] ++;

        for(int j = 1; j <= n; j ++)
            cost[j] = fr[j] = 0;
    }

    for(int i = 1; i <= maxi; i ++)
    {
        nr[i] *= i;
        nr[i] += nr[i - 1];
    }

    for(int i = 1; i <= q; i ++)
    {
        int x, y;
        cin >> x >> y;
        if(y < x)
            swap(x, y);
        if(y > maxi)
            y = maxi;

        cout << nr[y] - nr[x - 1] << '\n';
    }
    return 0;
}
