#include <bits/stdc++.h>
#define debug(x) cerr << #x << " " << x << "\n"
#define debugs(x) cerr << #x << " " << x << " "
#define int long long

using namespace std;

struct edge
{
    int a;
    int b;
    int cost;
};

bool cmp(edge a, edge b)
{
    return a.cost<b.cost;
}

vector<edge> edges;
unordered_map<int,int> normcost;
vector<int> vals;

int indice(int a)
{
    return upper_bound(vals.begin(),vals.end(),a)-vals.begin()-1;
}

int root[100001];
int sz[100001];
int biggest[100001];
int roads[100001];
int total;

int searchset(int a)
{
    if (a==root[a])
    return a;
    root[a]=searchset(root[a]);
    return root[a];
}

void unite(int a, int b)
{
    a=searchset(a);
    b=searchset(b);
    if (a==b)
        return;
    if (sz[a]<=sz[b])
    {
        root[b]=a;
        sz[a]+=sz[b];
        sz[b]=sz[a];
    }
    else
    {
        root[a]=b;
        sz[b]+=sz[a];
        sz[a]=sz[b];
    }
}

void deletecontrib(int a)
{
     a=searchset(a);
     total-=(((sz[a]-1)*sz[a])/2)*biggest[a];
}

void activate(edge lol)
{
    int of,sza,szb;
    sza=sz[searchset(lol.a)];
    szb=sz[searchset(lol.b)];
    unite(lol.a,lol.b);
    of=searchset(lol.a);
    biggest[of]=lol.cost;
    total+=(sza*szb)*biggest[of];
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n,q,u,v,i,c,val,l,r;
    cin >> n >> q;
    for (i=1;i<=n-1;i++)
    {
         cin >> u >> v >> c;
         edges.push_back({u,v,c});
    }
    sort(edges.begin(),edges.end(),cmp);
    val=0;
    vals.push_back(0);
    for (i=0;i<edges.size();i++)
    {
         if (i==0 || edges[i].cost!=edges[i-1].cost)
         {
             val++;
             vals.push_back(edges[i].cost);
         }
         normcost[edges[i].cost]=val;
    }
    for (i=1;i<=n;i++)
    {
         root[i]=i;
         sz[i]=1;
    }
    total=0;
    for (auto x : edges)
    {
         activate(x);
         roads[normcost[x.cost]]=total;
    }
    for (i=1;i<=q;i++)
    {
         cin >> l >> r;
         l=indice(l-1);///direct pt rasp
         r=indice(r);
         cout << roads[r]-roads[l] << "\n";
    }
    return 0;
}
