#include <bits/stdc++.h>
using namespace std;

#define MAXN 1000
#define INF 2000000000

int nvec[MAXN];
char vis[MAXN];
vector<int> adj[MAXN];
vector<int> g[MAXN];

int cnt;
int v[MAXN * MAXN + 1];

void dfs(int nod, int mx) {
  int i;

  if(mx > -1) {
    v[cnt++] = mx;
  }

  vis[nod] = 1;

  for(i = 0; i < nvec[nod]; i++)
    if(!vis[adj[nod][i]])
      dfs(adj[nod][i], max(mx, g[nod][i]));
}

int main() {
  int n, q, i, j, i1, w, a, b, rez;

  scanf("%d%d", &n, &q);
  for(i = 0; i < n - 1; i++) {
    scanf("%d%d%d", &a, &b, &w);
    a--;
    b--;

    adj[a].push_back(b);
    adj[b].push_back(a);
    g[a].push_back(w);
    g[b].push_back(w);
    nvec[a]++;
    nvec[b]++;
  }

  cnt = 0;
  for(i = 0; i < n; i++) {
    for(j = 0; j < n; j++)
      vis[j] = 0;
    dfs(i, -1);
  }

  sort(v, v + cnt);
  v[cnt] = INF;

  for(i = 0; i < q; i++) {
    scanf("%d%d", &a, &b);
    i1 = 0;
    while(v[i1] < a) {
      i1++;
    }
    rez = 0;
    while(v[i1] <= b) {
      rez += v[i1];
      i1++;
    }
    printf("%d\n", rez / 2);
  }

  return 0;
}
