#include <bits/stdc++.h>

using namespace std;

#define pb push_back
using ll=long long;
const int MAXN=2e3;

struct node{
    int u, w;
};

vector<node> vec[MAXN+1];
map<int, int> mp;
int viz[MAXN+1];
int x;

void dfs(int p, int maxim){
    for(auto e : vec[p]){
        mp[max(maxim, e.w)]++;
        if(!viz[e.u]){
            viz[e.u]=1;
            dfs(e.u, max(maxim, e.w));
        }
    }
}

int main()
{
    int n, q;
    cin>>n>>q;
    for(int i=0; i<n-1; i++){
        int v, u, x;
        cin>>u>>v>>x;
        vec[v].pb({u, x});
        vec[u].pb({v, x});
    }
    for(int i=1; i<=n; i++){
        x=i;
        viz[i]=1;
        dfs(i, 0);
        for(int j=0; j<=n; j++)
            viz[j]=0;
    }
    for(int i=0; i<q; i++){
        int l, r;
        cin>>l>>r;
        ll ans=0;
        for(auto e : mp){
            if(e.first>=l && e.first<=r)
                ans+=1LL*e.first*e.second;
        }
        cout<<ans/4<<"\n";
    }
    return 0;
}
