/*
     _      _       _ 
    | | ___| | __ _| |
 _  | |/ _ \ |/ _` | |
| |_| |  __/ | (_| | |
 \___/ \___|_|\__,_|_|
  
*/
#include <bits/stdc++.h>

using namespace std;
  
// #define int long long
  
const int N = 1e4;
const int md = 1e9 + 7;
const int INF = 1e9;

int32_t main(int32_t argc, char *argv[]) {
  ios::sync_with_stdio(false); cin.tie(nullptr);
  
  int T = 1;
  // cin >> T;
  while (T--) {
    int n, q, mx = 0;
    cin >> n >> q;
    vector<vector<int>> a(n + 1, vector<int> (n + 1));
    vector<vector<pair<int, int>>> adj(n + 1);
    for (int i = 0; i < n - 1; i++) {
      int u, v, w;
      cin >> u >> v >> w;
      adj[u].push_back({v, w});
      adj[v].push_back({u, w});
      mx = max(mx, w);
    }
    vector<int> dist(n + 1);
    for (int i = 1; i <= n; i++) {
      queue<pair<int, int>> q;
      vector<bool> visited(n + 1);
      visited[i] = 1;
      q.push({i, 0});
      while (!q.empty()) {
        auto &[u, w] = q.front();
        if (!a[i][u] && !a[u][i]) {
          dist[w]++;
          a[u][i] = 1;
        }
        q.pop();
        for (auto &[v, w1] : adj[u])
          if (!visited[v]) {
            q.push({v, max(w, w1)});
            visited[v] = 1;
          }
      }
    }
    vector<int> pref(N);
    for (int i = 1; i <= n; i++)
      pref[i] = pref[i - 1] + (dist[i] * i);
    while (q--) {
      int l, r;
      cin >> l >> r;
      cout << pref[min(mx, r)] - pref[l - 1] << '\n';
    }
  }

  return 0;
}