/*
     _      _       _ 
    | | ___| | __ _| |
 _  | |/ _ \ |/ _` | |
| |_| |  __/ | (_| | |
 \___/ \___|_|\__,_|_|
  
*/
#include <bits/stdc++.h>

using namespace std;
  
// #define int long long
  
const int N = 1e4;
const int md = 1e9 + 7;
const int INF = 1e9;

int32_t main(int32_t argc, char *argv[]) {
  ios::sync_with_stdio(false); cin.tie(nullptr);
  
  int T = 1;
  // cin >> T;
  while (T--) {
    int n, q, mx = 0;
    cin >> n >> q;
    map<int, int> mp;
    vector<int> b;
    vector<vector<int>> a(n + 1, vector<int> (n + 1));
    vector<vector<pair<int, int>>> adj(n + 1);
    for (int i = 0; i < n - 1; i++) {
      int u, v, w;
      cin >> u >> v >> w;
      adj[u].push_back({v, w});
      adj[v].push_back({u, w});
      if (!mp[w])
        b.push_back(w);
      mp[w] = 1;
    }
    sort(b.begin(), b.end());
    for (int i = 0; i < (int) size(b); i++)
      mp[b[i]] = i + 1;
    vector<int> dist(n + 1);
    for (int i = 1; i <= n; i++) {
      queue<pair<int, int>> q;
      vector<bool> visited(n + 1);
      visited[i] = 1;
      q.push({i, 0});
      while (!q.empty()) {
        auto &[u, w] = q.front();
        if (!a[i][u] && !a[u][i]) {
          dist[mp[w]]++;
          a[u][i] = 1;
        }
        q.pop();
        for (auto &[v, w1] : adj[u])
          if (!visited[v]) {
            q.push({v, max(w, w1)});
            visited[v] = 1;
          }
      }
    }
    vector<int> pref(N);
    for (int i = 1; i <= n + 1; i++) {
      if ((int) size(b) - i >= 0)
        pref[i] = pref[i - 1] + (dist[mp[b[i - 1]]] * b[i - 1]);
      else
        pref[i] = pref[i - 1];
    }
    for (int i = 0; i <= n - 1; i++)
      cout << pref[i] << " ";
    cout << '\n';
    while (q--) {
      int l, r;
      cin >> l >> r;
      int l1 = lower_bound(b.begin(), b.end(), l) - b.begin();
      if ((l1 == (int) size(b)) && b[l1] > l) l1--;
      l1++;
      int r1 = lower_bound(b.begin(), b.end(), r) - b.begin();
      if ((r1 == (int) size(b)) && b[r1] > r) r1--;
      r1++;
      cout << pref[r1] - pref[l1 - 1] << '\n';
    }
  }

  return 0;
}